subroutine wallstress_dns(txz,tyz)
use types,only:rprec
use param,only:ld,nx,ny,nz,nu_molec,z_i,u_star,dz
use sim_param,only:u,v
implicit none
real(kind=rprec),dimension(ld,ny,nz),intent(out)::txz,tyz
integer::jx,jy
      
do jy=1,ny
do jx=1,nx
   txz(jx,jy,1)=-nu_molec/(z_i*u_star)*u(jx,jy,1)/(0.5_rprec*dz)
   tyz(jx,jy,1)=-nu_molec/(z_i*u_star)*v(jx,jy,1)/(0.5_rprec*dz)
end do
end do
end subroutine wallstress_dns

subroutine rmsdiv(rms, du, dv, dw)
! actually, this is NOT the rms divergence of velocity, its like an
! l_1 norm or something.
use types,only:rprec
use param,only:ld,nx,ny,nz
implicit none
integer::jx,jy,jz
real(kind=rprec),dimension(ld,ny,nz)::du,dv,dw
real(kind=rprec)::rms
rms=0._rprec
do jz=1,nz-1
do jy=1,ny
do jx=1,nx
   rms=rms+abs(du(jx,jy,jz)+dv(jx,jy,jz)+dw(jx,jy,jz))
end do
end do
end do
rms=rms/(nx*ny*(nz-1))
end subroutine rmsdiv

module io
use types,only:rprec
use param,only:ld,nx,ny,nz,jx_s
implicit none
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer,parameter::base=100000,nwrite=1000
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
integer,parameter::jx_pls=jx_s+4,jx_ple=nx/16*9,width=int(ny/5)
integer,parameter::jy_pls=ny/2-width,jy_ple=ny/2+width+1
real(kind=rprec),dimension(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)::&
     mean_u,mean_v,mean_u2,mean_v2,mean_dudx
real(kind=rprec),dimension(nx,ny,nz)::lam2
contains

subroutine openfiles()
use sim_param,only:path
! note: this ain't in the 'output' subdir
open(64,file=path//'output/velspec.out')
open(78,file=path//'output/cs2_lag_planar.out')
open(79,file=path//'output/cs2_lag.out')
open(60,file=path//'output/cs2_2Del_planar.out')
open(61,file=path//'output/cs2_2Del.out')
open(62,file=path//'output/Beta_planar.out')
open(63,file=path//'output/Beta.out')

open(65,file=path//'output/FLM_vertprof.out')
open(66,file=path//'output/FMM_vertprof.out')
open(67,file=path//'output/LM_vertprof.out')
open(68,file=path//'output/MM_vertprof.out')
open(69,file=path//'output/nondim_u_vertprof.out')

open(45,file=path//'output/FQN_vertprof.out')
open(46,file=path//'output/FNN_vertprof.out')
open(47,file=path//'output/QN_vertprof.out')
open(48,file=path//'output/NN_vertprof.out')
 
open(80,file=path//'output/explode.out')

open(81,file=path//'output/clip.out')

open(90,file=path//'output/LMplan.out')
open(91,file=path//'output/MMplan.out')
open(92,file=path//'output/FLMplan.out')
open(93,file=path//'output/FMMplan.out')
open(94,file=path//'output/LMoverMM.out')

open(70,file=path//'output/QNplan.out')
open(71,file=path//'output/NNplan.out')
open(72,file=path//'output/FQNplan.out')
open(73,file=path//'output/FNNplan.out')
open(74,file=path//'output/QNoverNN.out')
 
open(98,file=path//'output/cs2plan-smallt.out')
open(96,file=path//'output/rmsprofiles.out')
open(97,file=path//'output/tawprofiles.out')

open(95,file=path//'output/mean_u.out',form='unformatted')
write(95)jx_pls,jx_ple,jy_pls,jy_ple
open(195,file=path//'output/lambda2.out',form='unformatted')
write(195)nx,ny,nz
end subroutine openfiles

!subroutine initial
!end subroutine initial

subroutine output_loop(jt,txx,txy,txz,tyy,tyz,tzz)
use param,only:output,dt,c_count
use sim_param,only:path,u,v,w,dudz,dudx,p,&
     RHSx,RHSy,RHSz
use sgsmodule,only:Cs_opt2,Cs_opt2_avg
implicit none
integer,intent(in)::jt
real(kind=rprec),dimension(ld,ny,nz)::txx,txy,txz,tyy,tyz,tzz
real(kind=rprec),dimension(nz)::u_ndim
character(len=20)::req
character(len=24)::fname
if (mod(jt,100) == 0) then
   u_ndim=sum(sum(dudz,DIM=1),DIM=1)/ny/nx
   write(69,5130) real(jt*dt),real(u_ndim)
end if
5130   format(2100(E14.5))
if (output.and.(mod(jt,base) == 0)) then
! checkpoint
!TS   open(1,file=path//'request')
!TS   read(1,*) req
!TS   close(1)
!TS   if (req.eq.'save') then
!TS      rewind (21)
!TS      write(21) u,v,w,RHSx,RHSy,RHSz,Cs_opt2
!TS   end if
! write out vel.out along the way
   if (mod(jt,base) == 0) then
      write(fname,'(A12,i5.5,A4)')path//'output/vel',jt,'.out'
      open(1,file=fname,form='unformatted')
      write(1) u,v,w,RHSx,RHSy,RHSz,Cs_opt2
      close(1)
      write(fname,'(A12,i5.5,A4)')path//'output/t13',jt,'.out'
      open(1,file=fname,form='unformatted')
      write(1) txz
      close(1)
   end if
end if
If (mod(jt,c_count)==0) then
   call avgslice (txx,txz,tyy,tyz,tzz,p,jt)
end if
Cs_opt2_avg(:,:,:)=Cs_opt2_avg(:,:,:)+Cs_opt2(:,:,:)/nwrite
!TS
mean_u(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=&
     mean_u(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)+&
     u(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)/nwrite
mean_u2(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=&
     mean_u2(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)+&
     u(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)**2/nwrite
mean_v(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=&
     mean_v(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)+&
     v(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)/nwrite
mean_v2(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=&
     mean_v2(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)+&
     v(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)**2/nwrite
mean_dudx(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=&
     mean_dudx(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)+&
     dudx(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)/nwrite
if (output) then
   if (mod(jt,nwrite)==0) then
      write(fname,'(A13,i5.5,A4)')path//'output/vel-',jt,'.out'
      open(21,file=fname,form='unformatted')
      write(21) real(u),real(v),real(w),real(Cs_opt2_avg),real(p)
      Cs_opt2_avg(:,:,:)=0._rprec
      close(21)
      write(95)real(mean_u),real(mean_u2),real(mean_v),real(mean_v2),real(mean_dudx)
      mean_u(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=0_rprec
      mean_u2(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=0_rprec
      mean_v(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=0_rprec
      mean_v2(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=0_rprec
      mean_dudx(jx_pls:jx_ple,jy_pls:jy_ple,2:nz-1)=0_rprec
   end if
   if(jt.gt.1000.and.mod(jt,nwrite/2).eq.0)then
      call lambda2()
      write(195)real(lam2)
   endif
end if
end subroutine output_loop

subroutine avgslice (txx,txz,tyy,tyz,tzz,p,jt)
use sim_param,only:path,u,v,w
use param,only:dz,p_count,c_count
use sgsmodule,only:Cs_opt2
implicit none
integer::i,j,k, jt
real(kind=rprec),dimension(ld,ny,nz)::txx,txz,tyy,tyz,tzz,p
real(kind=rprec),dimension(nx,nz)::ap,au,av,aw,p2,u2,v2,w2,auw,avw,acs
real(kind=rprec),dimension(nx,nz)::atxx,atxz,atyy,atyz,atzz
real(kind=rprec)::tu1,tv1,tw1,ttxx,ttxz,ttyy,ttyz,ttzz,&
     tu2,tv2,tw2,tp1,tp2,tuw,tvw,tCs,fr, arg1, arg2     

fr=(1._rprec/real(p_count,kind=rprec))*real(c_count,kind=rprec)
do k=1,Nz
do i=1,Nx
   tu1=0._rprec
   tv1=0._rprec
   tw1=0._rprec
   tp1=0._rprec
   ttxx=0._rprec
   ttxz=0._rprec
   ttyy=0._rprec
   ttyz=0._rprec
   ttzz=0._rprec
   tu2=0._rprec
   tv2=0._rprec
   tw2=0._rprec
   tp2=0._rprec
   tuw=0._rprec
   tvw=0._rprec
   tCs=0._rprec
   do j=1,Ny
      tu1=tu1+u(i,j,k)
      tv1=tv1+v(i,j,k)
      tw1=tw1+w(i,j,k)
      tp1=tp1+p(i,j,k)
      ttxx=ttxx+txx(i,j,k)
      ttxz=ttxz+txz(i,j,k)
      ttyy=ttyy+tyy(i,j,k)
      ttyz=ttyz+tyz(i,j,k)
      ttzz=ttzz+tzz(i,j,k)
      tu2=tu2+u(i,j,k)*u(i,j,k)
      tv2=tv2+v(i,j,k)*v(i,j,k)
      tw2=tw2+w(i,j,k)*w(i,j,k)
      tp2=tp2+p(i,j,k)*p(i,j,k)
      tCs=tCs+Cs_opt2(i,j,k)
      if (k.gt.1) then
         arg1=(u(i,j,k)+u(i,j,k-1))/2.
         arg2=(v(i,j,k)+v(i,j,k-1))/2.
      else
         arg1=0._rprec
         arg2=0._rprec
      end if
      tuw=tuw+w(i,j,k)*arg1
      tvw=tvw+w(i,j,k)*arg2
   end do
   au(i,k)=au(i,k)+(fr)*tu1/Ny
   av(i,k)=av(i,k)+(fr)*tv1/Ny
   aw(i,k)=aw(i,k)+(fr)*tw1/Ny
   ap(i,k)=ap(i,k)+(fr)*tp1/Ny
   u2(i,k)=u2(i,k)+(fr)*tu2/Ny
   v2(i,k)=v2(i,k)+(fr)*tv2/Ny
   w2(i,k)=w2(i,k)+(fr)*tw2/Ny
   atxx(i,k)=atxx(i,k)+(fr)*ttxx/Ny
   atxz(i,k)=atxz(i,k)+(fr)*ttxz/Ny
   atyy(i,k)=atyy(i,k)+(fr)*ttyy/Ny
   atyz(i,k)=atyz(i,k)+(fr)*ttyz/Ny
   atzz(i,k)=atzz(i,k)+(fr)*ttzz/Ny
   p2(i,k)=p2(i,k)+fr*tp2/Ny
   aCs(i,k)=aCs(i,k)+(fr)*tCs/Ny
   auw(i,k)=auw(i,k)+(fr)*tuw/Ny
   avw(i,k)=avw(i,k)+(fr)*tvw/Ny
end do
end do

if (mod(jt,p_count)==0.and.jt.gt.2000) then
   open(20,file=path//'output/aver_u.out')
   open(19,file=path//'output/aver_v.out')
   open(22,file=path//'output/aver_w.out')
   open(23,file=path//'output/aver_p.out')
!	open(24,file=path//'output/aver_u2.out')
!	open(25,file=path//'output/aver_v2.out')
!	open(26,file=path//'output/aver_w2.out')
   open(27,file=path//'output/aver_txx.out')
   open(28,file=path//'output/aver_txz.out')
   open(29,file=path//'output/aver_tyy.out')
   open(30,file=path//'output/aver_tyz.out')
   open(31,file=path//'output/aver_tzz.out')
   !	open(32,file=path//'output/aver_p2.out')
   open(33,file=path//'output/aver_uw.out')
   open(34,file=path//'output/aver_vw.out')
   open(35,file=path//'output/aver_Cs2.out')
   do k=1,nz
      write(20,5168) real(jt*dz),(real(au(i,k)),i=1,nx)
      write(19,5168) real(jt*dz),(real(av(i,k)),i=1,nx)
      write(22,5168) real(jt*dz),(real(aw(i,k)),i=1,nx)
      write(23,5168) real(jt*dz),(real(ap(i,k)),i=1,nx)
!	write(24,5168) jt*dz,(u2(i,k),i=1,nx)
!	write(25,5168) jt*dz,(v2(i,k),i=1,nx)
!	write(26,5168) jt*dz,(w2(i,k),i=1,nx)
      write(27,5168) real(jt*dz),(real(atxx(i,k)),i=1,nx)
      write(28,5168) real(jt*dz),(real(atxz(i,k)),i=1,nx)
      write(29,5168) real(jt*dz),(real(atyy(i,k)),i=1,nx)
      write(30,5168) real(jt*dz),(real(atyz(i,k)),i=1,nx)
      write(31,5168) real(jt*dz),(real(atzz(i,k)),i=1,nx)
!	write(32,5168) jt*dz,(p2(i,k),i=1,nx)
      write(33,5168) real(jt*dz),(real(auw(i,k)),i=1,nx)
      write(34,5168) real(jt*dz),(real(avw(i,k)),i=1,nx)
      write(35,5168) real(jt*dz),(real(aCs(i,k)),i=1,nx)
   end do

   au=0._rprec
   av=0._rprec
   aw=0._rprec
   ap=0._rprec
   u2=0._rprec
   v2=0._rprec
   w2=0._rprec
   atxx=0._rprec
   atxz=0._rprec
   atyy=0._rprec
   atyz=0._rprec
   atzz=0._rprec
   p2=0._rprec
   auw=0._rprec
   avw=0._rprec
   aCs=0._rprec   
end if
 5168     format(1400(E14.5))
end subroutine avgslice

subroutine output_final(jt)
use types,only:rprec
use param,only:nsteps
use sim_param,only:u,v,w,usp,vsp,wsp,RHSx,RHSy,RHSz
use sgsmodule,only:Cs_opt2
use sgsmodule,only:F_LM,F_MM
implicit none
integer,intent(in)::jt
integer::jx,jy,jz

rewind(121)
write(121) u,v,w,RHSx,RHSy,RHSz,Cs_opt2,F_LM,F_MM

usp=0._rprec
vsp=0._rprec
wsp=0._rprec
if (jt .GT. (nsteps-100)) then
   usp=usp+u
   vsp=vsp+v
   wsp=wsp+w
end if

usp=usp/100._rprec
vsp=vsp/100._rprec
wsp=wsp/100._rprec

rewind(64)
do jz=1,Nz
do jy=1,Ny
do jx=1,Nx
   write (64,5167) usp(jx,jy,jz),vsp(jx,jy,jz),wsp(jx,jy,jz)
end do
end do
end do
5167  format (110(1x,e10.4))
end subroutine output_final

subroutine lambda2()
use types,only:rprec
use sim_param,only:u,v,w,&
     dudx,dudy,dudz,dvdx,dvdy,dvdz,dwdx,dwdy,dwdz
use param,only:dx,dy,dz
!TSreal(kind=rprec),dimension(nx)::dpdx,dpdy,dpdz,aeu,awu,anu,asu,afu,abu
!TSreal(kind=rprec)::fne,fnn,fnf,S11,S22,S33,S12,O12,S13,O13,S23,O23
real(kind=rprec)::S11,S22,S33,S12,O12,S13,O13,S23,O23,&
     ux,uy,uz,vx,vy,vz,wx,wy,wz
integer::jx,jy,jz
! following used for eispack call...
integer::neis,nmeis,matzeis,ierreis,iv1eis(3)
double precision,dimension(3,3)::aeis,zeis
double precision,dimension(3)::wreis,wieis,fv1eis
double precision::ave

! assignments for eispack call
neis=3
nmeis=3
matzeis=0
ierreis=0
!TSfne=1._rprec/dx
!TSfnn=1._rprec/dy
!TSfnf=1._rprec/dz
!TSprint*,fne,fnn,fnf
lam2=0._rprec

! at level z=dz/2.  (Where dudz and dvdz are on UVP nodes)
do jy=1,ny
do jx=1,nx              
   ux=dudx(jx,jy,1)  ! uvp-node
   uy=dudy(jx,jy,1)  ! uvp-node
   uz=dudz(jx,jy,1)  ! uvp-node
   vx=dvdx(jx,jy,1)  ! uvp-node
   vy=dvdy(jx,jy,1)  ! uvp-node
   vz=dvdz(jx,jy,1)  ! uvp-node 
! special case
   wx=0.5_rprec*(dwdx(jx,jy,1)+dwdx(jx,jy,2))  ! uvp-node
   wy=0.5_rprec*(dwdy(jx,jy,1)+dwdy(jx,jy,2))  ! uvp-node
   wz=dwdz(jx,jy,1)  ! uvp-node
   S11=ux          ! uvp-node
   S12=0.5_rprec*(uy+vx) ! uvp-node
! taken care of with wall stress routine
   S13=0.5_rprec*(uz+wx) ! uvp
   O12=0.5_rprec*(uy-vx) ! w-node
   O13=0.5_rprec*(uz-wx) ! w-node
   S22=vy          ! uvp-node
! taken care of with wall stress routine 
   S23=0.5_rprec*(vz+wy) ! uvp
   O23=0.5_rprec*(vz-wy) ! w-node
   S33=wz          ! uvp-node
   aeis(1,1)=s11*s11+s12*s12+s13*s13-O12*O12-O13*O13
   aeis(1,2)=s11*s12+s12*s22+s13*s23-O13*O23
   aeis(1,3)=s11*s13+s12*s23+s13*s33+O12*O23
   aeis(2,2)=s12*s12+s22*s22+s23*s23-O12*O12-O23*O23
   aeis(2,3)=s12*s13+s22*s23+s23*s33-O12*O13
   aeis(3,3)=s13*s13+s23*s23+s33*s33-O13*O13-O23*O23
   aeis(2,1)=aeis(1,2)
   aeis(3,1)=aeis(1,3)
   aeis(3,2)=aeis(2,3)
   call rg(nmeis,neis,aeis,wreis,wieis,matzeis,zeis,iv1eis,fv1eis,ierreis)
   if(wreis(1).ge.wreis(2).and.wreis(1).le.wreis(3)) then
      lam2(jx,jy,jz)=real(wreis(1),kind=rprec)
   elseif(wreis(2).ge.wreis(1).and.wreis(2).le.wreis(3)) then
      lam2(jx,jy,jz)=real(wreis(2),kind=rprec)
   else
      lam2(jx,jy,jz)=real(wreis(3),kind=rprec)
   endif
end do
end do

! calculate derivatives/strain on w-nodes
do jz=2,nz-1  
do jy=1,ny
do jx=1,nx              
   ux=0.5_rprec*(dudx(jx,jy,jz) + dudx(jx,jy,jz-1))  ! w-node
   uy=0.5_rprec*(dudy(jx,jy,jz) + dudy(jx,jy,jz-1))  ! w-node
   uz=dudz(jx,jy,jz)  ! w-node
   vx=0.5_rprec*(dvdx(jx,jy,jz) + dvdx(jx,jy,jz-1))  ! w-node
   vy=0.5_rprec*(dvdy(jx,jy,jz) + dvdy(jx,jy,jz-1))  ! w-node
   vz=dvdz(jx,jy,jz)  ! w-node
   wx=dwdx(jx,jy,jz)  ! w-node
   wy=dwdy(jx,jy,jz)  ! w-node
   wz=0.5_rprec*(dwdz(jx,jy,jz) + dwdz(jx,jy,jz-1))  ! w-node
   S11=ux          ! w-node
   S12=0.5_rprec*(uy+vx) ! w-node
   S13=0.5_rprec*(uz+wx) ! w-node
   O12=0.5_rprec*(uy-vx) ! w-node
   O13=0.5_rprec*(uz-wx) ! w-node
   S22=vy          ! w-node
   S23=0.5_rprec*(vz+wy) ! w-node
   O23=0.5_rprec*(vz-wy) ! w-node
   S33=wz          ! w-node
   aeis(1,1)=s11*s11+s12*s12+s13*s13-O12*O12-O13*O13
   aeis(1,2)=s11*s12+s12*s22+s13*s23-O13*O23
   aeis(1,3)=s11*s13+s12*s23+s13*s33+O12*O23
   aeis(2,2)=s12*s12+s22*s22+s23*s23-O12*O12-O23*O23
   aeis(2,3)=s12*s13+s22*s23+s23*s33-O12*O13
   aeis(3,3)=s13*s13+s23*s23+s33*s33-O13*O13-O23*O23
   aeis(2,1)=aeis(1,2)
   aeis(3,1)=aeis(1,3)
   aeis(3,2)=aeis(2,3)
   call rg(nmeis,neis,aeis,wreis,wieis,matzeis,zeis,iv1eis,fv1eis,ierreis)
   if(wreis(1).ge.wreis(2).and.wreis(1).le.wreis(3)) then
      lam2(jx,jy,jz)=real(wreis(1),kind=rprec)
   elseif(wreis(2).ge.wreis(1).and.wreis(2).le.wreis(3)) then
      lam2(jx,jy,jz)=real(wreis(2),kind=rprec)
   else
      lam2(jx,jy,jz)=real(wreis(3),kind=rprec)
   endif
end do
end do
end do

!do k=2,nz-1
!do j=2,ny-1
!do i=2,nx-1
!   dpdx(i) = u(i+1,j,k) - u(i-1,j,k)
!   dpdy(i) = u(i,j+1,k) - u(i,j-1,k)
!   dpdz(i) = u(i,j,k+1) - u(i,j,k-1)
!   aeu(i)  = v(i+1,j,k) - v(i-1,j,k)
!   awu(i)  = v(i,j+1,k) - v(i,j-1,k)
!   anu(i)  = v(i,j,k+1) - v(i,j,k-1)
!   asu(i)  = w(i+1,j,k) - w(i-1,j,k)
!   afu(i)  = w(i,j+1,k) - w(i,j-1,k)
!   abu(i)  = w(i,j,k+1) - w(i,j,k-1)

!   S11=fne*dpdx(i)
!   S22=fnn*awu(i)
!   S33=fnf*abu(i)
!   S12=0.5_rprec*(fnn*dpdy(i)+fne*aeu(i))
!   O12=0.5_rprec*(fnn*dpdy(i)-fne*aeu(i))
!   S13=0.5_rprec*(fnf*dpdz(i)+fne*asu(i))
!   O13=0.5_rprec*(fnf*dpdz(i)-fne*asu(i))
!   S23=0.5_rprec*(fnf*anu(i)+fnn*afu(i))
!   O23=0.5_rprec*(fnf*anu(i)-fnn*afu(i))
!   aeis(1,1)=s11*s11+s12*s12+s13*s13-O12*O12-O13*O13
!   aeis(1,2)=s11*s12+s12*s22+s13*s23-O13*O23
!   aeis(1,3)=s11*s13+s12*s23+s13*s33+O12*O23
!   aeis(2,2)=s12*s12+s22*s22+s23*s23-O12*O12-O23*O23
!   aeis(2,3)=s12*s13+s22*s23+s23*s33-O12*O13
!   aeis(3,3)=s13*s13+s23*s23+s33*s33-O13*O13-O23*O23
!   aeis(2,1)=aeis(1,2)
!   aeis(3,1)=aeis(1,3)
!   aeis(3,2)=aeis(2,3)
!   call rg(nmeis,neis,aeis,wreis,wieis,matzeis,zeis,iv1eis,fv1eis,ierreis)
!   if(wreis(1).ge.wreis(2).and.wreis(1).le.wreis(3)) then
!      lam2(i,j,k)=real(wreis(1),kind=rprec)
!   elseif(wreis(2).ge.wreis(1).and.wreis(2).le.wreis(3)) then
!      lam2(i,j,k)=real(wreis(2),kind=rprec)
!   else
!      lam2(i,j,k)=real(wreis(3),kind=rprec)
!   endif
!enddo
!enddo
!enddo
print*,'minmax',minval(lam2),maxval(lam2)
end subroutine lambda2
end module io

subroutine dealias2(u,u_big)
! puts back into small array
use types,only:rprec
use param,only:ld,ld_big,nx,ny,nz,nx2,ny2,dx,dy
use fft
implicit none
integer::jz
real(kind=rprec),dimension(ld,ny,nz),intent(in):: u
real(kind=rprec),dimension(ld_big,ny2,nz),intent(inout)::u_big
real(kind=rprec)::ignore_me,const

! normalize
const=1._rprec/(nx2*ny2)
u_big=const*u_big
! Loop through horizontal slices
do jz=1,nz
! perform forward FFT
   call rfftwnd_f77_one_real_to_complex(forw_big,u_big(:,:,jz),ignore_me)    
   call unpadd(u(:,:,jz),u_big(:,:,jz))
! Back to physical space
   call rfftwnd_f77_one_complex_to_real(back,u(:,:,jz),ignore_me)
end do

! sc: do we need this?
!.....Making filter circular !!!!!!!!!!!
!	call filt_da(uu)
!.......................................
end subroutine dealias2

module sim_param
use types,only:rprec
use param,only:ld,ny,nz
implicit none

public
character(*),parameter::path='./'
real(kind=rprec),dimension(ld,ny,nz)::u,v,w,usp,vsp,wsp,&
     dudx,dudy,dudz,dvdx,dvdy,dvdz,dwdx,dwdy,dwdz, &
     dpdx,dpdy,dpdz,&
     RHSx,RHSy,RHSz,RHSx_f,RHSy_f,RHSz_f
real(kind=rprec),dimension(ld,ny,0:nz)::p
end module sim_param

subroutine derivwall()
! calculates deriv at wall as suggested in Moeng '84'
use types,only:rprec
use param,only:vonk,dz,ld,nx,ny,nz
use sim_param,only:dudz,dvdz,u,v
use bottombc,only:zo,phi_m,psi_m
implicit none
integer::jx,jy, method
real(kind=rprec),dimension(nx,ny)::ustar,u_avg

!TS Remove the following line when obukhov.f is used
psi_m=0._rprec
phi_m=1._rprec

method = 1
if (method == 1) then
   u_avg(1:nx,1:ny)=sqrt(u(1:nx,1:ny,1)**2+v(1:nx,1:ny,1)**2)
!TS ADD for non-neutral case
   ustar=u_avg*vonK/(log((0.5_rprec*dz)/zo)-psi_m)
   do jy=1,ny
   do jx=1,nx
      !this is as in Moeng 84
      dudz(jx,jy,1)=ustar(jx,jy)/(0.5_rprec*dz*vonK)*u(jx,jy,1)/u_avg(jx,jy)&
!TS ADD for non-neutral case
           *phi_m(jx,jy)
! sc: i dont know if this is correct yet
      dvdz(jx,jy,1)=ustar(jx,jy)/(0.5_rprec*dz*vonK)*v(jx,jy,1)/u_avg(jx,jy)&
!TS ADD for non-neutral case
           *phi_m(jx,jy)
      dudz(jx,jy,1)=merge(0._rprec,dudz(jx,jy,1),u(jx,jy,1).eq.0._rprec)
      dvdz(jx,jy,1)=merge(0._rprec,dvdz(jx,jy,1),v(jx,jy,1).eq.0._rprec)
   end do
   end do
elseif (method == 2) then
   dudz(1:nx,:,1)=dudz(1:nx,:,2)*2._rprec
   dvdz(1:nx,:,1)=dvdz(1:nx,:,2)/2._rprec
end if
end subroutine derivwall

module topbc
use types,only:rprec
use param,only:nz
implicit none
real(kind=rprec),dimension(nz)::sponge

contains
subroutine setsponge()
use param,only:u_star,z_i
implicit none
real(kind=rprec)::factor
integer::k
! sets relaxation term to vertical momentum equation in top quarter
! of domain, relaxation timescale on top is 50s with a factor of 5 if we
! had Nz=40 for the layers 40...31, Nieuwstadt et al. 1991, turbulent shear 
! flows

sponge=0._rprec
factor=9._rprec/dble(nz-3*nz/4+1)
sponge(nz)=z_i/(50._rprec*u_star)
do k=nz-1,3*nz/4+1,-1
   sponge(k)=sponge(k+1)/5._rprec**factor
end do
end subroutine setsponge
end module topbc

subroutine ddz_uv(dfdz, f)
! first derivative in z direction for boundary layer (2nd order numerics)
use types,only:rprec
use param,only:ld,nx,ny,nz,dz
implicit none
real(kind=rprec),dimension(ld,ny,nz),intent(in)::f
real(kind=rprec),dimension(ld,ny,nz),intent(inout)::dfdz
real(kind=rprec)::const
integer::jx,jy,jz


! see derivwall
const=1._rprec/dz
do jz=2,nz-1
do jy=1,ny
do jx=1,nx    
   dfdz(jx,jy,jz)=const*(f(jx,jy,jz)-f(jx,jy,jz-1))
end do
end do
end do
dfdz(:,:,nz)=0._rprec
end subroutine ddz_uv

subroutine ic()
!...Log profile that is modified to flatten at z=z_i
use types,only:rprec
!only:ld,nx,ny,nz,z_i,wt_s,num_patch,zo1,zo2,dz,vonk,s_flag,u_star,theta_s1
use param
use sim_param,only:u,v,w
use bottombc,only:num_patch,zo1,zo2,theta_s1
implicit none
!      real*8 theta(ld,ny,nz),q(ld,ny,nz)
real(kind=rprec),dimension(nz)::ubar
real(kind=rprec)::rms, noise, arg, arg2
real(kind=rprec)::z,zo_avg,w_star,T_star,q_star,ran3
integer::jx,jy,jz,seed

w_star=(9.81_rprec/theta_s1*wt_s*z_i)**(1._rprec/3._rprec)
!      T_star=wt_s/w_star
!      q_star=T_star
seed=-80

! included by jan
if (num_patch.gt.1) then
   zo_avg=(zo1+zo2)/2._rprec
else
   zo_avg=zo1
end if

print *,'Modified Log Profile for IC'
do jz=1,nz
   z=(jz-.5_rprec)*dz*z_i
! IC in equilibrium with rough surface (rough dominates in effective zo)
   arg2=z/zo_avg
   arg=(1._rprec/vonk)*log(arg2)!-1./(2.*vonk*z_i*z_i)*z*z
   ubar(jz)=arg
! sc: I changed around some parenthesis here
   if ((s_flag).and.(z.gt.(.4_rprec*z_i))) ubar(jz)=ubar(jz-1)
end do
do jz=1,nz
   print *,'k, ubar:',jz,ubar(jz)
end do

rms = 3._rprec
do jz=1,nz
do jy=1,ny
do jx=1,nx
!...Ran3 returns uniform RV between 0 and 1. (sigma_rv=0.289)
!...Taking std dev of vel as 1 at all heights
   z=(real(jz)-.5_rprec)*dz*z_i
   if (z.le.z_i) then
      noise=rms/.289_rprec*(ran3(seed)-.5_rprec)
      u(jx,jy,jz)=noise*(1._rprec-z/z_i)*w_star/u_star+ubar(jz)
      noise=rms/.289_rprec*(ran3(seed)-0.5_rprec)
      v(jx,jy,jz)=noise*(1._rprec-z/z_i)*w_star/u_star !noise
      noise=rms/.289_rprec*(ran3(seed)-.5_rprec)
      w(jx,jy,jz)=noise*(1._rprec-z/z_i)*w_star/u_star
!	      theta(jx,jy,jz)=(theta_s1+10.*noise*(1-z/z_i)*T_star)/T_scale
!	      q(jx,jy,jz)=q_mix+50.*noise*(1-z/z_i)*q_star
   else
      noise=rms/.289_rprec*(ran3(seed)-.5_rprec)
      u(jx,jy,jz)=noise*w_star/u_star*.01_rprec+ubar(jz)
      noise=rms/.289_rprec*(ran3(seed)-0.5_rprec)
      v(jx,jy,jz)=noise*w_star/u_star*.01_rprec
      noise=rms/.289_rprec*(ran3(seed)-0.5_rprec)
      w(jx,jy,jz)=noise*w_star/u_star*.01_rprec
      noise=ran3(seed)-.5_rprec
! is this right for the neutral case? can't we put just theta=0., q=0. ?
!	      theta(jx,jy,jz)=(theta_s1+(z-z_i)*0.003)/T_scale
!	      noise=ran3(seed)-0.5
!	      q(jx,jy,jz)=q_mix+10.*noise*(1-z/z_i)*q_star
   end if
end do
end do
end do

!...BC for W
do jy=1,ny
do jx=1,nx
   w(jx,jy,1)=0._rprec
   w(jx,jy,nz)=0._rprec
end do
end do

!...BC for U, V
do jy=1,ny
do jx=1,nx
   u(jx,jy,nz)=u(jx,jy,nz-1)
   v(jx,jy,nz)=v(jx,jy,nz-1)
end do
end do
end subroutine ic

! this is the w-node version
subroutine std_dynamic(Cs_opt2,S11,S12,S13,S22,S23,S33)
! standard dynamic model to calculate the Smagorinsky coefficient
! this is done layer-by-layer to save memory
! everything is done to be on uv-nodes
! -note: we need to calculate |S| here, too.
! stuff is done on uv-nodes
! can save more mem if necessary. mem requirement ~ n^2, not n^3
use types,only:rprec
use param,only:ld,ny,nz,dx,dy,dz
use sim_param,only:u,v,w
use test_filtermodule
implicit none
integer :: jz, jt
real(kind=rprec),dimension(ld,ny,nz),intent(in)::S11,S12,S13,S22,S23,S33
real(kind=rprec), dimension(nz),intent(inout):: Cs_opt2
real(kind=rprec), dimension(ld,ny)::L11,L12,L13,L22,L23,L33,u_pr,&
     M11,M12,M13,M22,M23,M33
real(kind=rprec), dimension(ld,ny) :: S_bar,S11_bar,S12_bar,&
     S13_bar,S22_bar,S23_bar,S33_bar,S_S11_bar, S_S12_bar,&
     S_S13_bar, S_S22_bar, S_S23_bar, S_S33_bar
real(kind=rprec), dimension(ld,ny) :: u_bar,v_bar,w_bar
real(kind=rprec), dimension(ld,ny) :: S
real(kind=rprec) :: delta, const,u_av,u_rms

delta = filter_size*(dx*dy*dz)**(1._rprec/3._rprec)

do jz=1,nz
! using L_ij as temp storage here
!!! watch the 0.25's:  recall w = c*z^2 close to wall, so get 0.25
   if (jz == 1) then  ! put on uvp-nodes
      L11(:,:) = u(:,:,1)*u(:,:,1)  ! uv-node
      L12(:,:) = u(:,:,1)*v(:,:,1)  ! uv-node
      L13(:,:) = u(:,:,1)*0.25_rprec*w(:,:,2)  ! parabolic interp.
      L22(:,:) = v(:,:,1)*v(:,:,1)  ! uv-node
      L23(:,:) = v(:,:,jz)*0.25_rprec*w(:,:,2)  ! uv-node
      L33(:,:) = (0.25_rprec*w(:,:,2))**2  ! uv-node
      u_bar(:,:) = u(:,:,1)
      v_bar(:,:) = v(:,:,1)
      w_bar(:,:) = 0.25_rprec*w(:,:,2)
   else  ! w-nodes
      L11(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*&
           0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))
      L12(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*&
           0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      L13(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*w(:,:,jz)
      L22(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))*&
           0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      L23(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))*w(:,:,jz)
      L33(:,:) = w(:,:,jz)*w(:,:,jz)
      u_bar(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))
      v_bar(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      w_bar(:,:) = w(:,:,jz)
   end if
   call test_filter(u_bar,G_test)
   call test_filter(v_bar,G_test)
   call test_filter(w_bar,G_test)
   call test_filter(L11,G_test)  ! in-place filtering
   L11 = L11 - u_bar*u_bar
   call test_filter(L12,G_test)
   L12 = L12 - u_bar*v_bar
   call test_filter(L13,G_test)
   L13 = L13 - u_bar*w_bar
   call test_filter(L22,G_test)
   L22 = L22 - v_bar*v_bar
   call test_filter(L23,G_test)
   L23 = L23 - v_bar*w_bar
   call test_filter(L33,G_test)
   L33 = L33 - w_bar*w_bar
!        print*, u_bar/u(:,:,jz)
!        print*, L23(5,5)

! calculate |S|
   S(:,:) = sqrt(2._rprec*(S11(:,:,jz)**2 + S22(:,:,jz)**2 + &
        S33(:,:,jz)**2 + 2._rprec*(S12(:,:,jz)**2 + &
        S13(:,:,jz)**2 + S23(:,:,jz)**2)))

! S_ij already on w-nodes
   S11_bar(:,:) = S11(:,:,jz)  
   S12_bar(:,:) = S12(:,:,jz)  
   S13_bar(:,:) = S13(:,:,jz)  
   S22_bar(:,:) = S22(:,:,jz)  
   S23_bar(:,:) = S23(:,:,jz)  
   S33_bar(:,:) = S33(:,:,jz)  

   call test_filter(S11_bar,G_test)
   call test_filter(S12_bar,G_test)
   call test_filter(S13_bar,G_test)
   call test_filter(S22_bar,G_test)
   call test_filter(S23_bar,G_test)
   call test_filter(S33_bar,G_test)

   S_bar = sqrt(2._rprec*(S11_bar**2 + S22_bar**2 + S33_bar**2 + &
          2._rprec*(S12_bar**2 + S13_bar**2 + S23_bar**2)))

   S_S11_bar(:,:) = S(:,:)*S11(:,:,jz)
   S_S12_bar(:,:) = S(:,:)*S12(:,:,jz)
   S_S13_bar(:,:) = S(:,:)*S13(:,:,jz)
   S_S22_bar(:,:) = S(:,:)*S22(:,:,jz)
   S_S23_bar(:,:) = S(:,:)*S23(:,:,jz)
   S_S33_bar(:,:) = S(:,:)*S33(:,:,jz)

   call test_filter(S_S11_bar,G_test)
   call test_filter(S_S12_bar,G_test)
   call test_filter(S_S13_bar,G_test)
   call test_filter(S_S22_bar,G_test)
   call test_filter(S_S23_bar,G_test)
   call test_filter(S_S33_bar,G_test)     

! now put beta back into M_ij
   const = 2._rprec*delta**2
! it might be faster just to go ahead and not store M_ij--just code directly
   M11 = const*(S_S11_bar - 4._rprec*S_bar*S11_bar)
   M12 = const*(S_S12_bar - 4._rprec*S_bar*S12_bar)
   M13 = const*(S_S13_bar - 4._rprec*S_bar*S13_bar)
   M22 = const*(S_S22_bar - 4._rprec*S_bar*S22_bar)
   M23 = const*(S_S23_bar - 4._rprec*S_bar*S23_bar)
   M33 = const*(S_S33_bar - 4._rprec*S_bar*S33_bar)
!        print*,M11,M22
        
   Cs_opt2(jz)=&
        sum(L11*M11+L22*M22+L33*M33+2._rprec*(L12*M12+L13*M13+L23*M23))/&
        sum(M11**2 + M22**2 + M33**2 + 2._rprec*(M12**2 + M13**2 + M23**2))
   Cs_opt2(jz) = max(0._rprec, real(Cs_opt2(jz),kind=rprec))
end do
end subroutine std_dynamic

subroutine stepbl_w (ui, RHSi, RHSi_f,f)
use types,only:rprec
use param,only:ld,nx,ny,nz,dt
implicit none
! Modified on 3/14 to remove non-zero <W> rather than forcing <dw/dt>=0.
! This is because initial velocity field may have nonzero <w> which
!   persisted.      
integer::jx,jy,jz
real(kind=rprec),dimension(ld,ny,nz),intent(out)::ui
real(kind=rprec),dimension(ld,ny,nz),intent(in)::RHSi,RHSi_f,f
real(kind=rprec)::w_bar

do jz=2,nz
! step the velocity with zero horizontal mean
! horizontal mean what? oh--zero plane averaged velocity at each z ??
   ui(:,:,jz)=ui(:,:,jz)+&
        dt*((1.5*RHSi(:,:,jz)-0.5*RHSi_f(:,:,jz))+f(:,:,jz))
! compute mean vertical velocity 
   w_bar=0.
   do jy=1,ny
   do jx=1,nx
      w_bar= w_bar+ui(jx,jy,jz)
   end do
   end do
   w_bar=w_bar/(nx*ny)  
! and remove the mean vertical velocity  
! this is going to be very bad for flow over rough surfaces!
   ui(:,:,jz)=ui(:,:,jz)-w_bar
end do
	
! no slip wall and no flow through top
ui(:,:,1)=0.
ui(:,:,nz)=0.
end subroutine stepbl_w

subroutine filt_da(f_c,dfdx_c,dfdy_c)
! kills the oddball components in f, and calculates in plane derivatives
use types,only:rprec
use param,only:lh,nx,ny,nz
use fft
implicit none
integer::jz
! only need complex treatment
complex(kind=rprec),dimension(lh,ny,nz)::f_c,dfdx_c,dfdy_c
real(kind=rprec)::const, ignore_me
! loop through horizontal slices
const=1._rprec/(nx*ny)
do jz=1,nz
   f_c(:,:,jz)=const*f_c(:,:,jz)   !normalize
   call rfftwnd_f77_one_real_to_complex(forw,f_c(:,:,jz),ignore_me)
! what exactly is the filter doing here? in other words, why is routine
! called filt_da? not filtering anything
! kill the oddballs
   f_c(lh,:,jz)=0._rprec
   f_c(:,ny/2+1,jz)=0._rprec
! in-plane derivatives
   dfdy_c(:,:,jz)=eye*ky(:,:)*f_c(:,:,jz)
   dfdx_c(:,:,jz)=eye*kx(:,:)*f_c(:,:,jz)
! the oddballs for derivatives should already be dead, since they are for f
! inverse transform 
   call rfftwnd_f77_one_complex_to_real(back,f_c(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back,dfdx_c(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back,dfdy_c(:,:,jz),ignore_me)
end do
end subroutine filt_da

      FUNCTION ran3(idum)
      INTEGER*4 idum
      INTEGER*4 MBIG,MSEED,MZ
!     REAL MBIG,MSEED,MZ
      REAL*8 ran3,FAC
      PARAMETER (MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1./MBIG)
!     PARAMETER (MBIG=4000000.,MSEED=1618033.,MZ=0.,FAC=1./MBIG)
      INTEGER*4 i,iff,ii,inext,inextp,k
      INTEGER*4 mj,mk,ma(55)
!     REAL mj,mk,ma(55)
      SAVE iff,inext,inextp,ma
      DATA iff /0/
      if(idum.lt.0.or.iff.eq.0)then
        iff=1
        mj=MSEED-iabs(idum)
        mj=mod(mj,MBIG)
        ma(55)=mj
        mk=1
        do 11 i=1,54
          ii=mod(21*i,55)
          ma(ii)=mk
          mk=mj-mk
          if(mk.lt.MZ)mk=mk+MBIG
          mj=ma(ii)
11      continue
        do 13 k=1,4
          do 12 i=1,55
            ma(i)=ma(i)-ma(1+mod(i+30,55))
            if(ma(i).lt.MZ)ma(i)=ma(i)+MBIG
12        continue
13      continue
        inext=0
        inextp=31
        idum=1
      endif
      inext=inext+1
      if(inext.eq.56)inext=1
      inextp=inextp+1
      if(inextp.eq.56)inextp=1
      mj=ma(inext)-ma(inextp)
      if(mj.lt.MZ)mj=mj+MBIG
      ma(inext)=mj
      ran3=mj*FAC
      return
      END

! put everything onto w-nodes, follow original version
subroutine sgs_stag(jt,txx,txy,txz,tyy,tyz,tzz)
use types,only:rprec
use param,only:ld,ld_big,nx,nx2,ny,ny2,nz,dx,dy,dz,z_i,u_star,&
     model,Co,nnn,vonk,cs_count,molec,nu_molec,dt,sgs
use sim_param,only: u,v,w,dudx,dudy,dudz,dvdx,dvdy,dvdz,dwdx,dwdy,dwdz
use sgsmodule,only:u_lag,v_lag,w_lag,dyn_count,Cs_opt2
use bottombc,only:zo
implicit none
integer,intent(in)::jt
real(kind=rprec),dimension(nz)::l,ziko,zz
real(kind=rprec),dimension(ld,ny,nz),intent(inout)::&
     txx,txy,txz,tyy,tyz,tzz
real(kind=rprec),dimension(ld,ny,nz)::S11,S12,S13,S22,S23,S33
real(kind=rprec),dimension(ld_big,ny2,nz)::Cs_opt2_big,&
     S11_big,S12_big,S13_big,S22_big,S23_big,S33_big,S_big,&
     txx_big,txy_big,txz_big,tyy_big,tyz_big,tzz_big
real(kind=rprec)::ux, uy, uz, vx, vy, vz, wx, wy, wz
real(kind=rprec),dimension(ld,ny) :: txzp, tyzp
real(kind=rprec) :: delta, nu, const
integer::jx,jy,jz

! save the wall level so that we make sure we don't mess with it.
! Wall level stress is computed from law of the wall
txzp(:,:)=txz(:,:,1)
tyzp(:,:)=tyz(:,:,1)

! calculate Sij on w-nodes
! calculate |S| on w-nodes

! at level z=dz/2.  (Where dudz and dvdz are on UVP nodes)
do jy=1,ny
do jx=1,nx              
   ux=dudx(jx,jy,1)  ! uvp-node
   uy=dudy(jx,jy,1)  ! uvp-node
   uz=dudz(jx,jy,1)  ! uvp-node
   vx=dvdx(jx,jy,1)  ! uvp-node
   vy=dvdy(jx,jy,1)  ! uvp-node
   vz=dvdz(jx,jy,1)  ! uvp-node 
! special case
   wx=0.5_rprec*(dwdx(jx,jy,1)+dwdx(jx,jy,2))  ! uvp-node
   wy=0.5_rprec*(dwdy(jx,jy,1)+dwdy(jx,jy,2))  ! uvp-node
   wz=dwdz(jx,jy,1)  ! uvp-node
   S11(jx,jy,1)=ux          ! uvp-node
   S12(jx,jy,1)=0.5_rprec*(uy+vx) ! uvp-node
! taken care of with wall stress routine
   S13(jx,jy,1)=0.5_rprec*(uz+wx) ! uvp
   S22(jx,jy,1)=vy          ! uvp-node
! taken care of with wall stress routine 
   S23(jx,jy,1)=0.5_rprec*(vz+wy) ! uvp
   S33(jx,jy,1)=wz          ! uvp-node
end do
end do

! calculate derivatives/strain on w-nodes
do jz=2,nz-1  
do jy=1,ny
do jx=1,nx              
   ux=0.5_rprec*(dudx(jx,jy,jz) + dudx(jx,jy,jz-1))  ! w-node
   uy=0.5_rprec*(dudy(jx,jy,jz) + dudy(jx,jy,jz-1))  ! w-node
   uz=dudz(jx,jy,jz)  ! w-node
   vx=0.5_rprec*(dvdx(jx,jy,jz) + dvdx(jx,jy,jz-1))  ! w-node
   vy=0.5_rprec*(dvdy(jx,jy,jz) + dvdy(jx,jy,jz-1))  ! w-node
   vz=dvdz(jx,jy,jz)  ! w-node
   wx=dwdx(jx,jy,jz)  ! w-node
   wy=dwdy(jx,jy,jz)  ! w-node
   wz=0.5_rprec*(dwdz(jx,jy,jz) + dwdz(jx,jy,jz-1))  ! w-node
   S11(jx,jy,jz)=ux          ! w-node
   S12(jx,jy,jz)=0.5_rprec*(uy+vx) ! w-node
   S13(jx,jy,jz)=0.5_rprec*(uz+wx) ! w-node
   S22(jx,jy,jz)=vy          ! w-node
   S23(jx,jy,jz)=0.5_rprec*(vz+wy) ! w-node
   S33(jx,jy,jz)=wz          ! w-node
end do
end do
end do

! at top
do jy=1,ny
do jx=1,nx              
   ux=dudx(jx,jy,nz) ! uvp-node
   uy=dudy(jx,jy,nz) ! uvp-node
   uz=0.5_rprec*(dudz(jx,jy,nz) + dudz(jx,jy,nz-1)) ! uvp-node
   vx=dvdx(jx,jy,nz) ! uvp-node
   vy=dvdy(jx,jy,nz) ! uvp-node
   vz=0.5_rprec*(dvdz(jx,jy,nz) + dvdz(jx,jy,nz-1))! uvp-node
   wx=0.5_rprec*(dwdx(jx,jy,nz) + dwdx(jx,jy,nz-1)) ! uvp-node
   wy=0.5_rprec*(dwdy(jx,jy,nz) + dwdy(jx,jy,nz-1))! uvp-node
   wz=dwdz(jx,jy,nz) ! uvp-node
! note: there's probably something wrong with the stuff on the w-nodes here
! only very small, though
   S11(jx,jy,nz)=ux          ! uvp-node
   S12(jx,jy,nz)=0.5_rprec*(uy+vx) ! uvp-node
   S13(jx,jy,nz)=0.5_rprec*(uz+wx) ! uvp-node
   S22(jx,jy,nz)=vy          ! uvp-node
   S23(jx,jy,nz)=0.5_rprec*(vz+wy) ! uvp-node
   S33(jx,jy,nz)=wz          ! uvp-node
end do
end do

!          do jz=1,nz
!          print*,jz,sum(S12(:,:,jz)/nx/ny),sum(S13(:,:,jz)/nx/ny)
!          end do

!	This small part computes the average velocity during cs_count times steps
!	This is used with the lagrangian model only
if (model == 4 .OR. model==5) then
   u_lag = u_lag+u
   v_lag = v_lag+v
   w_lag = w_lag+w
end if


if (sgs)then!ref01
! For traditional Smagorinsky
   if(model == 1) then!ref02
      delta=(dx*dy*dz)**(1._rprec/3._rprec) ! nondimensional
      do jz=1,nz!ref03
! Define parameters (Co and nn) for wallfunction
         Cs_opt2(:,:,jz)=Co**2  ! constant coefficient
         if (jz == 1) then!ref04
            zz(jz)=(real(jz)-0.5_rprec)*dz
         else  ! w-nodes
            zz(jz)=(jz-1)*dz
         end if! end ref04
! z's nondimensional, l here is on w-nodes, except at top & bottom
       l(jz)=(Co**(nnn)*(vonk*zz(jz))**(-nnn)+(delta)**(-nnn))**(-1._rprec/nnn)
      end do!end ref03
   else ! for dynamic procedures  !cont ref02
      l=(dx*dy*dz)**(1._rprec/3._rprec)  ! l is constant
      if ((jt == 1) .and. (Cs_opt2(1,1,1) < 1.e-10)) then!ref05
         dyn_count = cs_count
         print *,'CS_opt2 initialiazed'  
!     initialize Cs_opt2 data with curve fitting of prev. results
!	    do jz=1,nz
! may wanna change this

         Cs_opt2(:,:,jz) = (0.019_rprec*log((jz-0.5_rprec)/nz) + 0.11_rprec)**2
!	Cs_opt2(:,:,:) = 0.03 

!	    end do
! make sure that the "node conventions" in these dynamic models
! match with those done here
      else if((model==2.OR.model==3).AND.mod(jt,dyn_count)==0) then!cont ref05
         if (model == 2) then  ! Standard dynamic model !ref06
            ziko = Cs_opt2(5,5,:)
            call std_dynamic(ziko,S11,S12,S13,S22,S23,S33)
            do jx=1,ld
            do jy =1,ny
               Cs_opt2(jx,jy,:)=ziko(:)
            end do
            end do
         end if!end ref06
         if (model == 3) then  ! Scale dependent dynamic model
            ziko = Cs_opt2(5,5,:)
            call scaledep_dynamic(ziko,S11,S12,S13,S22,S23,S33,jt)
            do jx=1,ld
            do jy =1,ny
               Cs_opt2(jx,jy,:)=ziko(:)
            end do
            end do
         end if
!	else if (model==4.AND.(mod(jt_count,dyn_count)==0)) then ! Lagrangian
      else if (model==4.AND.(mod(jt,cs_count)==0)) then ! LagSS	cont ref5
         call lagrange_Ssim(S11,S12,S13,S22,S23,S33,jt)
      else if (model==5.AND.(mod(jt,cs_count)==0)) then ! LagSD	cont ref5
         call lagrange_Sdep(S11,S12,S13,S22,S23,S33,jt)
      end if  ! for if jt == 1 and 2 else ifs		end ref5
   end if !(for model =1 or else)		end ref02
end if ! for sgs-if		end ref01
!	jt_count = jt_count+1

call dealias1(S11,S11_big) ! w
call dealias1(S12,S12_big) ! w
call dealias1(S13,S13_big) ! w
call dealias1(S22,S22_big) ! w
call dealias1(S23,S23_big) ! w
call dealias1(S33,S33_big) ! w
call dealias1(Cs_opt2,Cs_opt2_big) ! w

! define |S| on w-nodes
do jz=1,nz
do jy=1,ny2
do jx=1,nx2
   S_big(jx,jy,jz)=sqrt(2._rprec * (S11_big(jx,jy,jz)**2 + &
        S22_big(jx,jy,jz)**2+S33_big(jx,jy,jz)**2&
        + 2._rprec * (S12_big(jx,jy,jz)**2 + S13_big(jx,jy,jz)**2 +&
        S23_big(jx,jy,jz)**2)))
end do
end do
end do

! evaluate nu_t= c_s^2 l^2 |S|
! bottom
      
do jy=1,ny2
do jx=1,nx2
   nu = 0.
   const = 0.
   if (sgs) then
      const = Cs_opt2_big(jx,jy,1)*l(1)**2
   end if
   if (molec) then
      nu = (nu_molec/(u_star*z_i)) ! dim/less 
   end if
! everything on right node here
   txx_big(jx,jy,1) = -2._rprec*(const*S_big(jx,jy,1) + nu)*S11_big(jx,jy,1)
   txy_big(jx,jy,1) = -2._rprec*(const*S_big(jx,jy,1) + nu)*S12_big(jx,jy,1)
   tyy_big(jx,jy,1) = -2._rprec*(const*S_big(jx,jy,1) + nu)*S22_big(jx,jy,1)
   tzz_big(jx,jy,1) = -2._rprec*(const*S_big(jx,jy,1) + nu)*S33_big(jx,jy,1)
   
   if ((const*dt/(dx**2)) .GT. 0.5_rprec) then
      print*, (const*dt/(dx**2))
   end if

end do
end do
! middle
do jz=2,nz-2  ! following original code
do jy=1,ny2
do jx=1,nx2
   nu=0._rprec
   const=0._rprec
   if (sgs) then 
      const=0.5_rprec*(Cs_opt2_big(jx,jy,jz) + Cs_opt2_big(jx,jy,jz+1))*&
           0.5_rprec*(l(jz)**2 + l(jz+1)**2)
   end if
   if (molec) then
      nu=(nu_molec/(u_star*z_i)) ! dim/less
   end if
   txx_big(jx,jy,jz)=&
        -2._rprec*(const*0.5_rprec*(S_big(jx,jy,jz)*S11_big(jx,jy,jz) +& 
        S_big(jx,jy,jz+1)*S11_big(jx,jy,jz+1))+&
        nu*0.5_rprec*(S11_big(jx,jy,jz) + S11_big(jx,jy,jz+1)))
   txy_big(jx,jy,jz)=&
        -2._rprec*(const*0.5_rprec*(S_big(jx,jy,jz)*S12_big(jx,jy,jz) +& 
        S_big(jx,jy,jz+1)*S12_big(jx,jy,jz+1)) +&
        nu*0.5_rprec*(S12_big(jx,jy,jz) + S12_big(jx,jy,jz+1)))
   tyy_big(jx,jy,jz)=&
        -2._rprec*(const*0.5_rprec*(S_big(jx,jy,jz)*S22_big(jx,jy,jz) +& 
        S_big(jx,jy,jz+1)*S22_big(jx,jy,jz+1)) +&
        nu*0.5_rprec*(S22_big(jx,jy,jz) + S22_big(jx,jy,jz+1)))
   tzz_big(jx,jy,jz)=&
        -2._rprec*(const*0.5_rprec*(S_big(jx,jy,jz)*S33_big(jx,jy,jz) +& 
        S_big(jx,jy,jz+1)*S33_big(jx,jy,jz+1)) +&
        nu*0.5_rprec*(S33_big(jx,jy,jz) + S33_big(jx,jy,jz+1)))

   if ((const*dt/(dx**2)) .GT. 0.5_rprec) then
      print*, (const*dt/(dx**2))
   end if

end do
end do
end do

! like original code:
! this is slightly messed up, the levels nz, nz-1 weird
! watch the nz and nz-1 here!
do jy=1,ny2
do jx=1,nx2
   nu=0._rprec
   const=0._rprec
   if (sgs) const=Cs_opt2_big(jx,jy,nz)*l(nz)**2
   if (molec) nu=(nu_molec/(u_star*z_i)) ! make dimensionless
   txx_big(jx,jy,nz-1)=-2._rprec*(const*S_big(jx,jy,nz) + nu)*S11_big(jx,jy,nz)
   txy_big(jx,jy,nz-1)=-2._rprec*(const*S_big(jx,jy,nz) + nu)*S12_big(jx,jy,nz)
   tyy_big(jx,jy,nz-1)=-2._rprec*(const*S_big(jx,jy,nz) + nu)*S22_big(jx,jy,nz)
   tzz_big(jx,jy,nz-1)=-2._rprec*(const*S_big(jx,jy,nz) + nu)*S33_big(jx,jy,nz)

   if ((const*dt/(dx**2)) .GT. 0.5_rprec) then
      print*, (const*dt/(dx**2))
   end if

end do
end do

do jz=2,nz-1
do jy=1,ny2
do jx=1,nx2
   nu = 0._rprec
   const = 0._rprec
   if (sgs) const=Cs_opt2_big(jx,jy,jz)*l(jz)**2
   if (molec) nu=(nu_molec/(u_star*z_i)) ! dim/less
   txz_big(jx,jy,jz)=-2._rprec*(const*S_big(jx,jy,jz) + nu)*&
        S13_big(jx,jy,jz)
   tyz_big(jx,jy,jz)=-2._rprec*(const*S_big(jx,jy,jz) + nu)*&
        S23_big(jx,jy,jz)
end do
end do
end do
! what happens at the very top nodes? for txx, tyy, etc. 
! u(k)=u(k-1), etc? make unimportant?

call dealias2(txx,txx_big)
call dealias2(txy,txy_big)
call dealias2(txz,txz_big)
call dealias2(tyy,tyy_big)
call dealias2(tyz,tyz_big)
call dealias2(tzz,tzz_big)
!TSCcall dealias2(Cs_opt2,Cs_opt2_big)

! don't need to do this, unless we accidentally mess with the wall level
txz(:,:,1)=txzp(:,:)
tyz(:,:,1)=tyzp(:,:)

txz(:,:,nz)=0._rprec
tyz(:,:,nz)=0._rprec

if (mod(jt,10)==0) then
   write(97,5400) (SUM(SUM(txz(:,:,:),DIM=1),DIM=1)/nx/ny)
   print*,SUM(txz(:,:,1))
   print*,SUM(tyz(:,:,1))
end if

5400 format(2050(E14.5))
end subroutine sgs_stag

subroutine avgpatch(patch,patchnum,u,u_avg)
! computes the averaged value of a variable (at the wall) over a patch
! and assigns it to an nx X ny array

! sc: 
! note: this is inefficient: should calculate directly to u_avg
! --no maybe its good
use types,only:rprec
use param,only:ld,nx,ny
use bottombc,only:ptypes
implicit none
real(kind=rprec),dimension(nx,ny),intent(inout)::u_avg
integer,dimension(ptypes),intent(in)::patchnum
integer,dimension(nx,ny),intent(in)::patch
integer::i,j,k
real(kind=rprec),dimension(ptypes)::temp
real(kind=rprec),dimension(ld,ny,1),intent(in)::u

temp=0._rprec
do j=1,ny
do i=1,nx
do k=1,ptypes
   if (patch(i,j).eq.k) then
      temp(patch(i,j))=temp(patch(i,j))+u(i,j,1)/real(patchnum(patch(i,j)))
   end if
end do
end do
end do

do j=1,ny
do i=1,nx
do k=1,ptypes
   if (patch(i,j).eq.k) then
      u_avg(i,j)=real(temp(k))
   end if
end do
end do
end do
end subroutine avgpatch

subroutine derivwall_dns()
use types,only:rprec
use param,only:dz,ld,nx,ny,nz
use sim_param,only:dudz,dvdz,u,v
implicit none
integer::jx,jy
! for some reason in the LES code, the 0.5 is not there. it seems to work
! though...      
do jy=1,ny
do jx=1,nx
   dudz(jx,jy,1)=u(jx,jy,1)/(0.5_rprec*dz)
   dvdz(jx,jy,1)=v(jx,jy,1)/(0.5_rprec*dz)
end do
end do
end subroutine derivwall_dns

subroutine ddxy (dfdx_c, dfdy_c, f_c)              
use types,only:rprec
use param,only:lh,nx,ny,nz,dz
use fft
implicit none
integer::jz
! only need complex treatment
complex(kind=rprec),dimension(lh,ny,nz),intent(in)::f_c
complex(kind=rprec),dimension(lh,ny,nz),intent(inout)::dfdx_c,dfdy_c
real(kind=rprec)::const, ignore_me

const=1._rprec/(nx*ny)
!...Loop through horizontal slices
do jz=1,nz
! temporay storage in dfdx_c, this was don't mess up f_c
   dfdx_c(:,:,jz)=const*f_c(:,:,jz)   !normalize
   call rfftwnd_f77_one_real_to_complex(forw,dfdx_c(:,:,jz),ignore_me)
! what exactly is the filter doing here? in other words, why is routine
! called filt_da? not filtering anything
   dfdx_c(lh,:,jz)=0._rprec
   dfdx_c(:,ny/2+1,jz)=0._rprec
! derivatives: must to y's first here, because we're using dfdx as storage
   dfdy_c(:,:,jz)=eye*ky(:,:)*dfdx_c(:,:,jz)
   dfdx_c(:,:,jz)=eye*kx(:,:)*dfdx_c(:,:,jz)
! the oddballs for derivatives should already be dead, since they are for f

! inverse transform 
   call rfftwnd_f77_one_complex_to_real(back,dfdx_c(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back,dfdy_c(:,:,jz),ignore_me)
end do
end subroutine ddxy

!TS 
! highly modified version with minimal output
! for use with fftw
! put in wisdom!
program main
use types,only:rprec
use param
use sim_param
use io,only:openfiles,avgslice,output_loop,output_final
use fft
use immersedbc
use sgsmodule,only:initest,Cs_opt2
use test_filtermodule
use topbc,only:setsponge,sponge
use bottombc,only:zo,patch,patchnum,num_patch,patches,avgpatch
implicit none
integer,parameter::wbase=1
integer :: jx,jy,jz,jt
real(kind=rprec),dimension(ld,ny,nz)::cx,cy,cz,&
     txx,txy,txz,tyy,tyz,tzz,divtx,divty,divtz
equivalence (txx,divtx),(tyy,divty),(tzz,divtz)
real(kind=rprec) rmsdivvel,ke,kestor,testu   
real(kind=rprec),dimension(nz)::u_ndim
real(kind=rprec),dimension(nx,ny):: T_s,q_s2d,&
     psi_m,psi_h,phi_h,phi_m,u_avg
real(kind=rprec)::u_avg_(num_patch)
real(kind=rprec),dimension(ld,ny,nz)::S_hat,Pr_0
real(kind=rprec)::const,tt

initest=1
call initial()
! formulate the fft plans--may want to use FFTW_USE_WISDOM
! initialize the kx,ky arrays
call init_fft()
! Open output files      
call openfiles()
! initialize test filter
!TSC standard dynamic or Lagrangian
   call test_filter_init(2._rprec*filter_size,G_test)
if (model == 3 .OR. model == 5) then  ! scale dependent dynamic
   call test_filter_init(4._rprec*filter_size,G_test_test)
end if
! sets roughness in the patches
! sc note: make sure that either patchnum is initialized (to 0) before
! calling, or that the patches routine initializes it to 0
call patches()

if (ubc == 1) call setsponge()
print*,'Number of timesteps', nsteps
print*,'dt and Cs= ',dt, cs
print*,'Nx, Ny, Nz= ',nx,ny,nz
print*,'Number of patches:',num_patch
!      print*,'sampling stats every ',c_count,' timesteps'
!      print*,'writing stats every ',p_count,' timesteps'
if (molec) print*, 'molecular viscosity (dimensional) ', nu_molec

! time Loop
do jt=1,nsteps   
! advance total time
   tt=tt+dt
! save previous time's right-hand-sides for Adams-Bashforth Integration
!  (In subroutine "STEP" use first order time advancement on first time 
!  step).
   if (jt > 1) then    
      RHSx_f=RHSx
      RHSy_f=RHSy
      RHSz_f=RHSz
   else ! for first timestep and for neutral conditions
      psi_m=0._rprec
      psi_h=0._rprec
      phi_m=1._rprec
      phi_h=1._rprec
   end if
! kill oddballs and calculate horizontal derivatives
   call filt_da(u,dudx,dudy)
   call filt_da(v,dvdx,dvdy)
   call filt_da(w,dwdx,dwdy)
! calculate average u at the wall over each patch
! don't need for dns case
   call avgpatch(u_avg)
!  finite differences      
   call ddz_uv(dudz,u)
   call ddz_uv(dvdz,v)
   call ddz_w(dwdz,w)   

! calculate wall stress 
   if (dns_bc) then
      call wallstress_dns(txz,tyz)
      call derivwall_dns()
   else
! "impose" wall stress
      call wallstress(txz,tyz)
! calculate derivatives at wall 
      call derivwall()
   end if
   
! compute convective term in physical space
   call convec(cx,cy,cz,u,v,w,dudy,dudz,dvdx,dvdz,dwdx,dwdy,jt)  
! compute turbulent viscosity (const.)
   if (dns_bc .and. molec) then
      call dns_stress(txx,txy,txz,tyy,tyz,tzz)
   else 
      call sgs_stag(jt,txx,txy,txz,tyy,tyz,tzz)
   end if
   if (use_bldg) then
      call bldg_stress(txx,txy,txz,tyy,tyz,tzz)
   end if
! compute divergence of SGS shear stresses     
! note: the divt's and the diagonal elements of t are equivalenced!
   call divstress_uv(divtx, txx, txy, txz)
   call divstress_uv(divty, txy, tyy, tyz)
   call divstress_w(divtz, txz, tyz, tzz)
! Compute preliminary RHS matrices for pressure calculation
   RHSx = -cx - divtx
   RHSy = -cy - divty
   RHSz = -cz - divtz
!        do jz=1,nz
!          do jy=1,ny
!            do jx=1,nx
!              RHSx(jx,jy,jz)=-cx(jx,jy,jz)-divtx(jx,jy,jz)
!	      RHSy(jx,jy,jz)=-cy(jx,jy,jz)-divty(jx,jy,jz)
!	      RHSz(jx,jy,jz)=-cz(jx,jy,jz)-divtz(jx,jy,jz) 
!!     &	         -sponge(jz)*w(jx,jy,jz)+beta(jx,jy,jz)  !stop
!            end do
!          end do
!        end do

! solve Poisson equation for pressure.
! do we ever need p itself, or only its gradient?  -> probably don't need
! store p
   if (use_bldg) then
      call press_stag_bldg(p,dpdx,dpdy,divtz)
   else
      call press_stag(p,dpdx,dpdy,divtz)     
   end if
! Calculate pressure gradients here
! careful! p is not dimensioned the same as the others!
   const=1._rprec/dz
   do jz=1,nz
   do jy=1,ny
   do jx=1,nx
      dpdz(jx,jy,jz)=const*(p(jx,jy,jz)-p(jx,jy,jz-1))
   end do
   end do
   end do

   call forcing(jt)
   call energy (ke)
   call rmsdiv(rmsdivvel,dudx,dvdy,dwdz)
   write(51,*) jt,ke
   if (mod(jt,wbase) == 0) then
      write(6,7777) float(jt), dt,rmsdivvel,ke
   end if
7777 format ('tt,dt,NU,diui,ke:',5(1x,e9.4))
   call output_loop(jt,txx,txy,txz,tyy,tyz,tzz)
! end time loop
end do
if (output)call output_final(jt)
end program main

subroutine press_stag_bldg(p_hat,dfdx,dfdy,divtz)   
! p_hat contains the physical space pressure on exit
!-------------------    
! Boundary Layer version with 4th order derivs in vertical.
!  04 December 1995
!	Mods.
!	12/6: added upper and lower boundary conditions.	
!    12/8: Corrected sign on imag. x and y deriv of RHS.
!	12/17 Forcing pressure equal zero at wall 
!			Removed forcing of <P>=0 for all z.
!		    Will need to change BC when hetero. surface stress.
!	12/17 Added ficticious node below wall (Note solver on Nz+1 x Nz+1
!          prev. version of this subroutine saved as p_bl4.old.12.17
!    12/18 Revised 2st deriv stencil at wall (avg of deriv at -1 and at 1)
!    12/21 Redid FDD to 2nd order accurate.
!    12/22 Now value of P(wall) diagnosed from prev P, to match gradient BC
!....1/13: major changes.
!		Broke out mean pressure for separate solution
!    1/20 back to tridag for natrix solution (same sol'n as LUDCMP...A Keeper!)
!....1/23 Staggered solution
!.........Using Nz+1 levels for computing P, but tossing out level below ground
!....4/1 Changed sign on Div T_iz at wall and lid (five places)
!-------------------          
use types,only:rprec
use param,only:ld,lh,nx,ny,nz,dt,dz
use sim_param,only:u,v,w,RHSx,RHSy,RHSz,RHSx_f,RHSy_f,RHSz_f
use fft
use immersedbc,only:fx,fy,fz
implicit none   
real(kind=rprec),dimension(ld,ny,nz),intent(in)::divtz
complex(kind=rprec),dimension(lh,ny,0:nz)::p_hat
real(kind=rprec),dimension(ld,ny,nz)::rH_x,rH_y,rH_z
complex(kind=rprec),dimension(lh,ny,nz)::H_x,H_y,H_z
equivalence (rH_x,H_x),(rH_y,H_y),(rH_z,H_z)
real(kind=rprec),dimension(ld,ny)::rtopw, rbottomw
complex(kind=rprec),dimension(lh,ny)::topw,bottomw
equivalence (rtopw,topw),(rbottomw,bottomw)
complex(kind=rprec),dimension(lh,ny,nz),intent(out)::dfdx,dfdy
complex(kind=rprec),dimension(nz+1)::RHS_col,p_col
real(kind=rprec),dimension(nz+1)::a1,b1,c1
real(kind=rprec)::const,ignore_me
! remove this stuff!
integer::jx,jy,jz,size,k

size=nz+1
p_hat(:,:,0)=0._rprec ! dont know for sure if this is right
!==========================================================================
! Get the right hand side ready 
! Loop over levels    
const=1._rprec/(nx*ny)
do jz=1,nz
! temp storage for sum of RHS terms.  normalized for fft
! sc: recall that the old timestep guys already contain the pressure
!   term
   rH_x(:,:,jz)=const*(RHSx(:,:,jz)-1._rprec/3._rprec*RHSx_f(:,:,jz)&
        +2._rprec/(3._rprec*dt)*u(:,:,jz)+2._rprec/3._rprec*fx(:,:,jz))
   rH_y(:,:,jz)=const*(RHSy(:,:,jz)-1._rprec/3._rprec*RHSy_f(:,:,jz)&
        +2._rprec/(3._rprec*dt)*v(:,:,jz)+2._rprec/3._rprec*fy(:,:,jz))
   rH_z(:,:,jz)=const*(RHSz(:,:,jz)-1._rprec/3._rprec*RHSz_f(:,:,jz)&
        +2._rprec/(3._rprec*dt)*w(:,:,jz)+2._rprec/3._rprec*fz(:,:,jz))
   call rfftwnd_f77_one_real_to_complex(forw,rH_x(:,:,jz),ignore_me)
   call rfftwnd_f77_one_real_to_complex(forw,rH_y(:,:,jz),ignore_me)
   call rfftwnd_f77_one_real_to_complex(forw,rH_z(:,:,jz),ignore_me)     
end do

! sc: could do out of place transform if wanted to...
rbottomw(:,:)=const*divtz(:,:,1)
rtopw(:,:)=const*divtz(:,:,nz)
call rfftwnd_f77_one_real_to_complex(forw,rbottomw(:,:),ignore_me)
call rfftwnd_f77_one_real_to_complex(forw,rtopw(:,:),ignore_me)

! set oddballs to 0
! probably can get rid of this if we're more careful below
H_x(lh,:,:)=0._rprec
H_y(lh,:,:)=0._rprec
H_z(lh,:,:)=0._rprec
H_x(:,ny/2+1,:)=0._rprec
H_y(:,ny/2+1,:)=0._rprec
H_z(:,ny/2+1,:)=0._rprec
topw(lh,:)=0._rprec
topw(:,ny/2+1)=0._rprec
bottomw(lh,:)=0._rprec
bottomw(:,ny/2+1)=0._rprec
!==========================================================================
! Loop over (Kx,Ky) to solve for Pressure amplitudes
do jy=1,ny
   if (jy.eq.ny/2+1) then
      p_hat(:,jy,:)=0._rprec
      goto 5111
   end if
! since this is all in Fourier space, don't we need to skip ny/2+1?
   do jx=1,lh-1
! the lh part should be zero, right?
! this is the k=0 part
! Zero wavenumber problem is non-unique for matrix solution
! So just integrate up from wall with arbitrary P=const starting point.
! why is the jz index the innermost loop?
      if (jx*jy.eq.1) then          
! what is in p_hat(:,:,0) here?
! does the (:,:,1) entry need to be real as in original?
! the 0. here is assuming that p(z=0)=0.
         p_hat(jx,jy,1)=0._rprec-dz*bottomw(jx,jy)
         do jz=2,nz
            p_hat(jx,jy,jz)=p_hat(jx,jy,jz-1)+H_z(jx,jy,jz)*dz
         end do
      else
! See end of wavenumber loops for endif
! Set up matrix solution for pressure Fourier coeff's
! Near Wall Nodes
         a1(1)=0._rprec
         b1(1)=-1._rprec
         c1(1)=1._rprec
         RHS_col(1)=-dz*bottomw(jx,jy) ! complex 
! Interior Nodes
         do jz=2,nz
            RHS_col(jz)=eye*(kx(jx,jy)*H_x(jx,jy,jz-1)+&
                 ky(jx,jy)*H_y(jx,jy,jz-1))&
                 +(H_z(jx,jy,jz)-H_z(jx,jy,jz-1))/dz
! this part OK
            a1(jz)=1._rprec/(dz**2)
            b1(jz)=-(kx(jx,jy)**2+ky(jx,jy)**2+2._rprec/(dz**2))
            c1(jz)=1._rprec/(dz**2)
         end do

! top nodes 
         RHS_col(nz+1)=-topw(jx,jy)*dz
! note: check to make sure the topw's aren't automatically 0
! this would save some time
         a1(nz+1)= -1._rprec
         b1(nz+1)=1._rprec
         c1(nz+1)=0._rprec
! Call Solver
! modified to handle complex
         call tridag (a1,b1,c1,RHS_col,p_col,size)
! Put Pressure amplitudes in Matrix
         do jz=0,nz
! if called above directly with a row of p_hat, we'd probably encounter
! some serious cache thrashing??? try it
            p_hat(jx,jy,jz)=p_col(jz+1)
         end do
! Ending IF from zero wavenumber solution
      end if
! End loop over kx,ky
   end do
   p_hat(lh,jy,:)=0._rprec
5111 continue
end do

!      do jz=0,nz
!        print*, p_hat(1,1,jz),p_hat(5,5,jz)
!      end do


!=========================================================================== 
!...Now need to get p_hat(wave,level) to physical p(jx,jy,jz)   
!.....Loop over height levels     
call rfftwnd_f77_one_complex_to_real(back,p_hat(:,:,0),ignore_me)
do jz=1,nz
do jy=1,ny
do jx=1,lh
! complex
   dfdx(jx,jy,jz)=eye*kx(jx,jy)*p_hat(jx,jy,jz)
   dfdy(jx,jy,jz)=eye*ky(jx,jy)*p_hat(jx,jy,jz)
! note the oddballs of p_hat are already 0, so we should be OK here
end do
end do
call rfftwnd_f77_one_complex_to_real(back,dfdx(:,:,jz),ignore_me)
call rfftwnd_f77_one_complex_to_real(back,dfdy(:,:,jz),ignore_me)
call rfftwnd_f77_one_complex_to_real(back,p_hat(:,:,jz),ignore_me)
end do
end subroutine press_stag_bldg

module test_filtermodule
use types,only:rprec
use param,only:lh,ny

private lh,ny
!TS Truely grid refinement test needs to keep the filter_size
!TS the same as that in coarse grid (Double grid size: filter_size=2. etc)
integer,parameter::filter_size=1._rprec
real(kind=rprec),dimension(lh,ny)::G_test,G_test_test
end module test_filtermodule

subroutine test_filter(f,G_test)
! note: this filters in-place, so input is ruined
use types,only:rprec
use param,only:lh,ny
use fft
implicit none
! note we're treating as complex here
complex(kind=rprec), dimension(lh,ny),intent(inout)::f
real(kind=rprec), dimension(lh,ny),intent(in) :: G_test
!f_c=cmplx(f,0.,kind=rprec)
call rfftwnd_f77_one_real_to_complex(forw,f)
! the normalization is "in" G_test
f = G_test*f  ! Nyquist taken care of with G_test
call rfftwnd_f77_one_complex_to_real(back,f)
!f=real(f_c,kind=rprec)
end subroutine test_filter

subroutine test_filter_init(alpha,G_test)
! spectral cutoff filter at width alpha*delta
! note the normalization for FFT's is already in G! (see 1/(nx*ny))
use types,only:rprec
use param,only:lh,nx,ny,dx,dy,pi,ifilter,model
use fft
implicit none
real(kind=rprec):: alpha, delta, kc2
real(kind=rprec),dimension(lh,ny) :: G_test
G_test=1._rprec/(nx*ny)  ! normalization for the forward FFT
delta = sqrt(dx*dy)  ! "2d-delta", not full 3d one
if(ifilter==1) then ! spectral cutoff filter
   if (model==6.OR.model==7) then
      print *, 'Use Gaussian or Top-hat filter for mixed models'
      stop
   endif
! alpha is ratio of test filter to grid filter widths
   kc2 = (pi/(alpha*delta))**2
   where (real(k2) >= kc2) G_test = 0._rprec
else if(ifilter==2) then ! Gaussian filter
   G_test=exp(-(2._rprec*delta)**2*k2/(4._rprec*6._rprec))*G_test       
else if(ifilter==3) then ! Top-hat (Box) filter
   G_test= (sin(kx*delta/2._rprec)*sin(ky*delta/2._rprec)+10._rprec**(-8))/&
        (kx*delta/2._rprec*ky*delta/2._rprec+10._rprec**(-8))*G_test
endif

! since our k2 has zero at Nyquist, we have to do this by hand
G_test(lh,:) = 0._rprec
G_test(:,ny/2+1) = 0._rprec
end subroutine test_filter_init

subroutine ddx(dfdx, f)              
! f remains untouched
use types,only:rprec
use param,only:lh,nx,ny,nz,dz
use fft
implicit none
integer::jz
complex(kind=rprec),dimension(lh,ny,nz),intent(in)::f
complex(kind=rprec),dimension(lh,ny,nz),intent(inout)::dfdx
real(kind=rprec)::const, ignore_me

const=1._rprec/(nx*ny)
! Loop through horizontal slices
do jz=1,nz
! temporary storage in dfdx--even though they're complex arrays!
   dfdx(:,:,jz)=const*f(:,:,jz)
   call rfftwnd_f77_one_real_to_complex(forw,dfdx(:,:,jz),ignore_me)       
! oddballs
   dfdx(lh,:,jz)=0._rprec
   dfdx(:,ny/2+1,jz)=0._rprec
! compute coefficients for pseudospectral derivative calculation
   dfdx(:,:,jz)=eye*kx(:,:)*dfdx(:,:,jz)
! inverse transform to get pseudospectral derivative
   call rfftwnd_f77_one_complex_to_real(back,dfdx(:,:,jz),ignore_me)
end do
end subroutine ddx

subroutine ddz_w(dfdz,f)
!  First deriv in z direction for boundary layer (2nd order numerics)
!  F is on w nodes and dFdz is on uvp nodes
!    -23 January 1996
use types,only:rprec
use param,only:ld,nx,ny,nz,dz
implicit none
real(kind=rprec),dimension(ld,ny,nz),intent(in)::f
real(kind=rprec),dimension(ld,ny,nz),intent(inout)::dfdz
real(kind=rprec)::const
integer::jx,jy,jz

const=1._rprec/dz
do jz=1,nz-1
do jy=1,ny
do jx=1,nx
   dfdz(jx,jy,jz)=const*(f(jx,jy,jz+1)-f(jx,jy,jz))
end do
end do
end do

! Stress free lid (ubc)
!	if (ubc==0) then stop

!	else
dfdz(:,:,nz)=0._rprec !dfdz(:,:,Nz-1) ! c? any better ideas for sponge?
!     end if
end subroutine ddz_w

! this is the w-node version
subroutine scaledep_dynamic(Cs_opt2,S11,S12,S13,S22,S23,S33,jt)
! standard dynamic model to calculate the Smagorinsky coefficient
! this is done layer-by-layer to save memory
! note: we need to calculate |S| here, too.
! stuff is done on uv-nodes
! can save more mem if necessary.  mem requirement ~ n^2, not n^3
use types,only:rprec
use param,only:ld,nx,ny,nz,dx,dy,dz
use sim_param,only:path,u,v,w
use sgsmodule,only:rtnewt
use test_filtermodule
implicit none
integer :: jz, jt
real(kind=rprec), dimension(ld,ny,nz) :: S11,S12,S13,S22,S23,S33
real(kind=rprec), dimension(nz) :: Cs_opt2
real(kind=rprec), dimension(ld,ny) :: L11,L12,L13,L22,L23,L33
real(kind=rprec), dimension(ld,ny) :: Q11,Q12,Q13,Q22,Q23,Q33
real(kind=rprec), dimension(ld,ny) :: M11,M12,M13,M22,M23,M33
!equivalence (M11,Q11), (M12,Q12), (M13,Q13), (M22,Q22), (M23,Q23),&
!     (M33,Q33)
real(kind=rprec), dimension(ld,ny) :: S_bar,S11_bar,S12_bar,&
     S13_bar,S22_bar,S23_bar,S33_bar,S_S11_bar, S_S12_bar,&
     S_S13_bar, S_S22_bar, S_S23_bar, S_S33_bar
real(kind=rprec), dimension(ld,ny) :: S_hat,S11_hat,S12_hat,&
     S13_hat,S22_hat,S23_hat,S33_hat,S_S11_hat, S_S12_hat,&
     S_S13_hat, S_S22_hat, S_S23_hat, S_S33_hat
real(kind=rprec), dimension(ld,ny) :: u_bar,v_bar,w_bar
real(kind=rprec), dimension(ld,ny) :: u_hat,v_hat,w_hat
real(kind=rprec), dimension(ld,ny) :: S
real(kind=rprec) :: delta, const
real(kind=rprec), dimension(0:5) :: A
real(kind=rprec) :: a1, b1, c1, d1, e1, a2, b2, c2, d2, e2
real(kind=rprec), dimension(nz) :: beta
!TSreal(kind=rprec) :: rtnewt
character(len=24)::fname

delta = filter_size*(dx*dy*dz)**(1._rprec/3._rprec)

do jz=1,nz
! using L_ij as temp storage here
!!! watch the 0.25's: w = c*z**z near wall, so get 0.25
   if (jz == 1) then  ! put on uvp-nodes
      L11(:,:) = u(:,:,1)*u(:,:,1)  ! uv-node
      L12(:,:) = u(:,:,1)*v(:,:,1)  ! uv-node
      L13(:,:) = u(:,:,1)*0.25_rprec*w(:,:,2)  ! assume parabolic near wall
      L22(:,:) = v(:,:,1)*v(:,:,1)  ! uv-node
      L23(:,:) = v(:,:,jz)*0.25_rprec*w(:,:,2)  ! uv-node
      L33(:,:) = (0.25_rprec*w(:,:,2))**2  ! uv-node
      u_bar(:,:) = u(:,:,1)
      v_bar(:,:) = v(:,:,1)
      w_bar(:,:) = 0.25_rprec*w(:,:,2)
   else  ! w-nodes
      L11(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*&
           0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))
      L12(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*&
           0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      L13(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*w(:,:,jz)
      L22(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))*&
           0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      L23(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))*w(:,:,jz)
      L33(:,:) = w(:,:,jz)*w(:,:,jz)
      u_bar(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))
      v_bar(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      w_bar(:,:) = w(:,:,jz)
   end if
   u_hat = u_bar
   v_hat = v_bar
   w_hat = w_bar
! would be neat to have some rotating storage or something so we don't 
!   have to do this (use pointers)
   
   call test_filter(u_bar,G_test)
   call test_filter(v_bar,G_test)
   call test_filter(w_bar,G_test)
   call test_filter(L11,G_test)  ! in-place filtering
   L11 = L11 - u_bar*u_bar
   call test_filter(L12,G_test)
   L12 = L12 - u_bar*v_bar
   call test_filter(L13,G_test)
   L13 = L13 - u_bar*w_bar
   call test_filter(L22,G_test)
   L22 = L22 - v_bar*v_bar
   call test_filter(L23,G_test)
   L23 = L23 - v_bar*w_bar
   call test_filter(L33,G_test)
   L33 = L33 - w_bar*w_bar
   
   Q11 = u_bar*u_bar
   Q12 = u_bar*v_bar
   Q13 = u_bar*w_bar
   Q22 = v_bar*v_bar
   Q23 = v_bar*w_bar
   Q33 = w_bar*w_bar

   call test_filter(u_hat,G_test_test)
   call test_filter(v_hat,G_test_test)
   call test_filter(w_hat,G_test_test)
   call test_filter(Q11,G_test_test)
   Q11 = Q11 - u_hat*u_hat
   call test_filter(Q12,G_test_test)
   Q12 = Q12 - u_hat*v_hat
   call test_filter(Q13,G_test_test)
   Q13 = Q13 - u_hat*w_hat
   call test_filter(Q22,G_test_test)
   Q22 = Q22 - v_hat*v_hat
   call test_filter(Q23,G_test_test)
   Q23 = Q23 - v_hat*w_hat
   call test_filter(Q33,G_test_test)
   Q33 = Q33 - w_hat*w_hat
   
! calculate |S|
   S(:,:) = sqrt(2._rprec*(S11(:,:,jz)**2 + S22(:,:,jz)**2 +& 
        S33(:,:,jz)**2 + 2._rprec*(S12(:,:,jz)**2 + &
        S13(:,:,jz)**2 + S23(:,:,jz)**2)))

! already on w-nodes
   S11_bar(:,:) = S11(:,:,jz)  
   S12_bar(:,:) = S12(:,:,jz)  
   S13_bar(:,:) = S13(:,:,jz)  
   S22_bar(:,:) = S22(:,:,jz)  
   S23_bar(:,:) = S23(:,:,jz)  
   S33_bar(:,:) = S33(:,:,jz)  
   
   S11_hat = S11_bar
   S12_hat = S12_bar
   S13_hat = S13_bar
   S22_hat = S22_bar
   S23_hat = S23_bar
   S33_hat = S33_bar
   
   call test_filter(S11_bar,G_test)
   call test_filter(S12_bar,G_test)
   call test_filter(S13_bar,G_test)
   call test_filter(S22_bar,G_test)
   call test_filter(S23_bar,G_test)
   call test_filter(S33_bar,G_test)

   call test_filter(S11_hat,G_test_test)
   call test_filter(S12_hat,G_test_test)
   call test_filter(S13_hat,G_test_test)
   call test_filter(S22_hat,G_test_test)
   call test_filter(S23_hat,G_test_test)
   call test_filter(S33_hat,G_test_test)

   S_bar = sqrt(2._rprec*(S11_bar**2 + S22_bar**2 + S33_bar**2 + &
        2._rprec*(S12_bar**2 + S13_bar**2 + S23_bar**2)))

   S_hat = sqrt(2._rprec*(S11_hat**2 + S22_hat**2 + S33_hat**2 + &
        2._rprec*(S12_hat**2 + S13_hat**2 + S23_hat**2)))

   S_S11_bar = S*S11(:,:,jz)
   S_S12_bar = S*S12(:,:,jz)
   S_S13_bar = S*S13(:,:,jz)
   S_S22_bar = S*S22(:,:,jz)
   S_S23_bar = S*S23(:,:,jz)
   S_S33_bar = S*S33(:,:,jz)

   S_S11_hat = S_S11_bar
   S_S12_hat = S_S12_bar
   S_S13_hat = S_S13_bar
   S_S22_hat = S_S22_bar
   S_S23_hat = S_S23_bar
   S_S33_hat = S_S33_bar

   call test_filter(S_S11_bar,G_test)
   call test_filter(S_S12_bar,G_test)
   call test_filter(S_S13_bar,G_test)
   call test_filter(S_S22_bar,G_test)
   call test_filter(S_S23_bar,G_test)
   call test_filter(S_S33_bar,G_test)     
   
   call test_filter(S_S11_hat,G_test_test)
   call test_filter(S_S12_hat,G_test_test)
   call test_filter(S_S13_hat,G_test_test)
   call test_filter(S_S22_hat,G_test_test)
   call test_filter(S_S23_hat,G_test_test)
   call test_filter(S_S33_hat,G_test_test)     

! note: check that the Nyquist guys are zero!
! the 1./(nx*ny) is not really neccessary, but in practice it does 
! affect the results.
   a1 = -2._rprec*(delta**2)*4._rprec*sum( S_bar*(S11_bar*L11 + S22_bar*L22 +&
        S33_bar*L33 + 2._rprec*( S12_bar*L12 + S13_bar*L13 + S23_bar*L23)))/&
        (nx*ny)
   b1 = -2._rprec*(delta**2)*sum( S_S11_bar*L11 + S_S22_bar*L22 +&
        S_S33_bar*L33 + 2._rprec*( S_S12_bar*L12 + S_S13_bar*L13 + &
        S_S23_bar*L23))/(nx*ny)
   c1 = (2._rprec*delta**2)**2 * sum( S_S11_bar**2 + S_S22_bar**2 +&
        S_S33_bar**2 + &
        2._rprec*( S_S12_bar**2 + S_S13_bar**2 + S_S23_bar**2))/(nx*ny)
   d1 = (2._rprec*delta**2)**2 * 16._rprec*sum( 0.5_rprec*S_bar**4 )/(nx*ny)
   e1 = 2._rprec*(2._rprec*delta**2)**2*4._rprec*sum( S_bar*( S11_bar*S_S11_bar +&
        S22_bar*S_S22_bar + S33_bar*S_S33_bar + 2._rprec*(&
        S12_bar*S_S12_bar + S13_bar*S_S13_bar + S23_bar*S_S23_bar)))/&
        (nx*ny)
   
   a2 = -2._rprec*(delta**2)*16._rprec*sum( S_hat*(S11_hat*Q11 + S22_hat*Q22 +&
        S33_hat*Q33 + 2._rprec*( S12_hat*Q12 + S13_hat*Q13 + S23_hat*Q23)))/&
        (nx*ny)
   b2 = -2._rprec*(delta**2)*sum( S_S11_hat*Q11 + S_S22_hat*Q22 +&
        S_S33_hat*Q33 + 2._rprec*( S_S12_hat*Q12 + S_S13_hat*Q13 + &
        S_S23_hat*Q23))/(nx*ny)
   c2 = (2._rprec*delta**2)**2 * sum( S_S11_hat**2 + S_S22_hat**2 +&
        S_S33_hat**2 + &
        2._rprec*( S_S12_hat**2 + S_S13_hat**2 + S_S23_hat**2))/(nx*ny)
   d2 = (2._rprec*delta**2)**2 *256._rprec*sum( 0.5_rprec*S_hat**4 )/(nx*ny)
   e2 = 2._rprec*(2._rprec*delta**2)**2*16._rprec*sum( S_hat*( S11_hat*S_S11_hat +&
        S22_hat*S_S22_hat + S33_hat*S_S33_hat + 2.*(&
        S12_hat*S_S12_hat + S13_hat*S_S13_hat + S23_hat*S_S23_hat)))/&
        (nx*ny)
                        
   A(0) = b2*c1 - b1*c2
   A(1) = a1*c2 - b2*e1
   A(2) = b2*d1 + b1*e2 - a2*c1
   A(3) = a2*e1 - a1*e2
   A(4) = -a2*d1 - b1*d2
   A(5) = a1*d2

!        if (jz == (nz/2)) print*, A

! note: this is not the temperature-beta
! I think we might need to do something to ensure that we always get the 
!  largest root, as in the JFM paper
   beta(jz) = rtnewt(A,jz)  ! subroutine at end of this file

! now put beta back into M_ij: using Q_ij as storage
   const = 2._rprec*delta**2
! it might be faster just to go ahead and not store M_ij; just code directly
   M11 = const*(S_S11_bar - 4._rprec*beta(jz)*S_bar*S11_bar)
   M12 = const*(S_S12_bar - 4._rprec*beta(jz)*S_bar*S12_bar)
   M13 = const*(S_S13_bar - 4._rprec*beta(jz)*S_bar*S13_bar)
   M22 = const*(S_S22_bar - 4._rprec*beta(jz)*S_bar*S22_bar)
   M23 = const*(S_S23_bar - 4._rprec*beta(jz)*S_bar*S23_bar)
   M33 = const*(S_S33_bar - 4._rprec*beta(jz)*S_bar*S33_bar)
        
   Cs_opt2(jz) = sum(L11*M11 + L22*M22 + L33*M33 + 2._rprec*(L12*M12 +&
        L13*M13 + L23*M23)) /&
        sum(M11**2 + M22**2 + M33**2 + 2._rprec*(M12**2 + M13**2 + M23**2))
   Cs_opt2(jz) = max(0._rprec, real(Cs_opt2(jz),kind=rprec))
end do

if (modulo(jt,500) == 0) then
   write(fname,'(A13,i5.5)')path//'output/beta',jt
      open(1,file=fname,form='unformatted')
   do jz=1,nz
      write(1,*) jz, beta(jz)
   end do
   close(1)
end if
end subroutine scaledep_dynamic

subroutine energy (ke)
use types,only:rprec
use param,only:ld,nx,ny,nz
use sim_param,only:u,v,w
implicit none
integer::jx,jy,jz
real(kind=rprec)::KE,denom,temp_w
ke=0._rprec
denom=2._rprec*(nx*ny*(nz-1))
do jz=2,nz
do jy=1,ny
do jx=1,nx
   temp_w=.5_rprec*(w(jx,jy,jz)+w(jx,jy,jz-1))
   ke=ke+(u(jx,jy,jz)**2+v(jx,jy,jz)**2+temp_w**2)/denom
end do
end do
end do
end subroutine energy

module immersedbc
use types,only:rprec
use param,only:ld,ny,nz
implicit none
private
public n_bldg,bldg_pts,fx,fy,fz,u_des,v_des,w_des,bldg_stress,bcuint
integer::n_bldg
integer,allocatable::bldg_pts(:,:)
real(kind=rprec),dimension(ld,ny,nz)::fx,fy,fz,u_des,v_des,w_des
logical,parameter::callag=.false.

contains

subroutine bldg_stress(txx,txy,txz,tyy,tyz,tzz)
implicit none
real(kind=rprec),dimension(ld,ny,nz),intent(inout)::txx,txy,txz,tyy,tyz,tzz
call bldg_stress_extrapol(txx)
call bldg_stress_extrapol(txy)
call bldg_stress_extrapol(txz)
call bldg_stress_extrapol(tyy)
call bldg_stress_extrapol(tyz)
call bldg_stress_extrapol(tzz)
end subroutine bldg_stress

subroutine bldg_stress_extrapol(tij)
implicit none

integer::jx,jy,jz
real(kind=rprec),dimension(ld,ny,nz):: tij
real(kind=rprec)::avg,npoints
integer :: i, px, py, lx, ly, lz,lz_1,lz_2

do i=1,n_bldg
   px=bldg_pts(1,i)
   py=bldg_pts(2,i)
   lx=bldg_pts(3,i)
   ly=bldg_pts(4,i)
   lz=bldg_pts(5,i)
   lz_1=lz+1
   lz_2=lz+2
   if(lz_1.ge.nz)lz_1=nz-1
   if(lz_2.ge.nz)lz_2=nz-1
! faces
   tij(px-1,py:py+ly,1:1+lz)=tij(px-2,py:py+ly,1:1+lz)
   tij(px,py:py+ly,1:1+lz)=tij(px-2,py:py+ly,1:1+lz)

   tij(px+lx,py:py+ly,1:1+lz)=tij(px+lx+2,py:py+ly,1:1+lz)
   tij(px+lx+1,py:py+ly,1:1+lz)=tij(px+lx+2,py:py+ly,1:1+lz)

   tij(px:px+lx,py-1,1:1+lz)=tij(px:px+lx,py-2,1:1+lz)
   tij(px:px+lx,py,1:1+lz)=tij(px:px+lx,py-2,1:1+lz)

   tij(px:px+lx,py+ly,1:1+lz)=tij(px:px+lx,py+ly+2,1:1+lz)
   tij(px:px+lx,py+ly+1,1:1+lz)=tij(px:px+lx,py+ly+2,1:1+lz)
!TS
!Change lz to lz_p to avoid overbound
   tij(px:px+lx,py:py+ly,1+lz) =tij(px:px+lx,py:py+ly,1+lz_2)
   tij(px:px+lx,py:py+ly,1+lz_1) =tij(px:px+lx,py:py+ly,1+lz_2)

! overwrite edges
   tij(px,py,1:1+lz-1) = 0.5_rprec*(tij(px-1,py,1:1+lz-1)+&
        tij(px,py-1,1:1+lz-1))
   tij(px-1,py-1,1:1+lz-1) = tij(px,py,1:1+lz-1)

   tij(px+lx,py,1:1+lz-1) = 0.5_rprec*(tij(px+lx+1,py,1:1+lz-1)+&
        tij(px+lx,py-1,1:1+lz-1))
   tij(px+lx+1,py-1,1:1+lz-1) = tij(px+lx,py,1:1+lz-1)

   tij(px+lx,py+ly,1:1+lz-1) = 0.5_rprec*(tij(px+lx+1,py+ly,1:1+lz-1)+&
        tij(px+lx,py+ly+1,1:1+lz-1))
   tij(px+lx+1,py+ly+1,1:1+lz-1) = tij(px+lx,py+ly,1:1+lz-1)

   tij(px,py+ly,1:1+lz-1) = 0.5_rprec*(tij(px-1,py+ly,1:1+lz-1)+&
        tij(px,py+ly+1,1:1+lz-1))
   tij(px-1,py+ly+1,1:1+lz-1) = tij(px,py+ly,1:1+lz-1)

! roof edges
   tij(px+1:px+lx-1,py,1+lz) = 0.5_rprec*(tij(px+1:px+lx-1,py-1,1+lz)+&
        tij(px+1:px+lx-1,py,1+lz_1))
   tij(px+1:px+lx-1,py-1,1+lz_1) = tij(px+1:px+lx-1,py,1+lz)

   tij(px+lx,py+1:py+ly-1,1+lz) =0.5_rprec*(tij(px+lx+1,py+1:py+ly-1,1+lz)+&
        tij(px+lx,py+1:py+ly-1,1+lz_1))
   tij(px+lx+1,py+1:py+ly-1,1+lz_1) = tij(px+lx,py+1:py+ly-1,1+lz) 

   tij(px+1:px+lx-1,py+ly,1+lz) =0.5_rprec*(tij(px+1:px+lx-1,py+ly+1,1+lz)+&
        tij(px+1:px+lx-1,py+ly,1+lz_1))
   tij(px+1:px+lx-1,py+ly+1,1+lz_1) = tij(px+1:px+lx-1,py+ly,1+lz)

   tij(px,py+1:py+ly-1,1+lz) =0.5_rprec*(tij(px-1,py+1:py+ly-1,1+lz)+&
        tij(px,py+1:py+ly-1,1+lz_1))
   tij(px-1,py+1:py+ly-1,1+lz_1) = tij(px,py+1:py+ly-1,1+lz) 

!  the corners
   tij(px-1,py,1+lz) = tij(px-2,py,1+lz)
   tij(px,py-1,1+lz) = tij(px,py-2,1+lz)
   tij(px,py,1+lz_1) = tij(px,py,1+lz_2)
   tij(px,py,1+lz)= (1._rprec/3._rprec)*(tij(px-1,py,1+lz)&
        +tij(px,py-1,1+lz)+tij(px,py,1+lz_1))

   tij(px+lx+1,py,1+lz) = tij(px+lx+2,py,1+lz)
   tij(px+lx,py-1,1+lz) = tij(px+lx,py-2,1+lz)
   tij(px+lx,py,1+lz_1) = tij(px+lx,py,1+lz_2)
   tij(px+lx,py,1+lz)= (1._rprec/3._rprec)*(tij(px+lx+1,py,1+lz)&
        +tij(px+lx,py-1,1+lz)+tij(px+lx,py,1+lz_1))

   tij(px+lx+1,py+ly,1+lz) = tij(px+lx+2,py+ly,1+lz)
   tij(px+lx,py+ly+1,1+lz) = tij(px+lx,py+ly+2,1+lz)
   tij(px+lx,py+ly,1+lz_1) = tij(px+lx,py+ly,1+lz_2)
   tij(px+lx,py+ly,1+lz)= (1._rprec/3._rprec)*(tij(px+lx+1,py+ly,1+lz)&
        +tij(px+lx,py+ly+1,1+lz)+tij(px+lx,py+ly,1+lz_1))

   tij(px-1,py+ly,1+lz) = tij(px-2,py+ly,1+lz)
   tij(px,py+ly+1,1+lz) = tij(px,py+ly+2,1+lz)
   tij(px,py+ly,1+lz_1) = tij(px,py+ly,1+lz_2)
   tij(px,py+ly,1+lz)= (1._rprec/3._rprec)*(tij(px-1,py+ly,1+lz)&
        +tij(px,py+ly+1,1+lz)+tij(px,py+ly,1+lz_1))

! interior
   if (callag) then
      do jz = 1,lz
         npoints=2._rprec*(lx+ly+2)
         avg=(1._rprec/npoints)*(SUM(tij(px:px+lx,py,jz))&
              +SUM(tij(px:px+lx,py+ly,jz))&
              +SUM(tij(px,py:py+ly,jz))&
              +SUM(tij(px+lx,py:py+ly,jz)))
         tij(px+1:px+lx-1,py+1:py+ly-1,jz) = avg
      end do
   else
      tij(px+1:px+lx-1,py+1:py+ly-1,1:1+lz-1) = 0._rprec
   end if
end do
end subroutine bldg_stress_extrapol

!TS SUBROUTINES FOR CUBIC SPLINE INTERPOLATION
SUBROUTINE bcuint(y,y1,y2,y12,x1dif,x2dif,M,N,x1,x2,ansy,jz)
implicit none
INTEGER::M,N,jz
REAL(KIND=rprec),INTENT(IN)::x1dif,x2dif
REAL(KIND=rprec),DIMENSION(M),INTENT(IN)::x1
REAL(KIND=rprec),DIMENSION(N),INTENT(IN)::x2
REAL(KIND=rprec),DIMENSION(M,N),INTENT(INOUT)::ansy
REAL(KIND=rprec),INTENT(IN)::y(4),y1(4),y12(4),y2(4)
INTEGER::i,j,k
REAL(KIND=rprec)::t,u
REAL(KIND=rprec),DIMENSION(4,4)::c
call bcucof(y,y1,y2,y12,x1dif,x2dif,c)
!if(jz.eq.16)then
!   print*,'y1',real(y),x1dif,x2dif
!   print*,'x12',x1,x2
!endif
if(x1dif.eq.0._rprec.or.x2dif.eq.0._rprec)stop 'bad input in bcuint'
do j=2,N-1
do i=2,M-1
t=x1(i)/x1dif
u=x2(j)/x2dif
ansy(i,j)=0._rprec
do k=4,1,-1
   ansy(i,j)=t*ansy(i,j)+((c(k,4)*u+c(k,3))*u+c(k,2))*u+c(k,1)
enddo
enddo
enddo
END SUBROUTINE bcuint

SUBROUTINE bcucof(y,y1,y2,y12,d1,d2,c)
IMPLICIT NONE
REAL(KIND=rprec), INTENT(IN) :: d1,d2
REAL(KIND=rprec), DIMENSION(4), INTENT(IN) :: y,y1,y2,y12
REAL(KIND=rprec), DIMENSION(4,4), INTENT(OUT) :: c
REAL(KIND=rprec), DIMENSION(16) :: x
REAL(KIND=rprec), DIMENSION(16,16) :: wt
DATA wt /1,0,-3,2,4*0,-3,0,9,-6,2,0,-6,4,&
     8*0,3,0,-9,6,-2,0,6,-4,10*0,9,-6,2*0,-6,4,2*0,3,-2,6*0,-9,6,&
     2*0,6,-4,4*0,1,0,-3,2,-2,0,6,-4,1,0,-3,2,8*0,-1,0,3,-2,1,0,-3,&
     2,10*0,-3,2,2*0,3,-2,6*0,3,-2,2*0,-6,4,2*0,3,-2,0,1,-2,1,5*0,&
     -3,6,-3,0,2,-4,2,9*0,3,-6,3,0,-2,4,-2,10*0,-3,3,2*0,2,-2,2*0,&
     -1,1,6*0,3,-3,2*0,-2,2,5*0,1,-2,1,0,-2,4,-2,0,1,-2,1,9*0,-1,2,&
     -1,0,1,-2,1,10*0,1,-1,2*0,-1,1,6*0,-1,1,2*0,2,-2,2*0,-1,1/
x(1:4)=y
x(5:8)=y1*d1
x(9:12)=y2*d2
x(13:16)=y12*d1*d2
x=matmul(wt,x)
c=reshape(x,(/4,4/),order=(/2,1/))
END SUBROUTINE bcucof
end module immersedbc

! this is the w-node version
subroutine lagrange_Sdep(S11,S12,S13,S22,S23,S33,jt)
! standard dynamic model to calculate the Smagorinsky coefficient
! this is done layer-by-layer to save memory
! everything is done to be on uv-nodes
! -note: we need to calculate |S| here, too.
! stuff is done on uv-nodes
! can save more mem if necessary. mem requirement ~ n^2, not n^3
use types,only:rprec
use param,only:ld,lh,nx,ny,nz,dx,dy,dz,dt,cs_count
use sim_param,only:u,v,w
use sgsmodule,only:F_LM,F_MM,F_QN,F_NN,beta,initest,dyn_count,Cs_opt2
use test_filtermodule
implicit none
integer :: jx,jy,jz,jt
integer :: countmc_s(nz),countmc_b(nz)
real(kind=rprec), dimension(ld,ny,nz+1) :: w_nod

real(kind=rprec) :: u_rms,v_rms,uw_rms,w_rms,u_av,v_av,w_av
real(kind=rprec), dimension(nx,ny) :: u_pr,v_pr,w_pr
real(kind=rprec) :: fractus

real(kind=rprec), dimension(ld,ny,nz) :: S11,S12,S13,S22,S23,S33
real(kind=rprec), dimension(ld,ny,nz) :: Cs_opt2_2delta
real(kind=rprec), dimension(ld,ny) :: L11,L12,L13,L22,L23,L33
real(kind=rprec), dimension(ld,ny) :: Q11,Q12,Q13,Q22,Q23,Q33
real(kind=rprec), dimension(ld,ny) :: M11,M12,M13,M22,M23,M33
real(kind=rprec), dimension(ld,ny) :: N11,N12,N13,N22,N23,N33
real(kind=rprec), dimension(ld,ny) :: N11_,N12_,N13_,N22_,N23_,N33_
real(kind=rprec), dimension(ld,ny) :: L11_,L12_,L13_,L22_,L23_,L33_
real(kind=rprec), dimension(ld,ny) :: Q11_,Q12_,Q13_,Q22_,Q23_,Q33_
real(kind=rprec), dimension(ld,ny) :: M11_,M12_,M13_,M22_,M23_,M33_

real(kind=rprec), dimension(nz) :: LMvert,MMvert,QNvert,NNvert
      
real(kind=rprec), dimension(ld,ny) :: LM,MM,QN,NN,Tn,epsi,dumfac
real(kind=rprec), dimension(ld,ny) :: fourbeta

real(kind=rprec), dimension(ld,ny) :: S_bar,S11_bar,S12_bar,&
     S13_bar,S22_bar,S23_bar,S33_bar,S_S11_bar, S_S12_bar,&
     S_S13_bar, S_S22_bar, S_S23_bar, S_S33_bar

real(kind=rprec), dimension(ld,ny) :: S_hat,S11_hat,S12_hat,&
     S13_hat,S22_hat,S23_hat,S33_hat,S_S11_hat, S_S12_hat,&
     S_S13_hat, S_S22_hat, S_S23_hat, S_S33_hat
real(kind=rprec), dimension(ld,ny) :: u_bar,v_bar,w_bar
real(kind=rprec), dimension(ld,ny) :: u_hat,v_hat,w_hat
!     hat is tilda, bar, hat, three filterings
real(kind=rprec), dimension(ld,ny) :: S
real(kind=rprec) :: delta,const,const2
real(kind=rprec) :: lagran_dt,opftdelta,powcoeff

if (initest .ne. 2) then
   print*, 'Beta initialized'
   Beta (:,:,:)  = 1
end if

delta = filter_size*(dx*dy*dz)**(1._rprec/3._rprec)
opftdelta = 1.5_rprec*delta
powcoeff = -1.0_rprec/8.0_rprec


lagran_dt=dt*real(dyn_count,kind=rprec)
!! (this is the time step used in the lagrangian computations)
call interpolag_Sdep(jt)
fractus= 1._rprec/(ny*nx)

do jz =1,nz
   w_nod(:,:,jz) = (w(:,:,jz)+w(:,:,jz+1))/2._rprec
end do
w_nod(:,:,nz+1) = w(:,:,nz)
const = 2._rprec*delta**2
const2 = 2._rprec*(2._rprec*delta)**2

do jz = nz,1,-1
! using L_ij as temp storage here
!!! watch the 0.25's:  recall w = c*z^2 close to wall, so get 0.25
   if (jz == 1) then  ! put on uvp-nodes
      L11(:,:) = u(:,:,1)*u(:,:,1)  ! uv-node
      L12(:,:) = u(:,:,1)*v(:,:,1)  ! uv-node
      L13(:,:) = u(:,:,1)*0.25_rprec*w(:,:,2)  ! parabolic interp.
      L22(:,:) = v(:,:,1)*v(:,:,1)  ! uv-node
      L23(:,:) = v(:,:,jz)*0.25_rprec*w(:,:,2)  ! uv-node
      L33(:,:) = (0.25_rprec*w(:,:,2))**2  ! uv-node
      u_bar(:,:) = u(:,:,1)
      v_bar(:,:) = v(:,:,1)
      w_bar(:,:) = 0.25_rprec*w(:,:,2)
   else  ! w-nodes
      L11(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*&
           0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))
      L12(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*&
           0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      L13(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))*w(:,:,jz)
      L22(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))*&
           0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      L23(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))*w(:,:,jz)
      L33(:,:) = w(:,:,jz)*w(:,:,jz)
      u_bar(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))
      v_bar(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      w_bar(:,:) = w(:,:,jz)
   end if

   
   call test_filter(u_bar,G_test)
   call test_filter(v_bar,G_test)
   call test_filter(w_bar,G_test)
   call test_filter(L11,G_test)  ! in-place filtering
   L11 = L11 - u_bar*u_bar
   call test_filter(L12,G_test)
   L12 = L12 - u_bar*v_bar
   call test_filter(L13,G_test)
   L13 = L13 - u_bar*w_bar
   call test_filter(L22,G_test)
   L22 = L22 - v_bar*v_bar
   call test_filter(L23,G_test)
   L23 = L23 - v_bar*w_bar
   call test_filter(L33,G_test)
   L33 = L33 - w_bar*w_bar

! would be neat to have some rotating storage or something so we don't 
!   have to do this (use pointers)
   u_hat = u_bar
   v_hat = v_bar
   w_hat = w_bar
   Q11 = u_bar*u_bar
   Q12 = u_bar*v_bar
   Q13 = u_bar*w_bar
   Q22 = v_bar*v_bar
   Q23 = v_bar*w_bar
   Q33 = w_bar*w_bar

   call test_filter(u_hat,G_test_test)
   call test_filter(v_hat,G_test_test)
   call test_filter(w_hat,G_test_test)
   call test_filter(Q11,G_test_test)
   Q11 = Q11 - u_hat*u_hat
   call test_filter(Q12,G_test_test)
   Q12 = Q12 - u_hat*v_hat
   call test_filter(Q13,G_test_test)
   Q13 = Q13 - u_hat*w_hat
   call test_filter(Q22,G_test_test)
   Q22 = Q22 - v_hat*v_hat
   call test_filter(Q23,G_test_test)
   Q23 = Q23 - v_hat*w_hat
   call test_filter(Q33,G_test_test)
   Q33 = Q33 - w_hat*w_hat

! calculate |S|
   S(:,:) = sqrt(2._rprec*(S11(:,:,jz)**2 + S22(:,:,jz)**2 + &
        S33(:,:,jz)**2 + 2._rprec*(S12(:,:,jz)**2 + &
        S13(:,:,jz)**2 + S23(:,:,jz)**2)))

! S_ij already on w-nodes
   S11_bar(:,:) = S11(:,:,jz)  
   S12_bar(:,:) = S12(:,:,jz)  
   S13_bar(:,:) = S13(:,:,jz)  
   S22_bar(:,:) = S22(:,:,jz)  
   S23_bar(:,:) = S23(:,:,jz)  
   S33_bar(:,:) = S33(:,:,jz)  
   
   call test_filter(S11_bar,G_test)
   call test_filter(S12_bar,G_test)
   call test_filter(S13_bar,G_test)
   call test_filter(S22_bar,G_test)
   call test_filter(S23_bar,G_test)
   call test_filter(S33_bar,G_test)
   
   
   S11_hat = S11_bar
   S12_hat = S12_bar
   S13_hat = S13_bar
   S22_hat = S22_bar
   S23_hat = S23_bar
   S33_hat = S33_bar
   
   call test_filter(S11_hat,G_test_test)
   call test_filter(S12_hat,G_test_test)
   call test_filter(S13_hat,G_test_test)
   call test_filter(S22_hat,G_test_test)
   call test_filter(S23_hat,G_test_test)
   call test_filter(S33_hat,G_test_test)

   S_bar = sqrt(2._rprec*(S11_bar**2 + S22_bar**2 + S33_bar**2 + & 
        2._rprec*(S12_bar**2 + S13_bar**2 + S23_bar**2)))
   S_hat = sqrt(2._rprec*(S11_hat**2 + S22_hat**2 + S33_hat**2 + &
        2._rprec*(S12_hat**2 + S13_hat**2 + S23_hat**2)))

   S_S11_bar(:,:) = S(:,:)*S11(:,:,jz)
   S_S12_bar(:,:) = S(:,:)*S12(:,:,jz)
   S_S13_bar(:,:) = S(:,:)*S13(:,:,jz)
   S_S22_bar(:,:) = S(:,:)*S22(:,:,jz)
   S_S23_bar(:,:) = S(:,:)*S23(:,:,jz)
   S_S33_bar(:,:) = S(:,:)*S33(:,:,jz)
   
   call test_filter(S_S11_bar,G_test)
   call test_filter(S_S12_bar,G_test)
   call test_filter(S_S13_bar,G_test)
   call test_filter(S_S22_bar,G_test)
   call test_filter(S_S23_bar,G_test)
   call test_filter(S_S33_bar,G_test)     

   S_S11_hat(:,:) = S_bar(:,:)*S11_bar(:,:)
   S_S12_hat(:,:) = S_bar(:,:)*S12_bar(:,:)
   S_S13_hat(:,:) = S_bar(:,:)*S13_bar(:,:)
   S_S22_hat(:,:) = S_bar(:,:)*S22_bar(:,:)
   S_S23_hat(:,:) = S_bar(:,:)*S23_bar(:,:)
   S_S33_hat(:,:) = S_bar(:,:)*S33_bar(:,:)
   
   call test_filter(S_S11_hat,G_test_test)
   call test_filter(S_S12_hat,G_test_test)
   call test_filter(S_S13_hat,G_test_test)
   call test_filter(S_S22_hat,G_test_test)
   call test_filter(S_S23_hat,G_test_test)
   call test_filter(S_S33_hat,G_test_test)  

! now put beta back into M_ij
   fourbeta=4._rprec*Beta(:,:,jz)
!	print*, fourbeta

! it might be faster just to go ahead and not store M_ij--just code directly

   M11 = const*(S_S11_bar - fourbeta*S_bar*S11_bar)
   M12 = const*(S_S12_bar - fourbeta*S_bar*S12_bar)
   M13 = const*(S_S13_bar - fourbeta*S_bar*S13_bar)
   M22 = const*(S_S22_bar - fourbeta*S_bar*S22_bar)
   M23 = const*(S_S23_bar - fourbeta*S_bar*S23_bar)
   M33 = const*(S_S33_bar - fourbeta*S_bar*S33_bar)
  
   N11 = const2*(S_S11_hat - fourbeta*S_hat*S11_hat)
   N12 = const2*(S_S12_hat - fourbeta*S_hat*S12_hat)
   N13 = const2*(S_S13_hat - fourbeta*S_hat*S13_hat)
   N22 = const2*(S_S22_hat - fourbeta*S_hat*S22_hat)
   N23 = const2*(S_S23_hat - fourbeta*S_hat*S23_hat)
   N33 = const2*(S_S33_hat - fourbeta*S_hat*S33_hat)

   if(jz==3) then
      N11_ = N11
      N12_ = N12
      N13_ = N13
      N23_ = N23
      N22_ = N22
      N33_ = N33
      L11_ = L11
      L12_ = L12
      L13_ = L13
      L23_ = L23
      L22_ = L22
      L33_ = L33
      Q11_ = Q11
      Q12_ = Q12
      Q13_ = Q13
      Q23_ = Q23
      Q22_ = Q22
      Q33_ = Q33
      M11_ = M11
      M12_ = M12
      M13_ = M13
      M23_ = M23
      M22_ = M22
      M33_ = M33
   else if ((jz==1) .OR. (jz==2)) then
      N11 = N11_
      N12 = N12_
      N13 = N13_
      N23 = N23_
      N22 = N22_
      N33 = N33_
      M11 = M11_
      M12 = M12_
      M13 = M13_
      M23 = M23_
      M22 = M22_
      M33 = M33_
      L11 = L11_
      L12 = L12_
      L13 = L13_
      L23 = L23_
      L22 = L22_
      L33 = L33_
      Q11 = Q11_
      Q12 = Q12_
      Q13 = Q13_
      Q23 = Q23_
      Q22 = Q22_
      Q33 = Q33_
   end if

   LM = L11*M11 + L22*M22 + L33*M33 + 2._rprec*(L12*M12 + L13*M13 + L23*M23)
   MM = M11**2 + M22**2 + M33**2 + 2._rprec*(M12**2 + M13**2 + M23**2)
   QN = Q11*N11 + Q22*N22 + Q33*N33 + 2._rprec*(Q12*N12 + Q13*N13 + Q23*N23)
   NN = N11**2 + N22**2 + N33**2 + 2._rprec*(N12**2 + N13**2 + N23**2)

! not an efficient initialization
   if (initest .ne. 2) then
!          print *,'F_MM and F_LM initialized' 
      F_MM (:,:,jz) = MM
      F_LM (:,:,jz) = .025_rprec*MM
      F_NN (:,:,jz) = NN
      F_QN (:,:,jz) = .025_rprec*NN
   end if

   Tn=opftdelta*((F_LM(:,:,jz)*F_MM(:,:,jz))**powcoeff)
   dumfac = lagran_dt/Tn
   epsi = dumfac / (1._rprec+dumfac)

   F_LM(:,:,jz)=(epsi*LM + (1._rprec-epsi)*F_LM(:,:,jz))
   F_MM(:,:,jz)=(epsi*MM + (1._rprec-epsi)*F_MM(:,:,jz))
   F_LM(:,:,jz)= max(real(1E-32),real(F_LM(:,:,jz)))
   Cs_opt2(:,:,jz) = F_LM(:,:,jz)/F_MM(:,:,jz)
   Cs_opt2(ld,:,jz) = 0._rprec
   Cs_opt2(ld-1,:,jz) = 0._rprec

   Tn=opftdelta*2._rprec*((F_QN(:,:,jz)*F_NN(:,:,jz))**powcoeff)
   dumfac = lagran_dt/Tn
   epsi = dumfac / (1._rprec+dumfac)

   F_QN(:,:,jz)=(epsi*QN + (1._rprec-epsi)*F_QN(:,:,jz))
   F_NN(:,:,jz)=(epsi*NN + (1._rprec-epsi)*F_NN(:,:,jz))
   F_QN(:,:,jz)= max(real(1E-32),real(F_QN(:,:,jz)))
   Cs_opt2_2delta(:,:,jz) = F_QN(:,:,jz)/F_NN(:,:,jz)
   Cs_opt2_2delta(ld,:,jz) = 0._rprec
   Cs_opt2_2delta(ld-1,:,jz) = 0._rprec
   
   Beta(:,:,jz) = (Sum(F_QN(:,:,jz))/Sum(F_NN(:,:,jz)))/&
                      (Sum(F_LM(:,:,jz))/Sum(F_MM(:,:,jz)))
!	end if
   Beta(ld,:,jz) = 0._rprec
   Beta(ld-1,:,jz) = 0._rprec
  
   if (mod(jt,100) == 0) then
      if (jz==1) then
         do jy= 1,ny
            write(90,5168) jt*dt,float(jz),(LM(jx,jy),jx=1,nx)
            write(91,5168) jt*dt,float(jz),(MM(jx,jy),jx=1,nx)
            write(92,5168) jt*dt,float(jz),(F_LM(jx,jy,jz),jx=1,nx)
            write(93,5168) jt*dt,float(jz),(F_MM(jx,jy,jz),jx=1,nx)
            write(94,5168) jt*dt,float(jz),(LM(jx,jy)/MM(jx,jy),jx=1,nx)
            write(70,5168) jt*dt,float(jz),(QN(jx,jy),jx=1,nx)
            write(71,5168) jt*dt,float(jz),(NN(jx,jy),jx=1,nx)
            write(72,5168) jt*dt,float(jz),(F_QN(jx,jy,jz),jx=1,nx)
            write(73,5168) jt*dt,float(jz),(F_NN(jx,jy,jz),jx=1,nx)
            write(74,5168) jt*dt,float(jz),(QN(jx,jy)/NN(jx,jy),jx=1,nx)  
         end do
      end if
      
      if (jz==nz/2) then
         do jy= 1,ny
            write(90,5168) jt*dt,float(jz),(LM(jx,jy),jx=1,nx)
            write(91,5168) jt*dt,float(jz),(MM(jx,jy),jx=1,nx)
            write(92,5168) jt*dt,float(jz),(F_LM(jx,jy,jz),jx=1,nx)
            write(93,5168) jt*dt,float(jz),(F_MM(jx,jy,jz),jx=1,nx)
            write(94,5168) jt*dt,float(jz),(LM(jx,jy)/MM(jx,jy),jx=1,nx)
            write(70,5168) jt*dt,float(jz),(QN(jx,jy),jx=1,nx)
            write(71,5168) jt*dt,float(jz),(NN(jx,jy),jx=1,nx)
            write(72,5168) jt*dt,float(jz),(F_QN(jx,jy,jz),jx=1,nx)
            write(73,5168) jt*dt,float(jz),(F_NN(jx,jy,jz),jx=1,nx)
            write(74,5168) jt*dt,float(jz),(QN(jx,jy)/NN(jx,jy),jx=1,nx)
         end do
      end if
      if (jz==nz-2) then
         do jy= 1,ny
            write(90,5168) jt*dt,float(jz),(LM(jx,jy),jx=1,nx)
            write(91,5168) jt*dt,float(jz),(MM(jx,jy),jx=1,nx)
            write(92,5168) jt*dt,float(jz),(F_LM(jx,jy,jz),jx=1,nx)
            write(93,5168) jt*dt,float(jz),(F_MM(jx,jy,jz),jx=1,nx)
            write(94,5168) jt*dt,float(jz),(LM(jx,jy)/MM(jx,jy),jx=1,nx)
            write(70,5168) jt*dt,float(jz),(QN(jx,jy),jx=1,nx)
            write(71,5168) jt*dt,float(jz),(NN(jx,jy),jx=1,nx)
            write(72,5168) jt*dt,float(jz),(F_QN(jx,jy,jz),jx=1,nx)
            write(73,5168) jt*dt,float(jz),(F_NN(jx,jy,jz),jx=1,nx)
            write(74,5168) jt*dt,float(jz),(QN(jx,jy)/NN(jx,jy),jx=1,nx)
         end do
      end if
   end if

   if (mod(jt,50) == 0) then
      LMvert(jz) = sum(sum(LM,DIM=1),DIM=1)/ny/nx
      MMvert(jz) = sum(sum(MM,DIM=1),DIM=1)/ny/nx
      QNvert(jz) = sum(sum(QN,DIM=1),DIM=1)/ny/nx
      NNvert(jz) = sum(sum(NN,DIM=1),DIM=1)/ny/nx
   end if
   
   if (mod(jt,10)==0 .AND. jt>1) then
      
      u_av  = sum(sum(u(:,:,jz),DIM=1),DIM=1)*fractus
      v_av  = sum(sum(v(:,:,jz),DIM=1),DIM=1)*fractus
      w_av  = sum(sum(w_nod(:,:,jz),DIM=1),DIM=1)*fractus
      
      do jx=1,nx
         u_pr (jx,:) = u(jx,:,jz)-u_av
         v_pr (jx,:) = v(jx,:,jz)-v_av
         w_pr (jx,:) = w_nod(jx,:,jz)-w_av
      end do

      u_rms = sum(sum((u_pr*u_pr),DIM=1),DIM=1)*fractus
      v_rms = sum(sum((v_pr*v_pr),DIM=1),DIM=1)*fractus
      w_rms = sum(sum((w_pr*w_pr),DIM=1),DIM=1)*fractus
      uw_rms=- sum(sum((u_pr*w_pr),DIM=1),DIM=1)*fractus
      
      write(96,5200) jt*dz,u_av,u_rms,v_rms,w_rms,uw_rms
      
   end if
5168 format(1400(E14.5))
5200 format(130(E14.5))
   
   write(99,5300) jt*dz,u(4,16,16),v(16,16,16),w(16,16,16)

5300 format(82(E14.5))

! this ends the main jz=1-nz loop          
end do
Cs_opt2(:,:,2)=Cs_opt2(:,:,3)/2._rprec
Cs_opt2(:,:,1)=Cs_opt2(:,:,3)/4._rprec
Cs_opt2_2delta(:,:,2)=Cs_opt2_2delta(:,:,3)/2._rprec
Cs_opt2_2delta(:,:,1)=Cs_opt2_2delta(:,:,3)/4._rprec
!	countmc_b(:)=0
!	countmc_s(:)=0
!	do jx=1,nx
!	do jy=1,ny
!	do jz=1,nz
!	if (Beta(jx,jy,jz) .LT. (0.5d0*dfloat(jz)/dfloat(nz))) then
!	Beta(jx,jy,jz) = (0.5d0*dfloat(jz)/dfloat(nz))
!	countmc_s(jz)=countmc_s(jz)+1
!	if (Beta(jx,jy,jz) .GT. 1.2d0) then
!	Beta(jx,jy,jz) = 1.2d0
!	countmc_b(jz)=countmc_b(jz)+1
!	end if
!	end do
!	end do
!	end do

!	print*, sum(Beta(:,:,:)/nx/ny/nz)

!      Cs_opt2(:,:,nz) = Cs_opt2(:,:,nz-1)

initest = 2
if (mod(jt,50) == 0) then
   write(79,5130) jt*dt,sum(sum(Cs_opt2,DIM=1),DIM=1)/ny/nx
   write(61,5130) jt*dt,sum(sum(Cs_opt2_2delta,DIM=1),DIM=1)/ny/nx
   write(63,5130) jt*dt,sum(sum(Beta,DIM=1),DIM=1)/ny/nx
   
   write(65,5130) jt*dt,sum(sum(F_LM,DIM=1),DIM=1)/ny/nx
   write(66,5130) jt*dt,sum(sum(F_MM,DIM=1),DIM=1)/ny/nx
   write(67,5130) jt*dt,LMvert
   write(68,5130) jt*dt,MMvert
   
   write(45,5130) jt*dt,sum(sum(F_QN,DIM=1),DIM=1)/ny/nx
   write(46,5130) jt*dt,sum(sum(F_NN,DIM=1),DIM=1)/ny/nx
   write(47,5130) jt*dt,QNvert
   write(48,5130) jt*dt,NNvert
end if
!	 if (mod(jt,5) == 0 .AND. jt<51) then
!          do jy= 1,ny
!          write(98,5168) jt*dt,2,(Cs_opt2(jx,jy,2),jx=1,nx)
!         end do
!          do jy= 1,ny
!          write(98,5168) jt*dt,12,(Cs_opt2(jx,jy,12),jx=1,nx)
!          end do
!          do jy= 1,ny
!          write(98,5168) jt*dt,22,(Cs_opt2(jx,jy,22),jx=1,nx)
!          end do
!          end if
!	 if (mod(jt,50) == 0 .AND. (jt>51 .AND. jt<1000)) then
!         do jy= 1,ny
!          write(98,5168) jt*dt,2,(Cs_opt2(jx,jy,2),jx=1,nx)
!         end do
!          do jy= 1,ny
!          write(98,5168) jt*dt,12,(Cs_opt2(jx,jy,12),jx=1,nx)
!          end do
!          do jy= 1,ny
!          write(98,5168) jt*dt,22,(Cs_opt2(jx,jy,22),jx=1,nx)
!          end do
!          end if
if (mod(jt,100) == 0) then
   
   do jy= 1,ny
      write(78,5168) jt*dt,1.0,(Cs_opt2(jx,jy,1),jx=1,nx)
      write(60,5168) jt*dt,1.0,(Cs_opt2_2delta(jx,jy,1),jx=1,nx)
      write(62,5168) jt*dt,1.0,(Beta(jx,jy,1),jx=1,nx)
   end do
  
   do jy= 1,ny
      write(78,5168) jt*dt,nz/2,(Cs_opt2(jx,jy,nz/2),jx=1,nx)
      write(60,5168) jt*dt,nz/2,(Cs_opt2_2delta(jx,jy,nz/2),jx=1,nx)
      write(62,5168) jt*dt,nz/2,(Beta(jx,jy,nz/2),jx=1,nx)
   end do

   do jy= 1,ny
      write(78,5168) jt*dt,nz-2,(Cs_opt2(jx,jy,nz-2),jx=1,nx)
      write(60,5168) jt*dt,nz-2,(Cs_opt2_2delta(jx,jy,nz-2),jx=1,nx)
      write(62,5168) jt*dt,nz-2,(Beta(jx,jy,nz-2),jx=1,nx)
   end do

end if
!        do jz = 1,nz
!	Cs_opt2(:,:,jz)=Cs_opt2_tempo(jz)
!	end do
5130 format(2100(E14.5))
end subroutine lagrange_Sdep

subroutine ddy (dfdy, f)              
! f remains untouched
use types,only:rprec
use param,only:lh,nx,ny,nz,dz
use fft
implicit none      
integer::jz
complex(kind=rprec),dimension(lh,ny,nz),intent(in)::f
complex(kind=rprec),dimension(lh,ny,nz),intent(inout)::dfdy
real(kind=rprec)::const, ignore_me

const=1._rprec/(nx*ny)   
! Loop through horizontal slices
do jz=1,nz
! temporary storage in dfdx
   dfdy(:,:,jz)=const*f(:,:,jz)
   call rfftwnd_f77_one_real_to_complex(forw,dfdy(:,:,jz),ignore_me)       
! oddballs
   dfdy(lh,:,jz)=0._rprec
   dfdy(:,ny/2+1,jz)=0._rprec
! compute coefficients for pseudospectral derivative calculation.
   dfdy(:,:,jz)=eye*ky(:,:)*dfdy(:,:,jz)
! inverse transform to get pseudospectral derivative.
   call rfftwnd_f77_one_complex_to_real(back,dfdy(:,:,jz),ignore_me)
end do
end subroutine ddy

module bottombc
use types,only:rprec
use param,only:nx,ny,ld
implicit none
! num_patch= numbr of patches, zo?=surface roughness for the patches types
! ptypes=number of pacthes types to be used, usually we use 2
integer,parameter::num_patch=1,ptypes=2
real(kind=rprec),parameter::zo1=.025_rprec,zo2=.25_rprec
integer,parameter::square=0
real(kind=rprec),parameter::zo_out=.025_rprec, zo_square=.25_rprec
integer,parameter::Nx_sq=5,Ny_sq=3
real(kind=rprec),parameter::t_scale=300._rprec
real(kind=rprec),parameter::theta_s1=300._rprec,theta_s2=300._rprec
real(kind=rprec),parameter::q_s1=11._rprec,q_s2=13._rprec
real(kind=rprec),dimension(nx,ny)::zo,T_s,q_s
!TS add for non-neutral case
real(kind=rprec),dimension(nx,ny)::phi_m,psi_m
integer,dimension(nx,ny)::patch
integer,dimension(num_patch)::patchnum

contains
subroutine patches()
! looks like this sets the roughness for the different patches
! and fills the lookup tables patch and patchnum
!use types,only:rprec
use param,only:z_i
implicit none

integer::i, j, patchtype, begini, endi, type
!integer,dimension(ptypes),intent(inout)::patchnum
!integer,dimension(nx,ny),intent(inout)::patch

! sc: 
! without this, some compilers may give total junk
! this was cause the u_avg to be WAY off, and so txz was WAY off, etc.
patchnum=0
!
if (square==1) then!for square patch
   zo(:,:)=zo_out/z_i
   patch(:,:)= 1
   zo(Nx/2-(Nx_sq-1)/2:Nx/2+(Nx_sq-1)/2,&
        Ny/2-(Ny_sq-1)/2:Ny/2+(Ny_sq-1)/2) = zo_square/z_i
   patch(Nx/2-(Nx_sq-1)/2:Nx/2+(Nx_sq-1)/2,&
        Ny/2-(Ny_sq-1)/2:Ny/2+(Ny_sq-1)/2) = 2
!TS   patchnum(2)=Nx_sq*Ny_sq
!TS   patchnum(1)=Nx*Ny-patchnum(2)
   patchnum=Nx*Ny
else!for regular patches
   do j=1,ny
      endi = 0
      type=1
      do patchtype=1,num_patch
         begini=endi+1
         endi=(nx*patchtype)/num_patch
         do i=begini,endi
            if (type.eq.1) then
               zo(i,j)=zo1/z_i
               T_s(i,j)=theta_s1/t_scale
               q_s(i,j)=q_s1
               patch(i,j)=type
            end if
            if(type.eq.2) then
               zo(i,j)=zo2/z_i
               T_s(i,j)=theta_s2/t_scale
               q_s(i,j)=q_s2
               patch(i,j)=type
            end if
            patchnum(type)=patchnum(type)+1
          end do
          if (type.eq.1) then
             type=2
          elseif (type.eq.2) then
             type=1
          end if
       end do       
      end do
end if
end subroutine patches

subroutine avgpatch(u_avg)
! computes the averaged value of a variable (at the wall) over a patch
! and assigns it to an nx X ny array

! sc: 
! note: this is inefficient: should calculate directly to u_avg
! --no maybe its good
!use types,only:rprec
use sim_param,only:u
!use bottombc,only:ptypes
implicit none
real(kind=rprec),dimension(nx,ny),intent(inout)::u_avg
!integer,dimension(ptypes),intent(in)::patchnum
!integer,dimension(nx,ny),intent(in)::patch
integer::i,j,k
real(kind=rprec),dimension(ptypes)::temp
!real(kind=rprec),dimension(ld,ny,1),intent(in)::u

temp=0._rprec
do j=1,ny
do i=1,nx
do k=1,ptypes
   if (patch(i,j).eq.k) then
      temp(patch(i,j))=temp(patch(i,j))+u(i,j,1)/real(patchnum(patch(i,j)))
   end if
end do
end do
end do

do j=1,ny
do i=1,nx
do k=1,ptypes
   if (patch(i,j).eq.k) then
      u_avg(i,j)=real(temp(k))
   end if
end do
end do
end do
end subroutine avgpatch

end module bottombc

subroutine unpadd(cc,cc_big)
use types,only:rprec
use param,only:ld,nx,ny,ny2,nz,lh_big,lh
implicit none
integer::jx,jy
! note using 2d definitions here!
complex(kind=rprec),dimension(lh_big,ny2)::cc_big
complex(kind=rprec),dimension(lh,ny)::cc
do jy=1,ny/2
do jx=1,nx/2
   cc(jx,jy)=cc_big(jx,jy)
end do
end do
! oddballs
cc(nx/2+1,:)=0._rprec
cc(:,ny/2+1)=0._rprec
do jy=1,ny/2-1
do jx=1,nx/2
   cc(jx,jy+ny/2+1)=cc_big(jx,jy+ny2-ny/2+1)
end do
end do
end subroutine unpadd

      subroutine derivwall2 (dudz,dvdz,u,v,zo,u_avg,phi_m)
C calculates deriv at wall as suggested in Moeng '84
      implicit none
      include 'dimen.h'
      integer jx,jy
      real*8 dudz(ld,ny,nz),dvdz(ld,ny,nz),u(ld,ny,nz),v(ld,ny,nz),
     &  zo(nx,ny),ustar(nx,ny),denom,u_avg(nx,ny),
     &  psi_m(nx,ny),phi_m(nx,ny)
      real*8 const

      ustar=u_avg*vonK/(log((0.5*dz)/zo)-psi_m)
! make sure conformable
! watch the 2's!
      do jy=1,ny
        do jx=1,nx
          dudz(jx,jy,1)=ustar(jx,jy)/(0.5*dz*vonK)*phi_m(jx,jy)*
     &      u(jx,jy,1)/u_avg(jx,jy)     !this is as in Moeng 84
C sc: i dont know if this is correct yet
          dvdz(jx,jy,1)=ustar(jx,jy)/(0.5*dz*vonK)*phi_m(jx,jy)*
     &      v(jx,jy,1)/u_avg(jx,jy)    

        end do
      end do
      return
      end

      subroutine setsponge(sponge)

      implicit none
      include 'dimen.h'

      real sponge(nz),factor
      integer k

! sets relaxation term to vertical momentum equation in top quarter
! of domain, relaxation timescale on top is 50s with a factor of 5 if we
! had Nz=40 for the layers 40...31, Nieuwstadt et al. 1991, turbulent shear 
! flows

      sponge=0._rprec
      factor=9._rprec/real(nz-3*nz/4+1,kind=rprec)
      sponge(nz)=z_i/(50._rprec*u_star)
      do k=nz-1,3*nz/4+1,-1
        sponge(k)=sponge(k+1)/real(5.,kind=rprec)**factor
      end do

      return
      end

subroutine divstress_uv (divt, tx, ty, tz)
use types,only:rprec
use param,only:ld,ny,nz
implicit none
real(kind=rprec),dimension(ld,ny,nz),intent(out)::divt
real(kind=rprec),dimension(ld,ny,nz),intent(in)::tx,ty,tz
! sc: we should be able to save some memory here!
! do this by writing a divergence subroutine--then don't store deriv's 
real(kind=rprec),dimension(ld,ny,nz)::dtxdx,dtydy, dtzdz
! compute stress gradients      
call ddx(dtxdx, tx)
call ddy(dtydy, ty)
call ddz_w(dtzdz, tz)
! the following gives bas results...but it seems like i the
! issue should be taken care of somewhere
! need to correct wall level, since tz will be on uv-node there
!      dtzdz(:,:,1) = (tz(:,:,2)-tz(:,:,1))/(0.5*dz)
divt=dtxdx+dtydy+dtzdz
end subroutine divstress_uv

!...Compute rotational convective term in physical space  (X-mom eq.)
!...For staggered grid
!...u2, du2, and du4 are on W nodes, rest on UVP nodes
!...(Fixed k=Nz plane on 1/24)
!...Corrected near wall on 4/14/96 {w(DZ/2)=0.5*w(DZ)}
! sc: better to have 0.25*w(dz), since really parabolic.
subroutine convec (cx,cy,cz,u1,u2,u3,du1d2,du1d3,du2d1,du2d3,du3d1,du3d2,jt)
use types,only:rprec
use param,only:ld,ld_big,nx,nx2,ny,ny2,nz
use fft
implicit none
integer,intent(in)::jt
real(kind=rprec),dimension(ld,ny,nz)::u1,u2,u3,cx,cy,cz
real(kind=rprec),dimension(ld,ny,nz)::du1d2,du1d3,du2d1,du2d3,du3d1,du3d2
real(kind=rprec),dimension(ld_big,ny2,nz)::cc_big,u1_big,u2_big,u3_big
real(kind=rprec),dimension(ld_big,ny2,nz)::vort1_big,vort2_big,vort3_big
! should these be ``common'ed'' to save RAM?
! look elsewhere for possble ``partners''
! vorticity saves RAM and FFT time!
! note the way the vorticity/uvp/w node stuff works out nicely
integer::jz
real(kind=rprec)::ignore_me,const,factor

!..Recall dudz, and dvdz are on UVP node for k=1 only
!...So du2 does not vary from arg2a to arg2b in 1st plane (k=1)

! sc: it would be nice to NOT have to loop through slices here
! Loop through horizontal slices

const=1._rprec/(nx*ny)
!$omp parallel do default(shared) private(jz)		
do jz=1,nz
! use cx,cy,cz for temp storage here! 
   cx(:,:,jz)=const*u1(:,:,jz)
   cy(:,:,jz)=const*u2(:,:,jz)
   cz(:,:,jz)=const*u3(:,:,jz)
! do forward fft on normal-size arrays
   call rfftwnd_f77_one_real_to_complex(forw,cx(:,:,jz),ignore_me)
   call rfftwnd_f77_one_real_to_complex(forw,cy(:,:,jz),ignore_me)
   call rfftwnd_f77_one_real_to_complex(forw,cz(:,:,jz),ignore_me)
! zero pad: padd takes care of the oddballs
   call padd(u1_big(:,:,jz),cx(:,:,jz))
   call padd(u2_big(:,:,jz),cy(:,:,jz))
   call padd(u3_big(:,:,jz),cz(:,:,jz))
! now do the same, but with the vorticity!
   cx(:,:,jz)=const*(du3d2(:,:,jz)-du2d3(:,:,jz))
   cy(:,:,jz)=const*(du1d3(:,:,jz)-du3d1(:,:,jz))
   cz(:,:,jz)=const*(du2d1(:,:,jz)-du1d2(:,:,jz))

! sc: need to modify the vorticity at the wall to accomodate the 
! correction to the finite differencing error
! want to put du1d3(:,:,2)=du1d3(:,:,2)+u_star/vonK/dz*(1-log(3.))
   call rfftwnd_f77_one_real_to_complex(forw,cx(:,:,jz),ignore_me)
   call rfftwnd_f77_one_real_to_complex(forw,cy(:,:,jz),ignore_me)
   call rfftwnd_f77_one_real_to_complex(forw,cz(:,:,jz),ignore_me)
   call padd(vort1_big(:,:,jz),cx(:,:,jz))
   call padd(vort2_big(:,:,jz),cy(:,:,jz))
   call padd(vort3_big(:,:,jz),cz(:,:,jz))

! Back to physical space
! the normalization should be ok...
   call rfftwnd_f77_one_complex_to_real(back_big,u1_big(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back_big,u2_big(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back_big,u3_big(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back_big,vort1_big(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back_big,vort2_big(:,:,jz),ignore_me)
   call rfftwnd_f77_one_complex_to_real(back_big,vort3_big(:,:,jz),ignore_me)
end do
!$omp end parallel do

! CX
! redefinition of const
const=1._rprec/(nx2*ny2)

! the cc's contain the normalization factor for the upcoming fft's
cc_big(:,:,1)=const*(u2_big(:,:,1)*(-vort3_big(:,:,1))&
     +0.5_rprec*u3_big(:,:,2)*(vort2_big(:,:,2)))
! according to the comment at the beginning, dudz, dvdz are on the UVP nodes
! for jz=1.  If that's so, then why do we use the 0.5?
! whats going on at du1d3_big(:,:,1), etc.?
! I don't think these quantites are 0! Or, if don't want them, then why 0.5?

!$omp parallel do default(shared) private(jz)
do jz=2,nz-1
   cc_big(:,:,jz)=const*(u2_big(:,:,jz)*(-vort3_big(:,:,jz))&
        +0.5_rprec*(u3_big(:,:,jz+1)*(vort2_big(:,:,jz+1))&
        +u3_big(:,:,jz)*(vort2_big(:,:,jz))))
end do
!$omp end parallel do

cc_big(:,:,nz)=const*(u2_big(:,:,nz)*(-vort3_big(:,:,nz))&
     +u3_big(:,:,nz)*(vort2_big(:,:,nz)))
! doesn't this sort of assume a no stress BC on top?
! so what happens with the sponge thing?

! Loop through horizontal slices
!$omp parallel do default(shared) private(jz)	
do jz=1,nz
   call rfftwnd_f77_one_real_to_complex(forw_big,cc_big(:,:,jz),ignore_me)
! un-zero pad
! note: cc_big is going into cx!!!!
   call unpadd(cx(:,:,jz),cc_big(:,:,jz))
! Back to physical space
   call rfftwnd_f77_one_complex_to_real(back,cx(:,:,jz),ignore_me)

! sc: why aren't we using this?
! call filt_da(cx)
end do
!$omp end parallel do

! CY
! const should be 1./(nx2*ny2) here
! the cc's contain the normalization factor for the upcoming fft's
cc_big(:,:,1)=const*(u1_big(:,:,1)*(vort3_big(:,:,1))&
     +0.5_rprec*u3_big(:,:,2)*(-vort1_big(:,:,2)))
! again, what's the deal with the 0.5 and not incl (:,:,1)?
 
!$omp parallel do default(shared) private(jz)
do jz=2,nz-1
   cc_big(:,:,jz)=const*(u1_big(:,:,jz)*(vort3_big(:,:,jz))&
        +0.5_rprec*(u3_big(:,:,jz+1)*(-vort1_big(:,:,jz+1))&
        +u3_big(:,:,jz)*(-vort1_big(:,:,jz))))
end do
!$omp end parallel do
cc_big(:,:,nz)=const*(u1_big(:,:,nz)*(vort3_big(:,:,nz))&
     +u3_big(:,:,nz)*(-vort1_big(:,:,nz)))

!$omp parallel do default(shared) private(jz)		
do jz=1,nz
   call rfftwnd_f77_one_real_to_complex(forw_big,cc_big(:,:,jz),ignore_me)
 ! un-zero pad
! note: cc_big is going into cy!!!!
   call unpadd(cy(:,:,jz),cc_big(:,:,jz))

! Back to physical space
   call rfftwnd_f77_one_complex_to_real(back,cy(:,:,jz),ignore_me)

!! sc: why aren't we using this?
! call filt_da(cy)
end do
!$omp end parallel do

! CZ
! There is no convective acceleration of w at wall or at top.
cc_big(:,:,1)=0.
!$omp parallel do default(shared) private(jz)
do jz=2,nz-1
   cc_big(:,:,jz)=const*0.5_rprec*(&
        (u1_big(:,:,jz)+u1_big(:,:,jz-1))*(-vort2_big(:,:,jz))&
        +(u2_big(:,:,jz)+u2_big(:,:,jz-1))*(vort1_big(:,:,jz))&
         )
!	end if
end do
!$omp end parallel do
cc_big(:,:,nz)=0._rprec ! according to JDA paper p.242

! Loop through horizontal slices
!$omp parallel do default(shared) private(jz)		
do jz=1,nz
   call rfftwnd_f77_one_real_to_complex(forw_big,cc_big(:,:,jz),ignore_me)

! un-zero pad
! note: cc_big is going into cz!!!!
   call unpadd(cz(:,:,jz),cc_big(:,:,jz))

! Back to physical space
   call rfftwnd_f77_one_complex_to_real(back,cz(:,:,jz),ignore_me)

! sc: why aren't we using this?
! call filt_da(cz)
end do
!$omp end parallel do
end subroutine convec

! this is the w-node version
      subroutine interpolag_Sdep(jt)
! This subroutine computes the values of F_LM and F_MM 
! at positions (x-u*dt) for use in the subroutine lagrangian
use types,only:rprec
use param,only:ld,nx,ny,nz,dx,dy,dz,dt
use sgsmodule
implicit none
integer :: jx, jy, jz ,jt
integer :: jjx, jjy, jjz
real(kind=rprec), dimension(ld,ny,nz) :: xp, yp, zp
real(kind=rprec) :: frac_x,frac_y,frac_z
real(kind=rprec) :: comp_x,comp_y,comp_z
real(kind=rprec), dimension(nx+2,ny+2,nz+2) :: FF_LM,FF_MM
real(kind=rprec), dimension(nx+2,ny+2,nz+2) :: FF_QN,FF_NN

integer :: addx, addy, addz
integer :: jxaddx, jyaddy, jzaddz
real(kind=rprec), dimension(ld,ny,nz) :: u_temp, v_temp
real(kind=rprec)::test_dyn_count
      
!     creates dummy arrays FF_LM and FF_MM to use in the subroutine
 
do jx=1,nx
do jy=1,ny
do jz=1,nz
   FF_LM(jx+1,jy+1,jz+1) = F_LM(jx,jy,jz)
   FF_MM(jx+1,jy+1,jz+1) = F_MM(jx,jy,jz)
   FF_QN(jx+1,jy+1,jz+1) = F_QN(jx,jy,jz)
   FF_NN(jx+1,jy+1,jz+1) = F_NN(jx,jy,jz)
end do
end do
end do

!This is a bit like witch craft but the following lines do take care
!of all the edges including the corners

FF_LM(1,:,:) = FF_LM(nx+1,:,:)
FF_LM(nx+2,:,:) = FF_LM(2,:,:)

FF_LM(:,1,:) = FF_LM(:,ny+1,:) 
FF_LM(:,ny+2,:) = FF_LM(:,2,:) 

FF_LM(:,:,1) = FF_LM(:,:,2) 
FF_LM(:,:,nz+2) = FF_LM(:,:,nz+1) 

FF_MM(1,:,:) = FF_MM(nx+1,:,:)
FF_MM(nx+2,:,:) = FF_MM(2,:,:)

FF_MM(:,1,:) = FF_MM(:,ny+1,:) 
FF_MM(:,ny+2,:) = FF_MM(:,2,:) 

FF_MM(:,:,1) = FF_MM(:,:,2) 
FF_MM(:,:,nz+2) = FF_MM(:,:,nz+1) 

FF_QN(1,:,:) = FF_QN(nx+1,:,:)
FF_QN(nx+2,:,:) = FF_QN(2,:,:)

FF_QN(:,1,:) = FF_QN(:,ny+1,:) 
FF_QN(:,ny+2,:) = FF_QN(:,2,:) 

FF_QN(:,:,1) = FF_QN(:,:,2) 
FF_QN(:,:,nz+2) = FF_QN(:,:,nz+1) 

FF_NN(1,:,:) = FF_NN(nx+1,:,:)
FF_NN(nx+2,:,:) = FF_NN(2,:,:)

FF_NN(:,1,:) = FF_NN(:,ny+1,:) 
FF_NN(:,ny+2,:) = FF_NN(:,2,:) 

FF_NN(:,:,1) = FF_NN(:,:,2) 
FF_NN(:,:,nz+2) = FF_NN(:,:,nz+1) 

! end of witch craft
!	puts u_lag and and v_lag on w nodes
u_temp = u_lag/real(dyn_count,kind=rprec)
v_temp = v_lag/real(dyn_count,kind=rprec)

do jz= 2,nz
   u_lag (:,:,jz) = 0.5_rprec*(u_temp(:,:,jz) + u_temp(:,:,jz-1))
   v_lag (:,:,jz) = 0.5_rprec*(v_temp(:,:,jz) + v_temp(:,:,jz-1))
end do
u_lag (:,:,1) = u_temp(:,:,1)
v_lag (:,:,1) = v_temp(:,:,1)
w_lag = w_lag/real(dyn_count,kind=rprec)
w_lag (:,:,1) = .25_rprec*w_lag (:,:,2)
!     computes the 3-D inverse displacement arrays that describe
!     the location where the point was at the previous step
xp = -u_lag*dt*real(dyn_count,kind=rprec)/dx    !! is u already normalized
yp = -v_lag*dt*real(dyn_count,kind=rprec)/dy   
zp = -w_lag*dt*real(dyn_count,kind=rprec)/dz

!	because first plane is on u,v,p nodes
!	this corrects for the fact that the first cell
!	in the z direction has height dz/2
!	it doubles the zp fraction if this fraction relates to the ecll beneath it
zp(:,:,2)=zp(:,:,2)+min(real(zp(jx,jy,2),kind=rprec),0._rprec)
zp(:,:,1)=zp(:,:,1)+max(real(zp(jx,jy,1),kind=rprec),0._rprec)

test_dyn_count=maxval(abs(xp))
!print*, 'test_dyn_count'
!print*, test_dyn_count
!      if ((test_dyn_count>0.7) .OR. (test_dyn_count<0.5)) then
!      jt_count = 1
!      dyn_count = int (0.6 / test_dyn_count * float(dyn_count))
!      dyn_count = max(1,dyn_count)
!      dyn_count = min(10,dyn_count)
!      print*, 'dyn_count corrected to', dyn_count
!      end if
do jx=1,nx
jjx = jx+1
do jy=1,ny
jjy = jy+1
do jz=1,nz
   jjz = jz+1
!     the are the values to add to the indices jx, jy, and jz
!     the are +1 or -1 depending on what cube should be used for interpolation
   addx = int(dsign(1._rprec,xp(jx,jy,jz)))
   addy = int(dsign(1._rprec,yp(jx,jy,jz)))
   addz = int(dsign(1._rprec,zp(jx,jy,jz)))
   
   jxaddx = jjx + addx 
   jyaddy = jjy + addy
   jzaddz = jjz + addz
!     computes the relative weights given to F_** in the cube depending on point location
   comp_x = abs(xp(jx,jy,jz))
   comp_y = abs(yp(jx,jy,jz))
   comp_z = abs(zp(jx,jy,jz)) 
     
   if ((mod(jt,500) == 0) .AND. (jt>55000)) then    
      write(80,5180) jt*dt,float(jx),float(jy),float(jz),frac_x,frac_y,frac_z
   end if
    
5180 format(120(E14.5))
  
   frac_x = 1._rprec - comp_x
   frac_y = 1._rprec - comp_y
   frac_z = 1._rprec - comp_z

!     computes interpolated F_LM

   F_LM(jx,jy,jz)=frac_x*frac_y*&
        (FF_LM(jjx,jjy,jjz)*frac_z+FF_LM(jjx,jjy,jzaddz)*comp_z)&
        + frac_x*comp_y*&
        (FF_LM(jjx,jyaddy,jjz)*frac_z+FF_LM(jjx,jyaddy,jzaddz)*comp_z)&
        + comp_x*frac_y*&
        (FF_LM(jxaddx,jjy,jjz)*frac_z+FF_LM(jxaddx,jjy,jzaddz)*comp_z)&
        + comp_x*comp_y*&
        (FF_LM(jxaddx,jyaddy,jjz)*frac_z&
        +FF_LM(jxaddx,jyaddy,jzaddz)*comp_z)

!     computes interpolated F_MM
   F_MM(jx,jy,jz)=frac_x*frac_y*&
        (FF_MM(jjx,jjy,jjz)*frac_z+FF_MM(jjx,jjy,jzaddz)*comp_z)&
        + frac_x*comp_y*&
        (FF_MM(jjx,jyaddy,jjz)*frac_z+FF_MM(jjx,jyaddy,jzaddz)*comp_z)&
        + comp_x*frac_y*&
        (FF_MM(jxaddx,jjy,jjz)*frac_z+FF_MM(jxaddx,jjy,jzaddz)*comp_z)&
        + comp_x*comp_y*&
        (FF_MM(jxaddx,jyaddy,jjz)*frac_z&
        +FF_MM(jxaddx,jyaddy,jzaddz)*comp_z)

!     computes interpolated F_QN
   F_QN(jx,jy,jz)=frac_x*frac_y*&
        (FF_QN(jjx,jjy,jjz)*frac_z+FF_QN(jjx,jjy,jzaddz)*comp_z)&
        + frac_x*comp_y*&
        (FF_QN(jjx,jyaddy,jjz)*frac_z+FF_QN(jjx,jyaddy,jzaddz)*comp_z)&
        + comp_x*frac_y*&
        (FF_QN(jxaddx,jjy,jjz)*frac_z+FF_QN(jxaddx,jjy,jzaddz)*comp_z)&
        + comp_x*comp_y*&
        (FF_QN(jxaddx,jyaddy,jjz)*frac_z&
        +FF_QN(jxaddx,jyaddy,jzaddz)*comp_z)

!     computes interpolated F_NN
   F_NN(jx,jy,jz)=frac_x*frac_y*&
        (FF_NN(jjx,jjy,jjz)*frac_z+FF_NN(jjx,jjy,jzaddz)*comp_z)&
        + frac_x*comp_y*&
        (FF_NN(jjx,jyaddy,jjz)*frac_z+FF_NN(jjx,jyaddy,jzaddz)*comp_z)&
        + comp_x*frac_y*&
        (FF_NN(jxaddx,jjy,jjz)*frac_z+FF_NN(jxaddx,jjy,jzaddz)*comp_z)&
        + comp_x*comp_y*&
        (FF_NN(jxaddx,jyaddy,jjz)*frac_z&
        +FF_NN(jxaddx,jyaddy,jzaddz)*comp_z)
end do
end do
end do

u_lag = 0._rprec
v_lag = 0._rprec
w_lag = 0._rprec
end subroutine interpolag_Sdep

! this is the w-node version
subroutine lagrange_Ssim(S11,S12,S13,S22,S23,S33,jt)
! standard dynamic model to calculate the Smagorinsky coefficient
! this is done layer-by-layer to save memory
! everything is done to be on uv-nodes
! -note: we need to calculate |S| here, too.
! stuff is done on uv-nodes
! can save more mem if necessary. mem requirement ~ n^2, not n^3
!TSuse sgsmodule,only:F_LM,F_MM,F_QN,F_NN,u_lag,v_lag,w_lag,initest
use types,only:rprec
use param,only:ld,lh,nx,ny,nz,dx,dy,dz,dt,cs_count,use_bldg
use sim_param,only:u,v,w
use sgsmodule,only:F_LM,F_MM,Beta,initest,Cs_opt2
use test_filtermodule
!TSC
use immersedbc
implicit none
!TSC
integer::px,py,lx,ly,lz,i
integer :: jx,jy,jz,jt
real(kind=rprec), dimension(ld,ny,nz+1) :: w_nod
real(kind=rprec) :: u_rms,v_rms,uw_rms,w_rms,u_av,v_av,w_av
real(kind=rprec), dimension(nx,ny) :: u_pr,v_pr,w_pr
real(kind=rprec) :: fractus

real(kind=rprec), dimension(ld,ny,nz) :: S11,S12,S13,S22,S23,S33
real(kind=rprec), dimension(ld,ny) :: L11,L12,L13,L22,L23,L33
real(kind=rprec), dimension(ld,ny) :: M11,M12,M13,M22,M23,M33
real(kind=rprec), dimension(ld,ny) :: fourbeta

real(kind=rprec), dimension(nz) :: LMvert,MMvert

real(kind=rprec), dimension(ld,ny) :: LM,MM,Tn,epsi,dumfac

real(kind=rprec), dimension(ld,ny) :: S_bar,S11_bar,S12_bar,&
     S13_bar,S22_bar,S23_bar,S33_bar,S_S11_bar, S_S12_bar,&
     S_S13_bar, S_S22_bar, S_S23_bar, S_S33_bar

real(kind=rprec), dimension(ld,ny) :: u_bar,v_bar,w_bar
!     hat is tilda, bar, hat, three filterings
real(kind=rprec), dimension(ld,ny) :: S
real(kind=rprec) :: delta,const
real(kind=rprec) :: lagran_dt,opftdelta,powcoeff
!TSC
delta = 2._rprec*(dx*dy*dz)**(1._rprec/3._rprec)
opftdelta = 1.5_rprec*delta
powcoeff = -1._rprec/8._rprec
!TS FIX THE BUG IN COMPAQ COMPILER (USE INVERSE)
!opftdelta = 2._rprec/3_rprec/delta
!powcoeff = 1._rprec/8._rprec
!TSC
if (use_bldg) then
      do i=1,n_bldg
         px=bldg_pts(1,i)
         py=bldg_pts(2,i)
         lx=bldg_pts(3,i)
         ly=bldg_pts(4,i)
         lz=bldg_pts(5,i)
         print*,'u_bar',lx,u(px+2,py-3:py+ly+3,10)
         do jx=px+1,px+lx-1
         do jy=py+1,py+ly-1
         do jz=1,1+lz-1
         u(jx,jy,jz)=.5_rprec*(u(px,jy,jz)+&
              (jx-px)*(u(px+lx,jy,jz)-u(px,jy,jz))/lx)+&
              .5_rprec*(u(jx,py,jz)+&
              (jy-py)*(u(jx,py+ly,jz)-u(jx,py,jz))/ly)
         v(jx,jy,jz)=.5_rprec*(u(px,jy,jz)+&
              (jx-px)*(u(px+lx,jy,jz)-u(px,jy,jz))/lx)+&
              .5_rprec*(u(jx,py,jz)+&
              (jy-py)*(u(jx,py+ly,jz)-u(jx,py,jz))/ly)
         w(jx,jy,jz)=.5_rprec*(u(px,jy,jz)+&
              (jx-px)*(u(px+lx,jy,jz)-u(px,jy,jz))/lx)+&
              .5_rprec*(u(jx,py,jz)+&
              (jy-py)*(u(jx,py+ly,jz)-u(jx,py,jz))/ly)
         enddo
         enddo
         enddo
         print*,'u_aft',u(px+2,py-3:py+ly+3,10)
      end do
   end if

lagran_dt=dt*real(cs_count,kind=rprec)
call interpolag_Ssim(jt)
!! (this is the time step used in the lagrangian computations)
fractus= 1._rprec/(ny*nx)

const = 2._rprec*delta**2
do jz =1,nz-1
! w_nod is the value of w interpolated on uvp nodes
   w_nod(:,:,jz) = (w(:,:,jz)+w(:,:,jz+1))/2._rprec
end do
w_nod(:,:,nz) = w(:,:,nz-1)

Beta(:,:,1) = (1._rprec-0.65_rprec*Exp(-0.85_rprec*0.5_rprec*dz/delta))
Beta(ld,:,1) = 0._rprec
Beta(ld-1,:,1) = 0._rprec
do jz= 2,nz
   Beta(:,:,jz) = (1._rprec-0.65_rprec*Exp(-0.85_rprec*(jz-1)*dz/delta))
   Beta(ld,:,jz) = 0._rprec
   Beta(ld-1,:,jz) = 0._rprec
end do

do jz = 1,nz
! using L_ij as temp storage here
!!! watch the 0.25's:  recall w = c*z^2 close to wall, so get 0.25
   if (jz == 1) then  ! put on uvp-nodes
      L11(:,:) = u(:,:,1)*u(:,:,1)  ! uv-node
      L12(:,:) = u(:,:,1)*v(:,:,1)  ! uv-node
      L13(:,:) = u(:,:,1)*0.25_rprec*w(:,:,2)  ! parabolic interp.
      L22(:,:) = v(:,:,1)*v(:,:,1)  ! uv-node
      L23(:,:) = v(:,:,jz)*0.25_rprec*w(:,:,2)  ! uv-node
      L33(:,:) = (0.25_rprec*w(:,:,2))**2  ! uv-node
      u_bar(:,:) = u(:,:,1)
      v_bar(:,:) = v(:,:,1)
      w_bar(:,:) = 0.25_rprec*w(:,:,2)
   else  ! w-nodes
      u_bar(:,:) = 0.5_rprec*(u(:,:,jz) + u(:,:,jz-1))
      v_bar(:,:) = 0.5_rprec*(v(:,:,jz) + v(:,:,jz-1))
      w_bar(:,:) = w(:,:,jz)   
      L11(:,:)=u_bar*u_bar
      L12(:,:)=u_bar*v_bar
      L13(:,:)=u_bar*w_bar
      L23(:,:)=v_bar*w_bar
      L22(:,:)=v_bar*v_bar
      L33(:,:)=w_bar*w_bar
   end if
   call test_filter(u_bar,G_test)
   call test_filter(v_bar,G_test)
   call test_filter(w_bar,G_test)
   call test_filter(L11,G_test)  ! in-place filtering
   L11 = L11 - u_bar*u_bar
   call test_filter(L12,G_test)
   L12 = L12 - u_bar*v_bar
   call test_filter(L13,G_test)
   L13 = L13 - u_bar*w_bar
   call test_filter(L22,G_test)
   L22 = L22 - v_bar*v_bar
   call test_filter(L23,G_test)
   L23 = L23 - v_bar*w_bar
   call test_filter(L33,G_test)
   L33 = L33 - w_bar*w_bar

! would be neat to have some rotating storage or something so we don't 
!   have to do this (use pointers)
! calculate |S|
   S(:,:) = sqrt(2._rprec*(S11(:,:,jz)**2 + S22(:,:,jz)**2 + &
        S33(:,:,jz)**2 + 2._rprec*(S12(:,:,jz)**2 + &
        S13(:,:,jz)**2 + S23(:,:,jz)**2)))

! S_ij already on w-nodes
   S11_bar(:,:) = S11(:,:,jz)  
   S12_bar(:,:) = S12(:,:,jz)  
   S13_bar(:,:) = S13(:,:,jz)  
   S22_bar(:,:) = S22(:,:,jz)  
   S23_bar(:,:) = S23(:,:,jz)  
   S33_bar(:,:) = S33(:,:,jz)  

   call test_filter(S11_bar,G_test)
   call test_filter(S12_bar,G_test)
   call test_filter(S13_bar,G_test)
   call test_filter(S22_bar,G_test)
   call test_filter(S23_bar,G_test)
   call test_filter(S33_bar,G_test)

   S_bar = sqrt(2._rprec*(S11_bar**2 + S22_bar**2 + S33_bar**2 + &
        2._rprec*(S12_bar**2 + S13_bar**2 + S23_bar**2)))

   S_S11_bar(:,:) = S(:,:)*S11(:,:,jz)
   S_S12_bar(:,:) = S(:,:)*S12(:,:,jz)
   S_S13_bar(:,:) = S(:,:)*S13(:,:,jz)
   S_S22_bar(:,:) = S(:,:)*S22(:,:,jz)
   S_S23_bar(:,:) = S(:,:)*S23(:,:,jz)
   S_S33_bar(:,:) = S(:,:)*S33(:,:,jz)

   call test_filter(S_S11_bar,G_test)
   call test_filter(S_S12_bar,G_test)
   call test_filter(S_S13_bar,G_test)
   call test_filter(S_S22_bar,G_test)
   call test_filter(S_S23_bar,G_test)
   call test_filter(S_S33_bar,G_test)     

! now put beta back into M_ij
   fourbeta=4._rprec*Beta(:,:,jz)
! it might be faster just to go ahead and not store M_ij--just code directly
   M11 = const*(S_S11_bar - fourbeta*S_bar*S11_bar)
   M12 = const*(S_S12_bar - fourbeta*S_bar*S12_bar)
   M13 = const*(S_S13_bar - fourbeta*S_bar*S13_bar)
   M22 = const*(S_S22_bar - fourbeta*S_bar*S22_bar)
   M23 = const*(S_S23_bar - fourbeta*S_bar*S23_bar)
   M33 = const*(S_S33_bar - fourbeta*S_bar*S33_bar)
   LM = L11*M11+L22*M22+L33*M33+2._rprec*(L12*M12+L13*M13+L23*M23)
   MM = M11**2+M22**2+M33**2+2._rprec*(M12**2+M13**2+M23**2)

! not an efficient initialization
   if (initest .ne. 2) then
      F_MM (:,:,jz) = MM
      F_LM (:,:,jz) = .025_rprec*MM
      F_MM(ld,:,jz)=1._rprec
      F_LM(ld,:,jz)=1._rprec
      F_MM(ld-1,:,jz)=1._rprec
      F_LM(ld-1,:,jz)=1._rprec
   end if
!TS FIX THE BUG IN COMPAQ COMPILER
   Tn =max(real(F_LM(:,:,jz)*F_MM(:,:,jz)),real(1E-32))
   Tn = opftdelta*(Tn**powcoeff)
   dumfac = lagran_dt/Tn
   epsi = dumfac / (1._rprec+dumfac)
!TS	print*,'bobby'
   F_LM(:,:,jz)=(epsi*LM + (1._rprec-epsi)*F_LM(:,:,jz))
   F_MM(:,:,jz)=(epsi*MM + (1._rprec-epsi)*F_MM(:,:,jz))
   F_LM(:,:,jz)= max(real(1E-32),real(F_LM(:,:,jz)))
   Cs_opt2(:,:,jz) = F_LM(:,:,jz)/F_MM(:,:,jz)
   Cs_opt2(ld,:,jz) = 0._rprec
   Cs_opt2(ld-1,:,jz) = 0._rprec
   Cs_opt2(:,:,jz)= max(real(1E-32),real(Cs_opt2(:,:,jz)))
   if (mod(jt,1000) == 0) then
      if (jz==1) then
         do jy= 1,ny
            write(90,5168) jt*dt,float(jz),(LM(jx,jy),jx=1,nx)
            write(91,5168) jt*dt,float(jz),(MM(jx,jy),jx=1,nx)
            write(92,5168) jt*dt,float(jz),(F_LM(jx,jy,jz),jx=1,nx)
            write(93,5168) jt*dt,float(jz),(F_MM(jx,jy,jz),jx=1,nx)
            write(94,5168) jt*dt,float(jz),(LM(jx,jy)/MM(jx,jy),jx=1,nx)
         end do
      end if
      if (jz==nz/2) then
         do jy= 1,ny
            write(90,5168) jt*dt,float(jz),(LM(jx,jy),jx=1,nx)
            write(91,5168) jt*dt,float(jz),(MM(jx,jy),jx=1,nx)
            write(92,5168) jt*dt,float(jz),(F_LM(jx,jy,jz),jx=1,nx)
            write(93,5168) jt*dt,float(jz),(F_MM(jx,jy,jz),jx=1,nx)
            write(94,5168) jt*dt,float(jz),(LM(jx,jy)/MM(jx,jy),jx=1,nx)
         end do
      end if
      if (jz==nz-2) then
         do jy= 1,ny
            write(90,5168) jt*dt,float(jz),(LM(jx,jy),jx=1,nx)
            write(91,5168) jt*dt,float(jz),(MM(jx,jy),jx=1,nx)
            write(92,5168) jt*dt,float(jz),(F_LM(jx,jy,jz),jx=1,nx)
            write(93,5168) jt*dt,float(jz),(F_MM(jx,jy,jz),jx=1,nx)
            write(94,5168) jt*dt,float(jz),(LM(jx,jy)/MM(jx,jy),jx=1,nx)
         end do
      end if
   end if

   if (mod(jt,200) == 0) then
      LMvert(jz) = sum(sum(LM,DIM=1),DIM=1)/ny/nx
      MMvert(jz) = sum(sum(MM,DIM=1),DIM=1)/ny/nx
   end if
! Note: these are not the rms but the standard dev
! Square these values to get the rms
   if (mod(jt,10)==0 .AND. jt>1)then
 !	all the folowing is on UVP nodes
      u_av  = sum(sum(u(:,:,jz),DIM=1),DIM=1)*fractus
      v_av  = sum(sum(v(:,:,jz),DIM=1),DIM=1)*fractus
      w_av  = sum(sum(w_nod(:,:,jz),DIM=1),DIM=1)*fractus
      do jx=1,nx
         u_pr (jx,:) = u(jx,:,jz)-u_av
         v_pr (jx,:) = v(jx,:,jz)-v_av
         w_pr (jx,:) = w_nod(jx,:,jz)-w_av
      end do
      u_rms = sqrt(sum(sum((u_pr*u_pr),DIM=1),DIM=1)*fractus)
      v_rms = sqrt(sum(sum((v_pr*v_pr),DIM=1),DIM=1)*fractus)
      w_rms = sqrt(sum(sum((w_pr*w_pr),DIM=1),DIM=1)*fractus)
      uw_rms=- sum(sum((u_pr*w_pr),DIM=1),DIM=1)*fractus
      write(96,5200) jt*dz,u_av,u_rms,v_rms,w_rms,uw_rms
   end if
! this ends the main jz=1-nz loop          
end do
initest = 2
if (mod(jt,200) == 0) then
   write(79,5130) jt*dt,sum(sum(Cs_opt2,DIM=1),DIM=1)/ny/nx
   write(62,5130) jt*dt,sum(sum(Beta,DIM=1),DIM=1)/ny/nx
   write(65,5130) jt*dt,sum(sum(F_LM,DIM=1),DIM=1)/ny/nx
   write(66,5130) jt*dt,sum(sum(F_MM,DIM=1),DIM=1)/ny/nx
   write(67,5130) jt*dt,LMvert
   write(68,5130) jt*dt,MMvert
end if
if (mod(jt,1000) == 0) then
   do jy= 1,ny
      write(78,5168) jt*dt,1.0,(Cs_opt2(jx,jy,1),jx=1,nx)
   end do
   do jy= 1,ny
      write(78,5168) jt*dt,nz/2,(Cs_opt2(jx,jy,nz/2),jx=1,nx)
   end do
   do jy= 1,ny
      write(78,5168) jt*dt,nz-2,(Cs_opt2(jx,jy,nz-2),jx=1,nx)
   end do
end if
!CTS
print*,'CS_OPT2',Cs_opt2(30-3:30+8+3,15+2,10)
!CTS
print*,'CS_OPT2',maxval(CS_opt2)
 5168     format(1400(E14.5))
 5200     format(130(E14.5))
 5130     format(2100(E14.5))
end subroutine lagrange_Ssim

module sgsmodule
use types,only:rprec
use param,only:ld,ny,nz
implicit none
private ld,ny,nz
real(kind=rprec),dimension(ld,ny,nz)::F_LM,F_MM,F_QN,F_NN,Beta
integer::dyn_count,initest
real(kind=rprec),dimension(ld,ny,nz)::u_lag,v_lag,w_lag
integer ::jt_count
real(kind=rprec),dimension(ld,ny,nz)::Cs_opt2,Cs_opt2_avg

contains

real(kind=rprec) function rtnewt(A, jz)
use types,only:rprec
integer,parameter :: jmax=100
real(kind=rprec) :: x1,x2,xacc
integer :: j, jz
real(kind=rprec) :: df,dx,f
real(kind=rprec), dimension(0:5) :: A
x1 = 0._rprec
x2 = 15._rprec  ! try to find the largest root first....hmm
xacc = 0.001_rprec ! doesn't need to be that accurate...
rtnewt = 0.5_rprec*(x1+x2)
do j=1,jmax
   f = A(0)+rtnewt*(A(1)+rtnewt*(A(2)+rtnewt*(A(3)+rtnewt*(A(4)+rtnewt*A(5)))))
   df = A(1) + rtnewt*(2._rprec*A(2) + rtnewt*(3._rprec*A(3) +&
        rtnewt*(4._rprec*A(4) + rtnewt*(5._rprec*A(5)))))
   dx=f/df
   rtnewt = rtnewt - dx
!        if ((x1-rtnewt)*(rtnewt-x2) < 0.) STOP 'rtnewt out of bounds'
   if (abs(dx) < xacc) return
end do
rtnewt = 1._rprec  ! if dont converge fast enough
write(6,*) 'using beta=1 at jz= ', jz
end function rtnewt

end module sgsmodule

subroutine dns_stress(txx,txy,txz,tyy,tyz,tzz)
! using the 'sgs' sign convention for stress, so there is a - sign
use types,only:rprec
use param,only:ld,ld_big,nx,ny,nz,z_i,u_star,nu_molec
use sim_param,only:dudx,dudy,dudz,dvdx,dvdy,dvdz,dwdx,dwdy,dwdz
implicit none
real(kind=rprec),dimension(ld,ny,nz),intent(out)::txx,txy,txz,tyy, tyz,tzz
real(kind=rprec)::S11,S12,S13,S22,S23,S33
real(kind=rprec),dimension(ld,ny)::txzp,tyzp
real(kind=rprec),dimension(nz)::zz
real(kind=rprec)::delta,nu
integer::jx,jy,jz

! non-dimensional molecular viscosity
nu=nu_molec/(z_i*u_star)
! uvp-nodes at height Delta_z/2
do jy=1,ny
do jx=1,nx
   S11=dudx(jx,jy,1)
   S12=0.5_rprec*(dudy(jx,jy,1)+dvdx(jx,jy,1))
   S22=dvdy(jx,jy,1)
   S33=dwdz(jx,jy,1)
   txx(jx,jy,1)=-2.*nu*S11
   txy(jx,jy,1)=-2.*nu*S12
   tyy(jx,jy,1)=-2.*nu*S22
   tzz(jx,jy,1)=-2.*nu*S33
end do
end do

! uvp-nodes
do jz=2,nz-2
do jy=1,ny
do jx=1,nx
   S11=dudx(jx,jy,jz)
   S12=0.5_rprec*(dudy(jx,jy,jz)+dvdx(jx,jy,jz))
   S22=dvdy(jx,jy,jz)
   S33=dwdz(jx,jy,jz)
   txx(jx,jy,jz)=-2.*nu*S11
   txy(jx,jy,jz)=-2.*nu*S12
   tyy(jx,jy,jz)=-2.*nu*S22
   tzz(jx,jy,jz)=-2.*nu*S33
end do
end do
end do

! uvp-nodes near top (don't need top, since we impose the vel. there)
do jy=1,ny
do jx=1,nx
   S11=dudx(jx,jy,nz-1)
   S12=0.5_rprec*(dudy(jx,jy,nz-1)+dvdx(jx,jy,nz-1))
   S22=dvdy(jx,jy,nz-1)
   S33=dwdz(jx,jy,nz-1)
   txx(jx,jy,nz-1)=-2._rprec*nu*S11
   txy(jx,jy,nz-1)=-2._rprec*nu*S12
   tyy(jx,jy,nz-1)=-2._rprec*nu*S22
   tzz(jx,jy,nz-1)=-2._rprec*nu*S33
end do
end do

! w-nodes
! leave the wall level alone: taken care of with wall stress
do jz=2,nz-1
do jy=1,ny
do jx=1,nx
   S13=0.5_rprec*(dudz(jx,jy,jz)+dwdx(jx,jy,jz))
   S23=0.5_rprec*(dvdz(jx,jy,jz)+dwdy(jx,jy,jz))
   txz(jx,jy,jz)=-2._rprec*nu*S13
   tyz(jx,jy,jz)=-2._rprec*nu*S23
end do
end do
end do
txz(:,:,nz)=0._rprec
tyz(:,:,nz)=0._rprec
end subroutine dns_stress

subroutine dealias1 (u,u_big)
! puts an array into the 'big' size
! doesn't dealias anything
! note: this sort of trashes u
use types,only:rprec
use param,only:ld,ld_big,nx,ny,nz,ny2,dx,dy
use fft
implicit none
integer::jz
real(kind=rprec),dimension(ld,ny,nz),intent(in):: u
real(kind=rprec),dimension(ld_big,ny2,nz),intent(inout)::u_big
real(kind=rprec)::ignore_me,const
! ahh get rid of this
real(kind=rprec),dimension(ld,ny,nz)::temp    
! be careful using u after calling this subroutine!
const=1._rprec/(nx*ny)
temp=const*u

do jz=1,nz
! still need to normalize
   call rfftwnd_f77_one_real_to_complex(forw,temp(:,:,jz),ignore_me)
! check padd syntax
   call padd(u_big(:,:,jz),temp(:,:,jz))
   call rfftwnd_f77_one_complex_to_real(back_big,u_big(:,:,jz),ignore_me)
end do
end subroutine dealias1

subroutine forcing(jt)
use types,only:rprec
use param,only:use_bldg,nx,ny,nz,DT,dns_bc,z_i,L_z,dx,dy,&
     jx_s,x_relax,face_avg,inflow
use sim_param,only:u,v,w,dpdx,dpdy,dpdz,RHSx,RHSy,RHSz,RHSx_f,RHSy_f,RHSz_f
use immersedbc
implicit none
real(kind=rprec)::force,RHS
integer,intent(in)::jt
integer::px,py,lx,ly,lz
integer :: jx,jy,jz,i,isize,jsize
real(kind=rprec),dimension(4)::y,y1,y2,y12
! this sets pressure grad's inside bldg's
if (use_bldg) then
      do i=1,n_bldg
         px=bldg_pts(1,i)
         py=bldg_pts(2,i)
         lx=bldg_pts(3,i)
         ly=bldg_pts(4,i)
         lz=bldg_pts(5,i)
         dpdx(px:px+lx,py:py+ly-1,1:1+lz)=0._rprec
         dpdy(px:px+lx-1,py:py+ly,1:1+lz)=0._rprec
         dpdz(px:px+lx-1,py:py+ly-1,1:1+lz)=0._rprec
      end do
   end if
! Finalize right hand side for explicit time advancement
   RHSx=RHSx-dpdx
   RHSy=RHSy-dpdy
   RHSz=RHSz-dpdz
! Start first step using new C as former C
! should be able to move this out of time loop
   if ((jt == 1) .and. (RHSx_f(1,1,1) == 0._rprec)) then 
      RHSx_f=RHSx
      RHSy_f=RHSy
      RHSz_f=RHSz
   end if

   force=z_i/L_z
! start calculation of body forces (fx,fy,fz)
! 'force' is the mean pressure gradient
   if (use_bldg) then
      do i=1,n_bldg
         px=bldg_pts(1,i)
         py=bldg_pts(2,i)
         lx=bldg_pts(3,i)
         ly=bldg_pts(4,i)
         lz=bldg_pts(5,i)
         do jz=1,1+lz
         do jy=py,py+ly-1
         do jx=px,px+lx
            RHS=1.5_rprec*RHSx(jx,jy,jz)-0.5_rprec*RHSx_f(jx,jy,jz)+force
            fx(jx,jy,jz) = (u_des(jx,jy,jz)-u(jx,jy,jz))/dt - RHS
!            RHS=1.5_rprec*RHSy(jx,jy,jz)-0.5_rprec*RHSy_f(jx,jy,jz)
!            fy(jx,jy,jz) = (v_des(jx,jy,jz)-v(jx,jy,jz))/dt - RHS
!            RHS=1.5_rprec*RHSz(jx,jy,jz)-0.5_rprec*RHSz_f(jx,jy,jz)
!            fz(jx,jy,jz) = (w_des(jx,jy,jz)-w(jx,jy,jz))/dt - RHS
         end do
         end do
         do jy=py,py+ly
         do jx=px,px+lx-1
            RHS=1.5_rprec*RHSy(jx,jy,jz)-0.5_rprec*RHSy_f(jx,jy,jz)
            fy(jx,jy,jz) = (v_des(jx,jy,jz)-v(jx,jy,jz))/dt - RHS
         end do
         end do
         do jy=py,py+ly
         do jx=px,px+lx
            RHS=1.5_rprec*RHSz(jx,jy,jz)-0.5_rprec*RHSz_f(jx,jy,jz)
            fz(jx,jy,jz) = (w_des(jx,jy,jz)-w(jx,jy,jz))/dt - RHS
         end do
         end do
         end do
      end do
! end calculation of forces
   endif
! this is the mean pressure gradient forcing
   do jz=1,nz-1
   do jy=1,ny
   do jx=1,nx
      RHS=1.5_rprec*RHSx(jx,jy,jz)-0.5_rprec*RHSx_f(jx,jy,jz)+force
      u(jx,jy,jz) = (u(jx,jy,jz) + dt*(RHS+fx(jx,jy,jz)))
      RHS=1.5_rprec*RHSy(jx,jy,jz)-0.5_rprec*RHSy_f(jx,jy,jz)
      v(jx,jy,jz) = (v(jx,jy,jz) + dt*(RHS+fy(jx,jy,jz)))
   end do
   end do
   end do
!TS ADD UNIFORM FLOW
   if(inflow)then
   do jy=0,x_relax-1
      jx=jx_s-jy
      u(jx,1:ny,1:nz-1)=face_avg+&
      (u(jx,1:ny,1:nz-1)-face_avg)*real(jy,kind=rprec)/real(x_relax,kind=rprec)
      v(jx,1:ny,1:nz-1)=(v(jx,1:ny,1:nz-1)-0._rprec)*&
           real(jy,kind=rprec)/real(x_relax,kind=rprec)
      w(jx,1:ny,1:nz)=(w(jx,1:ny,1:nz)-0._rprec)*&
           real(jy,kind=rprec)/real(x_relax,kind=rprec)
   end do
   endif

! no-stress top
   u(:,:,nz)=u(:,:,nz-1)
! no-stress top
   v(:,:,nz)=v(:,:,nz-1)
   if (dns_bc) then
      do jz=2,nz-1
      do jy=1,ny
      do jx=1,nx
         RHS=1.5_rprec*RHSz(jx,jy,jz)-0.5_rprec*RHSz_f(jx,jy,jz)
         w(jx,jy,jz) = (w(jx,jy,jz) + dt*(RHS+fz(jx,jy,jz)))
      end do
      end do
      end do
      w(:,:,1)=0._rprec
      w(:,:,nz)=0._rprec
   else
      call stepbl_w(w, RHSz, RHSz_f, fz)              
   end if
 end subroutine forcing

subroutine divstress_w(divt, tx, ty, tz)
use types,only:rprec
use param,only:ld,nx,ny,nz
implicit none
real(kind=rprec),dimension(ld,ny,nz),intent(out)::divt
real(kind=rprec),dimension(ld,ny,nz),intent(in)::tx,ty,tz
real(kind=rprec),dimension(ld,ny,nz)::dtxdx,dtydy, dtzdz
integer::jx,jy,jz

! compute stress gradients      
call ddx(dtxdx, tx)
call ddy(dtydy, ty)
call ddz_uv(dtzdz, tz)
! note ddz_uv does not return values for k=1 level.
do jz=2,nz
do jy=1,ny
do jx=1,nx              
   divt(jx,jy,jz)=dtxdx(jx,jy,jz)+dtydy(jx,jy,jz)+dtzdz(jx,jy,jz)
end do
end do
end do
! at wall we have to assume that dz(tzz)=0.0.  Any better ideas?
do jy=1,ny
do jx=1,nx
! in old version, it looks like some people tried some stuff with dwdz here
! but they were zeroed out, so they were left out of this version
   divt(jx,jy,1)=dtxdx(jx,jy,1)+dtydy(jx,jy,1)
end do
end do
end subroutine divstress_w

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! fftw 2.1.X version
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
module fft
use types,only:rprec
use param,only:lh,ny
implicit none

!public
private
public :: kx,ky,k2,eye,forw,back,forw_big,back_big,init_fft
public ::  FFTW_FORWARD, FFTW_BACKWARD,&
     FFTW_REAL_TO_COMPLEX,FFTW_COMPLEX_TO_REAL,FFTW_ESTIMATE,FFTW_MEASURE,&
     FFTW_OUT_OF_PLACE,FFTW_IN_PLACE,FFTW_USE_WISDOM
! plans
integer*8::forw,back,forw_big,back_big
real(kind=rprec),dimension(lh,ny)::kx,ky,k2
complex(kind=rprec), parameter :: eye = (0._rprec,1._rprec)
! fftw 2.1.3 stuff
integer, parameter :: FFTW_FORWARD=-1, FFTW_BACKWARD=1
integer, parameter :: FFTW_REAL_TO_COMPLEX=-1,FFTW_COMPLEX_TO_REAL=1
integer, parameter :: FFTW_ESTIMATE=0,FFTW_MEASURE=1
integer, parameter :: FFTW_OUT_OF_PLACE=0
integer, parameter :: FFTW_IN_PLACE=8,FFTW_USE_WISDOM=16
integer, parameter :: FFTW_THREADSAFE=128
integer, parameter :: FFTW_TRANSPOSED_ORDER=1, FFTW_NORMAL_ORDER=0
integer, parameter :: FFTW_SCRAMBLED_INPUT=8192
integer, parameter :: FFTW_SCRAMBLED_OUTPUT=16384

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
contains
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine init_fft()
use param,only:nx,ny,nx2,ny2
implicit none
! formulate the fft plans--may want to use FFTW_USE_WISDOM
call rfftw2d_f77_create_plan(forw,nx,ny,FFTW_REAL_TO_COMPLEX,&
     FFTW_MEASURE+FFTW_IN_PLACE)
call rfftw2d_f77_create_plan(back,nx,ny,FFTW_COMPLEX_TO_REAL,&
     FFTW_MEASURE+FFTW_IN_PLACE)
call rfftw2d_f77_create_plan(forw_big,nx2,ny2,&
     FFTW_REAL_TO_COMPLEX,FFTW_MEASURE+FFTW_IN_PLACE)
call rfftw2d_f77_create_plan(back_big,nx2,ny2,&
     FFTW_COMPLEX_TO_REAL,FFTW_MEASURE+FFTW_IN_PLACE)

call init_wavenumber()

end subroutine init_fft

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine init_wavenumber()
use types,only:rprec
use param,only:lh,nx,ny,L_x,L_y,pi
implicit none
integer :: jx,jy

do jx=1,lh-1
   kx(jx,:) = real(jx-1,kind=rprec)
end do

do jy=1,ny
   ky(:,jy) = real(modulo(jy - 1 + ny/2,ny) - ny/2,kind=rprec)
end do

! Nyquist: makes doing derivatives easier
      kx(lh,:)=0._rprec
      ky(lh,:)=0._rprec
      kx(:,ny/2+1)=0._rprec
      ky(:,ny/2+1)=0._rprec

! for the aspect ratio change
      kx=2._rprec*pi/L_x*kx
      ky=2._rprec*pi/L_y*ky

! magnitude squared: will have 0's around the edge
      k2 = kx*kx + ky*ky
end subroutine init_wavenumber

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

end module fft

      subroutine wallstress2(txz,tyz,u,v,zo,u_avg,psi_m)

      include 'dimen.h'
      integer jx,jy
      real*8 txz(ld,ny,nz),tyz(ld,ny,nz),u(ld,ny,nz),v(ld,ny,nz),
     &  zo(nx,ny),u_avg(nx,ny),denom(nx,ny),ustar(nx,ny),psi_m(nx,ny),
     &  u_aver(nx,ny),u1(ld,ny),v1(ld,ny)
     

       double precision, dimension(lh,ny) :: G_test, G_test_test
       common /test_filters/ G_test, G_test_test

       real*8 const
 
        u1=u(:,:,1)
        v1=v(:,:,1)

        call test_filter(u1,G_test)
        call test_filter(v1,G_test)

        denom=dlog(0.5*dz/zo)-psi_m
	do jx=1,nx
	do jy=1,ny
 	u_avg(jx,jy)=sqrt(u1(jx,jy)**2+v1(jx,jy)**2)
	end do
	end do
	


        ustar=u_avg*vonK/denom

        do jy=1,ny
         do jx=1,nx
          const=-(ustar(jx,jy)**2)/u_avg(jx,jy)
          txz(jx,jy,1)=const*u1(jx,jy)
          tyz(jx,jy,1)=const*v1(jx,jy)
         end do
        end do
     
      return    
      end

module param
use types,only:rprec
implicit none
private rprec
public
integer,parameter:: nx=64,ny=32,nz=64
integer,parameter:: nx2=3*nx/2,ny2=3*ny/2
real(kind=rprec),parameter::L_x=2._rprec,L_y=1._rprec
real(kind=rprec),parameter::z_i=1000._rprec,L_z=1000._rprec
real(kind=rprec),parameter::pi=3.1415926535897932384626433
! set the aspect ratio of the box, already nondimensional
real(kind=rprec),parameter::dz=L_z/z_i/(nz-1)
real(kind=rprec),parameter::dx=L_x/nx,dy=L_y/ny
integer,parameter::nsteps=40
real(kind=rprec),parameter::dt=.0001_rprec
real(kind=rprec),parameter::u_star=.45_rprec,Pr=.4_rprec
real(kind=rprec),parameter::vonk=.4_rprec,wt_s=.06_rprec
integer,parameter::lh=nx/2+1,ld=2*lh,lh_big=nx2/2+1,ld_big=2*lh_big
integer,parameter::c_count=20,p_count=1000,cs_count=5
logical,parameter::output=.true.
logical,parameter::initu=.false.,initsc=.false.
! nu_molec is dimensional m^2/s
real(kind=rprec),parameter::nu_molec=.01_rprec,z_plus_lim=5._rprec
logical,parameter::interp=.false.
logical,parameter::use_bldg=.FALSE.
logical,parameter::molec=.false.,sgs=.true.,dns_bc=.false.
! S_FLAG=1 for Theta and q, =0 for no scalars
logical,parameter::S_FLAG=.false.
!Model type: 1->Smagorinsky; 2->Dynamic; 3->Scale dependent
!            4->Lagrangian scale-sim   5-> Lagragian scale-dep
!Models type: 1->static prandtl, 2->Dynamic
!Cs is the Smagorinsky Constant
!Co and nnn are used in the mason model for smagorisky coeff
integer,parameter::model=4,models=1,nnn=2
real(kind=rprec),parameter::Co=0.16_rprec
real(kind=rprec),parameter::cs=0.2_rprec
!Test filter type: 1->cut off 2->Gaussian 3->Top-hat
integer,parameter::ifilter=1
! ubc: upper boundary condition: ubc=0 stress free lid, ubc=1 sponge
! lbc=0: prescribed surface temperature, lbc=1 prescribed surface flux 
! (0.06 Km/s)
integer,parameter::ubc=0,lbc=1
!TS ADD uniform inflow
!TS jx_s:bufferzone starting point,x_relax:buffer zone length
logical,parameter::inflow=.FALSE.
integer,parameter::jx_s=8,x_relax=4
real(kind=rprec),parameter::face_avg=20._rprec
end module param

subroutine padd (u_big,u)
! puts arrays into larger, zero-padded arrays 
! automatically zeroes the oddballs
use types,only:rprec
use param,only:lh,lh_big,nx,ny,ny2
implicit none
integer::jx,jy
! note we're calling with 2D arrays
complex(kind=rprec),dimension(lh,ny),intent(in)::u
complex(kind=rprec),dimension(lh_big,ny2),intent(out)::u_big
! make sure the big array is zeroed!
u_big=0._rprec
! note: the loops are split in an attempt to maintain locality
! test it                   !
do jy=1,ny/2
do jx=1,nx/2
! skip the Nyquist frequency since it should be zero anyway
   u_big(jx,jy)=u(jx,jy)
end do
end do
do jy=1,ny/2-1
do jx=1,nx/2
   u_big(jx,jy+ny2-ny/2+1)=u(jx,jy+ny/2+1)
end do
end do
end subroutine padd

      subroutine wavenumber()
use fft
      implicit none
      include 'dimen.h'
      integer jx,jy

      do jx=1,lh-1
        kx(jx,:) = dble(jx-1)
      end do

      do jy=1,ny
        ky(:,jy) = dble(modulo(jy - 1 + ny/2,ny) - ny/2)
      end do

! Nyquist: makes doing derivatives easier
      kx(lh,:)=0.
      ky(lh,:)=0.
      kx(:,ny/2+1)=0.
      ky(:,ny/2+1)=0.

! for the aspect ratio change
      kx=two_pi_over_Lx*kx   
      ky=two_pi_over_Ly*ky

! magnitude squared: will have 0's around the edge
      k2 = kx*kx + ky*ky

      return
      end

! this is the w-node version
subroutine interpolag_Ssim(jt)
! This subroutine computes the values of F_LM and F_MM 
! at positions (x-u*dt) for use in the subroutine lagrangian
!use sgsmodule,only:u_lag,v_lag,w_lag
use types,only:rprec
use param,only:ld,nx,ny,nz,dx,dy,dz,dt,cs_count
use sgsmodule
implicit none
integer :: jx, jy, jz ,jt
integer :: jjx, jjy, jjz
real(kind=rprec), dimension(ld,ny,nz) :: xp, yp, zp
real(kind=rprec) :: frac_x,frac_y,frac_z
real(kind=rprec) :: comp_x,comp_y,comp_z
real(kind=rprec), dimension(nx+2,ny+2,nz+2) :: FF_LM,FF_MM
real(kind=rprec) :: lagran_dt, consta,test_cs_count
integer :: addx, addy, addz
integer :: jxaddx, jyaddy, jzaddz
real(kind=rprec), dimension(ld,ny,nz) :: u_temp, v_temp
!     creates dummy arrays FF_LM and FF_MM to use in the subroutine
!$omp parallel do default(shared) private(jx,jy,jz)	
do jx=1,nx
do jy=1,ny
do jz=1,nz
   FF_LM(jx+1,jy+1,jz+1) = F_LM(jx,jy,jz)
   FF_MM(jx+1,jy+1,jz+1) = F_MM(jx,jy,jz)
end do
end do
end do
!$omp end parallel do

!This is a bit like witch craft but the following lines do take care
!of all the edges including the corners
FF_LM(1,:,:) = FF_LM(nx+1,:,:)
FF_LM(nx+2,:,:) = FF_LM(2,:,:)

FF_LM(:,1,:) = FF_LM(:,ny+1,:) 
FF_LM(:,ny+2,:) = FF_LM(:,2,:) 

FF_LM(:,:,1) = FF_LM(:,:,2) 
FF_LM(:,:,nz+2) = FF_LM(:,:,nz+1) 

FF_MM(1,:,:) = FF_MM(nx+1,:,:)
FF_MM(nx+2,:,:) = FF_MM(2,:,:)

FF_MM(:,1,:) = FF_MM(:,ny+1,:) 
FF_MM(:,ny+2,:) = FF_MM(:,2,:) 

FF_MM(:,:,1) = FF_MM(:,:,2) 
FF_MM(:,:,nz+2) = FF_MM(:,:,nz+1) 

! end of witch craft
!	puts u_lag and and v_lag on w nodes
u_temp = u_lag/real(cs_count,kind=rprec)
v_temp = v_lag/real(cs_count,kind=rprec)

!$omp parallel do default(shared) private(jz)	
do jz= 2,nz
   u_lag (:,:,jz) = 0.5_rprec*(u_temp(:,:,jz) + u_temp(:,:,jz-1))
   v_lag (:,:,jz) = 0.5_rprec*(v_temp(:,:,jz) + v_temp(:,:,jz-1))
end do
!$omp end parallel do
u_lag (:,:,1) = u_temp(:,:,1)
v_lag (:,:,1) = v_temp(:,:,1)
w_lag = w_lag/real(cs_count,kind=rprec)
w_lag (:,:,1) = .25_rprec*w_lag (:,:,2)

!     computes the 3-D inverse displacement arrays that describe
!     the location where the point was at the previous step
xp = -u_lag*dt*real(cs_count,kind=rprec)/dx    !! is u already normalized
yp = -v_lag*dt*real(cs_count,kind=rprec)/dy   
zp = -w_lag*dt*real(cs_count,kind=rprec)/dz

!	because first plane is on u,v,p nodes
!	this corrects for the fact that the first cell
!	in the z direction has height dz/2
!	it doubles the zp fraction if this fraction relates to the cell beneath it
do jx= 1,nx
do jy=1,ny
   zp(jx,jy,2) = zp(jx,jy,2) + dmin1(zp(jx,jy,2),0._rprec)
   zp(jx,jy,1) = zp(jy,jy,1) + dmax1(zp(jx,jy,1),0._rprec)
end do
end do

test_cs_count=maxval(abs(xp))
print*, 'Lagrangian CFL condition'
print*, test_cs_count
!      if ((test_dyn_count>0.7) .OR. (test_dyn_count<0.5)) then
!      jt_count = 1
!      dyn_count = int (0.6 / test_dyn_count * float(dyn_count))
!      dyn_count = max(1,dyn_count)
!      dyn_count = min(10,dyn_count)
!      print*, 'dyn_count corrected to', dyn_count
!      end if

do jx=1,nx
 jjx = jx+1
 do jy=1,ny
  jjy = jy+1
  do jz=1,nz
     jjz = jz+1
     !the are the values to add to the indices jx, jy, and jz
!     the are +1 or -1 depending on what cube should be used for interpolation
     addx = int(sign(1._rprec,xp(jx,jy,jz)))
     addy = int(sign(1._rprec,yp(jx,jy,jz)))
     addz = int(sign(1._rprec,zp(jx,jy,jz)))
     jxaddx = jjx + addx 
     jyaddy = jjy + addy
     jzaddz = jjz + addz

!     computes the relative weights given to F_** in the cube depending on point location
     comp_x = abs(xp(jx,jy,jz))
     comp_y = abs(yp(jx,jy,jz))
     comp_z = abs(zp(jx,jy,jz)) 
     
     if ((mod(jt,1000) == 0) .AND. (jt>55000)) then    
!TS        write(80,5180)jt*dt,float(jx),float(jy),float(jz),real(frac_x),real*frac_y),real(frac_z)
        write(80,*)jt*dt,jx,jy,jz,real(frac_x),real(frac_y),real(frac_z)
     end if
5180     format(120(E14.5))
  
     frac_x = 1._rprec - comp_x
     frac_y = 1._rprec - comp_y
     frac_z = 1._rprec - comp_z
         
!     computes interpoated F_LM

     F_LM(jx,jy,jz)=frac_x*frac_y*&
          (FF_LM(jjx,jjy,jjz)*frac_z+FF_LM(jjx,jjy,jzaddz)*comp_z)&
          + frac_x*comp_y*&
          (FF_LM(jjx,jyaddy,jjz)*frac_z+FF_LM(jjx,jyaddy,jzaddz)*comp_z)&
          + comp_x*frac_y*&
          (FF_LM(jxaddx,jjy,jjz)*frac_z+FF_LM(jxaddx,jjy,jzaddz)*comp_z)&
          + comp_x*comp_y*&
          (FF_LM(jxaddx,jyaddy,jjz)*frac_z&
          +FF_LM(jxaddx,jyaddy,jzaddz)*comp_z)

!     computes interpoated F_MM
     F_MM(jx,jy,jz)=&
          frac_x*frac_y*&
          (FF_MM(jjx,jjy,jjz)*frac_z+FF_MM(jjx,jjy,jzaddz)*comp_z)&
          + frac_x*comp_y*&
          (FF_MM(jjx,jyaddy,jjz)*frac_z+FF_MM(jjx,jyaddy,jzaddz)*comp_z)&
          + comp_x*frac_y*&
          (FF_MM(jxaddx,jjy,jjz)*frac_z+FF_MM(jxaddx,jjy,jzaddz)*comp_z)&
          + comp_x*comp_y*&
          (FF_MM(jxaddx,jyaddy,jjz)*frac_z&
          +FF_MM(jxaddx,jyaddy,jzaddz)*comp_z)
  end do
 end do
end do

u_lag = 0._rprec
v_lag = 0._rprec
w_lag = 0._rprec
end subroutine interpolag_Ssim

subroutine ic_dns()
use types,only:rprec
!only:ld,nx,ny,nz,z_i,wt_s,num_patch,zo1,zo2,dz,vonk,s_flag,u_star,theta_s1
use param
use sim_param,only:u,v,w
implicit none
real(kind=rprec),dimension(nz)::ubar
real(kind=rprec)::rms,temp,ran3
integer::jx,jy,jz,seed,z

seed=-112
! calculate height of first uvp point in wall units
! lets do a laminar case (?)
do jz=1,nz
   z=(real(jz)-.5_rprec)*dz ! non-dimensional
   ubar(jz)=(u_star*z_i/nu_molec)*z*(1._rprec-.5_rprec*z) ! non-dimensional
!         ubar(jz)=0.
end do
do jz=1,nz
   print *,'jz, ubar:',jz,ubar(jz)
end do
! rms=0.0001 seems to work in some cases
! the "default" rms of a unif variable is 0.289
rms=0.2_rprec
do jz=1,nz
do jy=1,ny
do jx=1,nx
   u(jx,jy,jz)=ubar(jz)+(rms/.289_rprec)*(ran3(seed)-.5_rprec)/u_star
   v(jx,jy,jz)=0._rprec+(rms/.289_rprec)*(ran3(seed)-.5_rprec)/u_star
   w(jx,jy,jz)=0._rprec+(rms/.289_rprec)*(ran3(seed)-.5_rprec)/u_star
end do
end do
end do

! make sure w-mean is 0
temp=0._rprec
do jz=1,nz
do jy=1,ny
do jx=1,nx
   temp=temp+w(jx,jy,jz)
end do
end do
end do
temp=temp/(nx*ny*nz)

do jz=1,nz
do jy=1,ny
do jx=1,nx
   w(jx,jy,jz)=w(jx,jy,jz)-temp
end do
end do
end do
      
w(:,:,1)=0._rprec
w(:,:,nz)=0._rprec
u(:,:,nz)=u(:,:,nz-1)
v(:,:,nz)=v(:,:,nz-1)
end subroutine ic_dns

subroutine initial()
use types,only:rprec
use param,only:initu,interp,dns_bc,use_bldg,nz
use sim_param,only:path,u,v,w,RHSx,RHSy,RHSz
use sgsmodule,only:Cs_opt2_avg
use immersedbc,only:fx,fy,fz,u_des,v_des,w_des,n_bldg,bldg_pts
use io,only:mean_u,mean_u2,mean_v,mean_v2,mean_dudx
implicit none
integer::i
Cs_opt2_avg=0._rprec
fx=0._rprec;fy=0._rprec;fz=0._rprec
u_des=0._rprec;v_des=0._rprec;w_des=0._rprec
mean_u=0._rprec;mean_u2=0._rprec;mean_v=0._rprec;mean_v2=0._rprec;mean_dudx=0._rprec

open(51,file=path//'output/check_ke.out')
open(121,file=path//'vel.out',form='unformatted')

if (initu) then
   if (interp) then
      print*, 'Using interpolated field'
      open (31,file=path//'vel_new.out',form='unformatted')
      read(31) u,v,w
      close(31)
   else
      print *,'Reading initial velocity field from file'
      read(121) u,v,w,RHSx,RHSy,RHSz
   end if
else
   if (dns_bc) then
      print*, 'Creating initial velocity field with DNS BCs'
      call ic_dns()
   else
      print*, 'Creating initial velocity field'
      call ic()
   end if
end if

! bldg stuff
if (use_bldg) then
   open(1,file=path//'bldg.dat')
   read(1,*) n_bldg
   allocate(bldg_pts(5,n_bldg))
   do i=1,n_bldg
      read(1,*) bldg_pts(1:5,i)
      if(bldg_pts(5,i).ge.nz)then
         write(*,*)"lz should be less than nz"
         stop
      end if
   end do
end if
end subroutine initial

subroutine tridag(a,b,c,r,u,n)
! sc: modified for complex!
use types,only:rprec
implicit none
integer,intent(in)::n
real(kind=rprec),dimension(n),intent(in)::a,b,c
complex(kind=rprec),dimension(n),intent(in)::r
complex(kind=rprec),dimension(n),intent(out)::u
integer::j
real(kind=rprec)::bet
integer,parameter::NMAX=500
real(kind=rprec),dimension(NMAX)::gam

if (b(1).eq.0._rprec)	print*,'tridag: rewrite equations'
bet=b(1)
u(1)=r(1)/bet
do j=2,n
   gam(j)=c(j-1)/bet
   bet=b(j)-a(j)*gam(j)
   if(bet.eq.0._rprec) then
      print *, 'tridag failed at k=',j  
      print *,'a, b, c, gam, and bet=',a(j),b(j),c(j),gam(j),bet
   end if
   u(j)=(r(j)-a(j)*u(j-1))/bet
enddo
do j=n-1,1,-1
   u(j)=u(j)-gam(j+1)*u(j+1)
enddo
END subroutine tridag
!  (C) Copr. 1986-92 Numerical Recipes Software ]2#"0>Ya%.

subroutine wallstress(txz,tyz)
! For use with staggered grid LES
! JDA, 23 Jan 96
! zo is nondimensionalized, zo1 not!
use types,only:rprec
use param,only:dz,ld,lh,nx,ny,nz,vonk
use sim_param,only:u,v
use bottombc,only:zo,psi_m
use test_filtermodule
implicit none
integer::jx,jy
real(kind=rprec),dimension(ld,ny,nz),intent(out)::txz,tyz
real(kind=rprec),dimension(nx,ny)::ustar,u_avg,u_aver,denom
real(kind=rprec),dimension(ld,ny)::u1,v1
real(kind=rprec)::const

!TS Remove the following line when obukhov.f is used
psi_m=0._rprec

u1=u(:,:,1)
v1=v(:,:,1)
call test_filter(u1,G_test)
call test_filter(v1,G_test)
denom=log(0.5_rprec*dz/zo)-psi_m
   u_avg=sqrt(u1(1:nx,1:ny)**2+v1(1:nx,1:ny)**2)
ustar=u_avg*vonk/denom

do jy=1,ny
do jx=1,nx
   const=-(ustar(jx,jy)**2) /u_avg(jx,jy)
   txz(jx,jy,1)=const *u1(jx,jy)
   tyz(jx,jy,1)=const *v1(jx,jy)
end do
end do
end subroutine wallstress

#!/bin/sh
# appends module dependencies to the end of a partially completed makefile
# call this from makefile with argument "$(SRCS)"
Makefile=Makefile

SRCS=${1}
#echo "SRCS=${SRCS}"

# remove old deps, if any
begin=$(egrep -n "^#deps" ${Makefile} | awk -F : '{ print $1 }')
end=$(egrep -n "^#end deps" ${Makefile} | awk -F : '{ print $1 }')
#echo begin=${begin}
#echo end=${end}
# This could use some refinement
if [ "${begin}" ]; then
  if [ "${end}" ]; then
    if [ ${begin} -lt ${end} ]; then
      new=$(sed "${begin}","${end}"d ${Makefile})
      echo "${new}" > ${Makefile} 
    fi
  fi
fi

echo "Building dependency list..."

# add line to Makefile showing where deps start
echo "" >> ${Makefile}
echo "#deps" >> ${Makefile}

# scan each source file for use statements and store module names
for file in ${SRCS}; do
#  echo "file=${file}"
  # look for use statements & isolate the module name & elim duplicates
  # **need to allow for upper case here 
  MODS=$(awk '/^[:blank:]*use +/ { print $2 }' ${file} | \
    sed 's/,/ /g' | sort | uniq)
  # just to reformat
  MODS=$(echo ${MODS})
#  echo "MODS=${MODS}"
  # At this point MODS contains the modules that $file depends on directly.
  # Not sure if we need to include indirect dependcies.  I think make can
  # do indirect part itself.

  # scan each source file for that module definition
  dep_list=""
  for module in ${MODS}; do
    for src_file in ${SRCS}; do
#      echo "about to get match"
      # egrep may be best here, just an experiment
#      echo "module=${module}"
#      echo "src_file=${src_file}"
# can't get this to do what I want using ${module} in the awk regex
      name=$(awk '/^[:blank:]*module +/ { print $2 }' ${src_file}) 
#      echo "name=${name}"
      # do we need to worry about whitespace here?
      if [ "${name}" = "${module}" ]; then
        # the ${file} directly depends on the ${src_file}
        # need to replace the .f90 with .o here --use sed
        obj_file=$(echo ${src_file} | sed 's/.f90$/.o/')
        dep_list="${dep_list} ${obj_file}"
#        echo "dep_list=${dep_list}"
      fi
    done
  done
  # remove extra whitespace
  dep_list=$(echo ${dep_list} | sed 's/^[:blank:]+//g' | \
    sed 's/[:blank:]+/ /g')
  #echo "dep_list=${dep_list}"

  # now add a line to Makefile with the deps
  if [ "${dep_list}" != "" ]; then
    o_file=$(echo ${file} | sed 's/.f90$/.o/')
    line=${o_file}" : "${dep_list}
    echo "${line}"
    echo "${line}" >> ${Makefile}
  fi
done

# echo a line to indicate end of deps
echo "#end deps" >> ${Makefile}

echo "Dependency list added to ${Makefile}"
